/*!-----------------------------------------------------------
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Version: 0.42.0-dev-20230823(38e1e3d097f84e336c311d071a9ffb5191d4ffd1)
 * Released under the MIT license
 * https://github.com/microsoft/vscode/blob/main/LICENSE.txt
 *-----------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/errors","vs/base/common/strings","vs/editor/common/core/offsetRange","vs/base/common/event","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/editor/common/core/lineRange","vs/base/common/platform","vs/base/common/uri","vs/nls","vs/base/common/arrays","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/base/common/cache","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cancellation","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/smartLinesDiffComputer","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],re=function(O){for(var n=[],E=0,M=O.length;E<M;E++)n[E]=ie[O[E]];return n};const Ne=this,Ee=typeof global=="object"?global:{};var ge;(function(O){O.global=Ne;class n{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=n._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof O.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}O.Environment=n})(ge||(ge={}));var ge;(function(O){class n{constructor(u,d,g){this.type=u,this.detail=d,this.timestamp=g}}O.LoaderEvent=n;class E{constructor(u){this._events=[new n(1,"",u)]}record(u,d){this._events.push(new n(u,d,O.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}O.LoaderEventRecorder=E;class M{record(u,d){}getEvents(){return[]}}M.INSTANCE=new M,O.NullLoaderEventRecorder=M})(ge||(ge={}));var ge;(function(O){class n{static fileUriToFilePath(M,i){if(i=decodeURI(i).replace(/%23/g,"#"),M){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(M,i){return M.length>=i.length&&M.substr(0,i.length)===i}static endsWith(M,i){return M.length>=i.length&&M.substr(M.length-i.length)===i}static containsQueryString(M){return/^[^\#]*\?/gi.test(M)}static isAbsolutePath(M){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(M)}static forEachProperty(M,i){if(M){let u;for(u in M)M.hasOwnProperty(u)&&i(u,M[u])}}static isEmpty(M){let i=!0;return n.forEachProperty(M,()=>{i=!1}),i}static recursiveClone(M){if(!M||typeof M!="object"||M instanceof RegExp||!Array.isArray(M)&&Object.getPrototypeOf(M)!==Object.prototype)return M;let i=Array.isArray(M)?[]:{};return n.forEachProperty(M,(u,d)=>{d&&typeof d=="object"?i[u]=n.recursiveClone(d):i[u]=d}),i}static generateAnonymousModule(){return"===anonymous"+n.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(M){return n.startsWith(M,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=O.global.performance&&typeof O.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?O.global.performance.now():Date.now()}}n.NEXT_ANONYMOUS_ID=1,n.PERFORMANCE_NOW_PROBED=!1,n.HAS_PERFORMANCE_NOW=!1,O.Utilities=n})(ge||(ge={}));var ge;(function(O){function n(i){if(i instanceof Error)return i;const u=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(u.stack=i.stack),u}O.ensureError=n;class E{static validateConfigurationOptions(u){function d(g){if(g.phase==="loading"){console.error('Loading "'+g.moduleId+'" failed'),console.error(g),console.error("Here are the modules that depend on it:"),console.error(g.neededBy);return}if(g.phase==="factory"){console.error('The factory function of "'+g.moduleId+'" has thrown an exception'),console.error(g),console.error("Here are the modules that depend on it:"),console.error(g.neededBy);return}}if(u=u||{},typeof u.baseUrl!="string"&&(u.baseUrl=""),typeof u.isBuild!="boolean"&&(u.isBuild=!1),typeof u.paths!="object"&&(u.paths={}),typeof u.config!="object"&&(u.config={}),typeof u.catchError>"u"&&(u.catchError=!1),typeof u.recordStats>"u"&&(u.recordStats=!1),typeof u.urlArgs!="string"&&(u.urlArgs=""),typeof u.onError!="function"&&(u.onError=d),Array.isArray(u.ignoreDuplicateModules)||(u.ignoreDuplicateModules=[]),u.baseUrl.length>0&&(O.Utilities.endsWith(u.baseUrl,"/")||(u.baseUrl+="/")),typeof u.cspNonce!="string"&&(u.cspNonce=""),typeof u.preferScriptTags>"u"&&(u.preferScriptTags=!1),u.nodeCachedData&&typeof u.nodeCachedData=="object"&&(typeof u.nodeCachedData.seed!="string"&&(u.nodeCachedData.seed="seed"),(typeof u.nodeCachedData.writeDelay!="number"||u.nodeCachedData.writeDelay<0)&&(u.nodeCachedData.writeDelay=1e3*7),!u.nodeCachedData.path||typeof u.nodeCachedData.path!="string")){const g=n(new Error("INVALID cached data configuration, 'path' MUST be set"));g.phase="configuration",u.onError(g),u.nodeCachedData=void 0}return u}static mergeConfigurationOptions(u=null,d=null){let g=O.Utilities.recursiveClone(d||{});return O.Utilities.forEachProperty(u,(a,s)=>{a==="ignoreDuplicateModules"&&typeof g.ignoreDuplicateModules<"u"?g.ignoreDuplicateModules=g.ignoreDuplicateModules.concat(s):a==="paths"&&typeof g.paths<"u"?O.Utilities.forEachProperty(s,(v,e)=>g.paths[v]=e):a==="config"&&typeof g.config<"u"?O.Utilities.forEachProperty(s,(v,e)=>g.config[v]=e):g[a]=O.Utilities.recursiveClone(s)}),E.validateConfigurationOptions(g)}}O.ConfigurationOptionsUtil=E;class M{constructor(u,d){if(this._env=u,this.options=E.mergeConfigurationOptions(d),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let g=this.options.nodeRequire.main.filename,a=Math.max(g.lastIndexOf("/"),g.lastIndexOf("\\"));this.options.baseUrl=g.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let u=0;u<this.options.ignoreDuplicateModules.length;u++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[u]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],O.Utilities.forEachProperty(this.options.paths,(u,d)=>{Array.isArray(d)?this.sortedPathsRules.push({from:u,to:d}):this.sortedPathsRules.push({from:u,to:[d]})}),this.sortedPathsRules.sort((u,d)=>d.from.length-u.from.length)}cloneAndMerge(u){return new M(this._env,E.mergeConfigurationOptions(u,this.options))}getOptionsLiteral(){return this.options}_applyPaths(u){let d;for(let g=0,a=this.sortedPathsRules.length;g<a;g++)if(d=this.sortedPathsRules[g],O.Utilities.startsWith(u,d.from)){let s=[];for(let v=0,e=d.to.length;v<e;v++)s.push(d.to[v]+u.substr(d.from.length));return s}return[u]}_addUrlArgsToUrl(u){return O.Utilities.containsQueryString(u)?u+"&"+this.options.urlArgs:u+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(u){return this.options.urlArgs?this._addUrlArgsToUrl(u):u}_addUrlArgsIfNecessaryToUrls(u){if(this.options.urlArgs)for(let d=0,g=u.length;d<g;d++)u[d]=this._addUrlArgsToUrl(u[d]);return u}moduleIdToPaths(u){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(u))return this.isBuild()?["empty:"]:["node|"+u];let d=u,g;if(!O.Utilities.endsWith(d,".js")&&!O.Utilities.isAbsolutePath(d)){g=this._applyPaths(d);for(let a=0,s=g.length;a<s;a++)this.isBuild()&&g[a]==="empty:"||(O.Utilities.isAbsolutePath(g[a])||(g[a]=this.options.baseUrl+g[a]),!O.Utilities.endsWith(g[a],".js")&&!O.Utilities.containsQueryString(g[a])&&(g[a]=g[a]+".js"))}else!O.Utilities.endsWith(d,".js")&&!O.Utilities.containsQueryString(d)&&(d=d+".js"),g=[d];return this._addUrlArgsIfNecessaryToUrls(g)}requireToUrl(u){let d=u;return O.Utilities.isAbsolutePath(d)||(d=this._applyPaths(d)[0],O.Utilities.isAbsolutePath(d)||(d=this.options.baseUrl+d)),this._addUrlArgsIfNecessaryToUrl(d)}isBuild(){return this.options.isBuild}shouldInvokeFactory(u){return!!(!this.options.isBuild||O.Utilities.isAnonymousModule(u)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[u])}isDuplicateMessageIgnoredFor(u){return this.ignoreDuplicateModulesMap.hasOwnProperty(u)}getConfigForModule(u){if(this.options.config)return this.options.config[u]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(u){this.options.onError(u)}}O.Configuration=M})(ge||(ge={}));var ge;(function(O){class n{constructor(s){this._env=s,this._scriptLoader=null,this._callbackMap={}}load(s,v,e,m){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:h}=s.getConfig().getOptionsLiteral();h?this._scriptLoader=new E:this._scriptLoader=new u(this._env)}else this._env.isNode?this._scriptLoader=new u(this._env):this._scriptLoader=new E;let c={callback:e,errorback:m};if(this._callbackMap.hasOwnProperty(v)){this._callbackMap[v].push(c);return}this._callbackMap[v]=[c],this._scriptLoader.load(s,v,()=>this.triggerCallback(v),h=>this.triggerErrorback(v,h))}triggerCallback(s){let v=this._callbackMap[s];delete this._callbackMap[s];for(let e=0;e<v.length;e++)v[e].callback()}triggerErrorback(s,v){let e=this._callbackMap[s];delete this._callbackMap[s];for(let m=0;m<e.length;m++)e[m].errorback(v)}}class E{attachListeners(s,v,e){let m=()=>{s.removeEventListener("load",c),s.removeEventListener("error",h)},c=p=>{m(),v()},h=p=>{m(),e(p)};s.addEventListener("load",c),s.addEventListener("error",h)}load(s,v,e,m){if(/^node\|/.test(v)){let c=s.getConfig().getOptionsLiteral(),h=d(s.getRecorder(),c.nodeRequire||O.global.nodeRequire),p=v.split("|"),f=null;try{f=h(p[1])}catch(y){m(y);return}s.enqueueDefineAnonymousModule([],()=>f),e()}else{let c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript"),this.attachListeners(c,e,m);const{trustedTypesPolicy:h}=s.getConfig().getOptionsLiteral();h&&(v=h.createScriptURL(v)),c.setAttribute("src",v);const{cspNonce:p}=s.getConfig().getOptionsLiteral();p&&c.setAttribute("nonce",p),document.getElementsByTagName("head")[0].appendChild(c)}}}function M(a){const{trustedTypesPolicy:s}=a.getConfig().getOptionsLiteral();try{return(s?self.eval(s.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(s){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=M(s)),this._cachedCanUseEval}load(s,v,e,m){if(/^node\|/.test(v)){const c=s.getConfig().getOptionsLiteral(),h=d(s.getRecorder(),c.nodeRequire||O.global.nodeRequire),p=v.split("|");let f=null;try{f=h(p[1])}catch(y){m(y);return}s.enqueueDefineAnonymousModule([],function(){return f}),e()}else{const{trustedTypesPolicy:c}=s.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(v)&&v.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(s)){fetch(v).then(p=>{if(p.status!==200)throw new Error(p.statusText);return p.text()}).then(p=>{p=`${p}
//# sourceURL=${v}`,(c?self.eval(c.createScript("",p)):new Function(p)).call(self),e()}).then(void 0,m);return}try{c&&(v=c.createScriptURL(v)),importScripts(v),e()}catch(p){m(p)}}}}class u{constructor(s){this._env=s,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(s){this._didInitialize||(this._didInitialize=!0,this._fs=s("fs"),this._vm=s("vm"),this._path=s("path"),this._crypto=s("crypto"))}_initNodeRequire(s,v){const{nodeCachedData:e}=v.getConfig().getOptionsLiteral();if(!e||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const m=this,c=s("module");function h(p){const f=p.constructor;let y=function(R){try{return p.require(R)}finally{}};return y.resolve=function(R,S){return f._resolveFilename(R,p,!1,S)},y.resolve.paths=function(R){return f._resolveLookupPaths(R,p)},y.main=process.mainModule,y.extensions=f._extensions,y.cache=f._cache,y}c.prototype._compile=function(p,f){const y=c.wrap(p.replace(/^#!.*/,"")),w=v.getRecorder(),R=m._getCachedDataPath(e,f),S={filename:f};let L;try{const A=m._fs.readFileSync(R);L=A.slice(0,16),S.cachedData=A.slice(16),w.record(60,R)}catch{w.record(61,R)}const r=new m._vm.Script(y,S),o=r.runInThisContext(S),l=m._path.dirname(f),_=h(this),b=[this.exports,_,this,f,l,process,Ee,Buffer],C=o.apply(this.exports,b);return m._handleCachedData(r,y,R,!S.cachedData,v),m._verifyCachedData(r,y,R,L,v),C}}load(s,v,e,m){const c=s.getConfig().getOptionsLiteral(),h=d(s.getRecorder(),c.nodeRequire||O.global.nodeRequire),p=c.nodeInstrumenter||function(y){return y};this._init(h),this._initNodeRequire(h,s);let f=s.getRecorder();if(/^node\|/.test(v)){let y=v.split("|"),w=null;try{w=h(y[1])}catch(R){m(R);return}s.enqueueDefineAnonymousModule([],()=>w),e()}else{v=O.Utilities.fileUriToFilePath(this._env.isWindows,v);const y=this._path.normalize(v),w=this._getElectronRendererScriptPathOrUri(y),R=!!c.nodeCachedData,S=R?this._getCachedDataPath(c.nodeCachedData,v):void 0;this._readSourceAndCachedData(y,S,f,(L,r,o,l)=>{if(L){m(L);return}let _;r.charCodeAt(0)===u._BOM?_=u._PREFIX+r.substring(1)+u._SUFFIX:_=u._PREFIX+r+u._SUFFIX,_=p(_,y);const b={filename:w,cachedData:o},C=this._createAndEvalScript(s,_,b,e,m);this._handleCachedData(C,_,S,R&&!o,s),this._verifyCachedData(C,_,S,l,s)})}}_createAndEvalScript(s,v,e,m,c){const h=s.getRecorder();h.record(31,e.filename);const p=new this._vm.Script(v,e),f=p.runInThisContext(e),y=s.getGlobalAMDDefineFunc();let w=!1;const R=function(){return w=!0,y.apply(null,arguments)};return R.amd=y.amd,f.call(O.global,s.getGlobalAMDRequireFunc(),R,e.filename,this._path.dirname(e.filename)),h.record(32,e.filename),w?m():c(new Error(`Didn't receive define call in ${e.filename}!`)),p}_getElectronRendererScriptPathOrUri(s){if(!this._env.isElectronRenderer)return s;let v=s.match(/^([a-z])\:(.*)/i);return v?`file:///${(v[1].toUpperCase()+":"+v[2]).replace(/\\/g,"/")}`:`file://${s}`}_getCachedDataPath(s,v){const e=this._crypto.createHash("md5").update(v,"utf8").update(s.seed,"utf8").update(process.arch,"").digest("hex"),m=this._path.basename(v).replace(/\.js$/,"");return this._path.join(s.path,`${m}-${e}.code`)}_handleCachedData(s,v,e,m,c){s.cachedDataRejected?this._fs.unlink(e,h=>{c.getRecorder().record(62,e),this._createAndWriteCachedData(s,v,e,c),h&&c.getConfig().onError(h)}):m&&this._createAndWriteCachedData(s,v,e,c)}_createAndWriteCachedData(s,v,e,m){let c=Math.ceil(m.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),h=-1,p=0,f;const y=()=>{setTimeout(()=>{f||(f=this._crypto.createHash("md5").update(v,"utf8").digest());const w=s.createCachedData();if(!(w.length===0||w.length===h||p>=5)){if(w.length<h){y();return}h=w.length,this._fs.writeFile(e,Buffer.concat([f,w]),R=>{R&&m.getConfig().onError(R),m.getRecorder().record(63,e),y()})}},c*Math.pow(4,p++))};y()}_readSourceAndCachedData(s,v,e,m){if(!v)this._fs.readFile(s,{encoding:"utf8"},m);else{let c,h,p,f=2;const y=w=>{w?m(w):--f===0&&m(void 0,c,h,p)};this._fs.readFile(s,{encoding:"utf8"},(w,R)=>{c=R,y(w)}),this._fs.readFile(v,(w,R)=>{!w&&R&&R.length>0?(p=R.slice(0,16),h=R.slice(16),e.record(60,v)):e.record(61,v),y()})}}_verifyCachedData(s,v,e,m,c){m&&(s.cachedDataRejected||setTimeout(()=>{const h=this._crypto.createHash("md5").update(v,"utf8").digest();m.equals(h)||(c.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${e}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(e,p=>{p&&c.getConfig().onError(p)}))},Math.ceil(5e3*(1+Math.random()))))}}u._BOM=65279,u._PREFIX="(function (require, define, __filename, __dirname) { ",u._SUFFIX=`
});`;function d(a,s){if(s.__$__isRecorded)return s;const v=function(m){a.record(33,m);try{return s(m)}finally{a.record(34,m)}};return v.__$__isRecorded=!0,v}O.ensureRecordedNodeRequire=d;function g(a){return new n(a)}O.createScriptLoader=g})(ge||(ge={}));var ge;(function(O){class n{constructor(a){let s=a.lastIndexOf("/");s!==-1?this.fromModulePath=a.substr(0,s+1):this.fromModulePath=""}static _normalizeModuleId(a){let s=a,v;for(v=/\/\.\//;v.test(s);)s=s.replace(v,"/");for(s=s.replace(/^\.\//g,""),v=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;v.test(s);)s=s.replace(v,"/");return s=s.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),s}resolveModule(a){let s=a;return O.Utilities.isAbsolutePath(s)||(O.Utilities.startsWith(s,"./")||O.Utilities.startsWith(s,"../"))&&(s=n._normalizeModuleId(this.fromModulePath+s)),s}}n.ROOT=new n(""),O.ModuleIdResolver=n;class E{constructor(a,s,v,e,m,c){this.id=a,this.strId=s,this.dependencies=v,this._callback=e,this._errorback=m,this.moduleIdResolver=c,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,s){try{return{returnedValue:a.apply(O.global,s),producedError:null}}catch(v){return{returnedValue:null,producedError:v}}}static _invokeFactory(a,s,v,e){return a.shouldInvokeFactory(s)?a.shouldCatchError()?this._safeInvokeFunction(v,e):{returnedValue:v.apply(O.global,e),producedError:null}:{returnedValue:null,producedError:null}}complete(a,s,v,e){this._isComplete=!0;let m=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let c=E._invokeFactory(s,this.strId,this._callback,v);m=c.producedError,a.record(22,this.strId),!m&&typeof c.returnedValue<"u"&&(!this.exportsPassedIn||O.Utilities.isEmpty(this.exports))&&(this.exports=c.returnedValue)}else this.exports=this._callback;if(m){let c=O.ensureError(m);c.phase="factory",c.moduleId=this.strId,c.neededBy=e(this.id),this.error=c,s.onError(c)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}O.Module=E;class M{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let s=this._strModuleIdToIntModuleId.get(a);return typeof s>"u"&&(s=this._nextId++,this._strModuleIdToIntModuleId.set(a,s),this._intModuleIdToStrModuleId[s]=a),s}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class i{constructor(a){this.id=a}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),O.RegularDependency=i;class u{constructor(a,s,v){this.id=a,this.pluginId=s,this.pluginParam=v}}O.PluginDependency=u;class d{constructor(a,s,v,e,m=0){this._env=a,this._scriptLoader=s,this._loaderAvailableTimestamp=m,this._defineFunc=v,this._requireFunc=e,this._moduleIdProvider=new M,this._config=new O.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}reset(){return new d(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,s){let v=c=>c.replace(/\\/g,"/"),e=v(a),m=s.split(/\n/);for(let c=0;c<m.length;c++){let h=m[c].match(/(.*):(\d+):(\d+)\)?$/);if(h){let p=h[1],f=h[2],y=h[3],w=Math.max(p.lastIndexOf(" ")+1,p.lastIndexOf("(")+1);if(p=p.substr(w),p=v(p),p===e){let R={line:parseInt(f,10),col:parseInt(y,10)};return R.line===1&&(R.col-=53),R}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],s=0;for(let v=0,e=this._modules2.length;v<e;v++){let m=this._modules2[v];if(!m)continue;let c=this._buildInfoPath[m.id]||null,h=this._buildInfoDefineStack[m.id]||null,p=this._buildInfoDependencies[m.id];a[s++]={id:m.strId,path:c,defineLocation:c&&h?d._findRelevantLocationInStack(c,h):null,dependencies:p,shim:null,exports:m.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new O.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=O.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,s){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let v=null;this._config.isBuild()&&(v=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:v,dependencies:a,callback:s}}defineModule(a,s,v,e,m,c=new n(a)){let h=this._moduleIdProvider.getModuleId(a);if(this._modules2[h]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let p=new E(h,a,this._normalizeDependencies(s,c),v,e,c);this._modules2[h]=p,this._config.isBuild()&&(this._buildInfoDefineStack[h]=m,this._buildInfoDependencies[h]=(p.dependencies||[]).map(f=>this._moduleIdProvider.getStrModuleId(f.id))),this._resolve(p)}_normalizeDependency(a,s){if(a==="exports")return i.EXPORTS;if(a==="module")return i.MODULE;if(a==="require")return i.REQUIRE;let v=a.indexOf("!");if(v>=0){let e=s.resolveModule(a.substr(0,v)),m=s.resolveModule(a.substr(v+1)),c=this._moduleIdProvider.getModuleId(e+"!"+m),h=this._moduleIdProvider.getModuleId(e);return new u(c,h,m)}return new i(this._moduleIdProvider.getModuleId(s.resolveModule(a)))}_normalizeDependencies(a,s){let v=[],e=0;for(let m=0,c=a.length;m<c;m++)v[e++]=this._normalizeDependency(a[m],s);return v}_relativeRequire(a,s,v,e){if(typeof s=="string")return this.synchronousRequire(s,a);this.defineModule(O.Utilities.generateAnonymousModule(),s,v,e,null,a)}synchronousRequire(a,s=new n(a)){let v=this._normalizeDependency(a,s),e=this._modules2[v.id];if(!e)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!e.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if(e.error)throw e.error;return e.exports}configure(a,s){let v=this._config.shouldRecordStats();s?this._config=new O.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!v&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let s=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),s.dependencies,s.callback,null,s.stack)}}_createLoadError(a,s){let v=this._moduleIdProvider.getStrModuleId(a),e=(this._inverseDependencies2[a]||[]).map(c=>this._moduleIdProvider.getStrModuleId(c));const m=O.ensureError(s);return m.phase="loading",m.moduleId=v,m.neededBy=e,m}_onLoadError(a,s){const v=this._createLoadError(a,s);this._modules2[a]||(this._modules2[a]=new E(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let e=[];for(let h=0,p=this._moduleIdProvider.getMaxModuleId();h<p;h++)e[h]=!1;let m=!1,c=[];for(c.push(a),e[a]=!0;c.length>0;){let h=c.shift(),p=this._modules2[h];p&&(m=p.onDependencyError(v)||m);let f=this._inverseDependencies2[h];if(f)for(let y=0,w=f.length;y<w;y++){let R=f[y];e[R]||(c.push(R),e[R]=!0)}}m||this._config.onError(v)}_hasDependencyPath(a,s){let v=this._modules2[a];if(!v)return!1;let e=[];for(let c=0,h=this._moduleIdProvider.getMaxModuleId();c<h;c++)e[c]=!1;let m=[];for(m.push(v),e[a]=!0;m.length>0;){let h=m.shift().dependencies;if(h)for(let p=0,f=h.length;p<f;p++){let y=h[p];if(y.id===s)return!0;let w=this._modules2[y.id];w&&!e[y.id]&&(e[y.id]=!0,m.push(w))}}return!1}_findCyclePath(a,s,v){if(a===s||v===50)return[a];let e=this._modules2[a];if(!e)return null;let m=e.dependencies;if(m)for(let c=0,h=m.length;c<h;c++){let p=this._findCyclePath(m[c].id,s,v+1);if(p!==null)return p.push(a),p}return null}_createRequire(a){let s=(v,e,m)=>this._relativeRequire(a,v,e,m);return s.toUrl=v=>this._config.requireToUrl(a.resolveModule(v)),s.getStats=()=>this.getLoaderEvents(),s.hasDependencyCycle=()=>this._hasDependencyCycle,s.config=(v,e=!1)=>{this.configure(v,e)},s.__$__nodeRequire=O.global.nodeRequire,s}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let s=this._moduleIdProvider.getStrModuleId(a),v=this._config.moduleIdToPaths(s),e=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(s.indexOf("/")===-1||e.test(s))&&v.push("node|"+s);let m=-1,c=h=>{if(m++,m>=v.length)this._onLoadError(a,h);else{let p=v[m],f=this.getRecorder();if(this._config.isBuild()&&p==="empty:"){this._buildInfoPath[a]=p,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}f.record(10,p),this._scriptLoader.load(this,p,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=p),f.record(11,p),this._onLoad(a)},y=>{f.record(12,p),c(y)})}};c(null)}_loadPluginDependency(a,s){if(this._modules2[s.id]||this._knownModules2[s.id])return;this._knownModules2[s.id]=!0;let v=e=>{this.defineModule(this._moduleIdProvider.getStrModuleId(s.id),[],e,null,null)};v.error=e=>{this._config.onError(this._createLoadError(s.id,e))},a.load(s.pluginParam,this._createRequire(n.ROOT),v,this._config.getOptionsLiteral())}_resolve(a){let s=a.dependencies;if(s)for(let v=0,e=s.length;v<e;v++){let m=s[v];if(m===i.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(m===i.MODULE){a.unresolvedDependenciesCount--;continue}if(m===i.REQUIRE){a.unresolvedDependenciesCount--;continue}let c=this._modules2[m.id];if(c&&c.isComplete()){if(c.error){a.onDependencyError(c.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(m.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(m.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let h=this._findCyclePath(m.id,a.id,0)||[];h.reverse(),h.push(m.id),console.warn(h.map(p=>this._moduleIdProvider.getStrModuleId(p)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[m.id]=this._inverseDependencies2[m.id]||[],this._inverseDependencies2[m.id].push(a.id),m instanceof u){let h=this._modules2[m.pluginId];if(h&&h.isComplete()){this._loadPluginDependency(h.exports,m);continue}let p=this._inversePluginDependencies2.get(m.pluginId);p||(p=[],this._inversePluginDependencies2.set(m.pluginId,p)),p.push(m),this._loadModule(m.pluginId);continue}this._loadModule(m.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let s=this.getRecorder();if(a.isComplete())return;let v=a.dependencies,e=[];if(v)for(let p=0,f=v.length;p<f;p++){let y=v[p];if(y===i.EXPORTS){e[p]=a.exports;continue}if(y===i.MODULE){e[p]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(y===i.REQUIRE){e[p]=this._createRequire(a.moduleIdResolver);continue}let w=this._modules2[y.id];if(w){e[p]=w.exports;continue}e[p]=null}const m=p=>(this._inverseDependencies2[p]||[]).map(f=>this._moduleIdProvider.getStrModuleId(f));a.complete(s,this._config,e,m);let c=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,c)for(let p=0,f=c.length;p<f;p++){let y=c[p],w=this._modules2[y];w.unresolvedDependenciesCount--,w.unresolvedDependenciesCount===0&&this._onModuleComplete(w)}let h=this._inversePluginDependencies2.get(a.id);if(h){this._inversePluginDependencies2.delete(a.id);for(let p=0,f=h.length;p<f;p++)this._loadPluginDependency(a.exports,h[p])}}}O.ModuleManager=d})(ge||(ge={}));var ne,ge;(function(O){const n=new O.Environment;let E=null;const M=function(g,a,s){typeof g!="string"&&(s=a,a=g,g=null),(typeof a!="object"||!Array.isArray(a))&&(s=a,a=null),a||(a=["require","exports","module"]),g?E.defineModule(g,a,s,null,null):E.enqueueDefineAnonymousModule(a,s)};M.amd={jQuery:!0};const i=function(g,a=!1){E.configure(g,a)},u=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return E.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){E.defineModule(O.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};u.config=i,u.getConfig=function(){return E.getConfig().getOptionsLiteral()},u.reset=function(){E=E.reset()},u.getBuildInfo=function(){return E.getBuildInfo()},u.getStats=function(){return E.getLoaderEvents()},u.define=M;function d(){if(typeof O.global.require<"u"||typeof require<"u"){const g=O.global.require||require;if(typeof g=="function"&&typeof g.resolve=="function"){const a=O.ensureRecordedNodeRequire(E.getRecorder(),g);O.global.nodeRequire=a,u.nodeRequire=a,u.__$__nodeRequire=a}}n.isNode&&!n.isElectronRenderer&&!n.isElectronNodeIntegrationWebWorker?module.exports=u:(n.isElectronRenderer||(O.global.define=M),O.global.require=u)}O.init=d,(typeof O.global.define!="function"||!O.global.define.amd)&&(E=new O.ModuleManager(n,O.createScriptLoader(n),M,u,O.Utilities.getHighPerformanceTimestamp()),typeof O.global.require<"u"&&typeof O.global.require!="function"&&u.config(O.global.require),ne=function(){return M.apply(null,arguments)},ne.amd=M.amd,typeof doNotInitLoader>"u"&&d())})(ge||(ge={}));var pe=this&&this.__awaiter||function(O,n,E,M){function i(u){return u instanceof E?u:new E(function(d){d(u)})}return new(E||(E=Promise))(function(u,d){function g(v){try{s(M.next(v))}catch(e){d(e)}}function a(v){try{s(M.throw(v))}catch(e){d(e)}}function s(v){v.done?u(v.value):i(v.value).then(g,a)}s((M=M.apply(O,n||[])).next())})};ne(ie[15],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.load=n.create=n.setPseudoTranslation=n.getConfiguredDefaultLocale=n.localize=void 0;let E=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const M="i-default";function i(h,p){let f;return p.length===0?f=h:f=h.replace(/\{(\d+)\}/g,(y,w)=>{const R=w[0],S=p[R];let L=y;return typeof S=="string"?L=S:(typeof S=="number"||typeof S=="boolean"||S===void 0||S===null)&&(L=String(S)),L}),E&&(f="\uFF3B"+f.replace(/[aouei]/g,"$&$&")+"\uFF3D"),f}function u(h,p){let f=h[p];return f||(f=h["*"],f)?f:null}function d(h){return h.charAt(h.length-1)==="/"?h:h+"/"}function g(h,p,f){return pe(this,void 0,void 0,function*(){const y=d(h)+d(p)+"vscode/"+d(f),w=yield fetch(y);if(w.ok)return yield w.json();throw new Error(`${w.status} - ${w.statusText}`)})}function a(h){return function(p,f){const y=Array.prototype.slice.call(arguments,2);return i(h[p],y)}}function s(h,p,...f){return i(p,f)}n.localize=s;function v(h){}n.getConfiguredDefaultLocale=v;function e(h){E=h}n.setPseudoTranslation=e;function m(h,p){var f;return{localize:a(p[h]),getConfiguredDefaultLocale:(f=p.getConfiguredDefaultLocale)!==null&&f!==void 0?f:y=>{}}}n.create=m;function c(h,p,f,y){var w;const R=(w=y["vs/nls"])!==null&&w!==void 0?w:{};if(!h||h.length===0)return f({localize:s,getConfiguredDefaultLocale:()=>{var l;return(l=R.availableLanguages)===null||l===void 0?void 0:l["*"]}});const S=R.availableLanguages?u(R.availableLanguages,h):null,L=S===null||S===M;let r=".nls";L||(r=r+"."+S);const o=l=>{Array.isArray(l)?l.localize=a(l):l.localize=a(l[h]),l.getConfiguredDefaultLocale=()=>{var _;return(_=R.availableLanguages)===null||_===void 0?void 0:_["*"]},f(l)};typeof R.loadBundle=="function"?R.loadBundle(h,S,(l,_)=>{l?p([h+".nls"],o):o(_)}):R.translationServiceUrl&&!L?pe(this,void 0,void 0,function*(){var l;try{const _=yield g(R.translationServiceUrl,S,h);return o(_)}catch(_){if(!S.includes("-"))return console.error(_),p([h+".nls"],o);try{const b=S.split("-")[0],C=yield g(R.translationServiceUrl,b,h);return(l=R.availableLanguages)!==null&&l!==void 0||(R.availableLanguages={}),R.availableLanguages["*"]=b,o(C)}catch(b){return console.error(b),p([h+".nls"],o)}}}):p([h+r],o,l=>{if(r===".nls"){console.error("Failed trying to load default language strings",l);return}console.error(`Failed to load message bundle for language ${S}. Falling back to the default language:`,l),p([h+".nls"],o)})}n.load=c}),function(){const O=globalThis.MonacoEnvironment,n=O&&O.baseUrl?O.baseUrl:"../../../";function E(v,e){var m;if(O?.createTrustedTypesPolicy)try{return O.createTrustedTypesPolicy(v,e)}catch(c){console.warn(c);return}try{return(m=self.trustedTypes)===null||m===void 0?void 0:m.createPolicy(v,e)}catch(c){console.warn(c);return}}const M=E("amdLoader",{createScriptURL:v=>v,createScript:(v,...e)=>{const m=e.slice(0,-1).join(","),c=e.pop().toString();return`(function anonymous(${m}) { ${c}
})`}});function i(){try{return(M?globalThis.eval(M.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function u(){return new Promise((v,e)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return v();const m=n+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(m)&&m.substring(0,globalThis.origin.length)!==globalThis.origin)&&i()){fetch(m).then(h=>{if(h.status!==200)throw new Error(h.statusText);return h.text()}).then(h=>{h=`${h}
//# sourceURL=${m}`,(M?globalThis.eval(M.createScript("",h)):new Function(h)).call(globalThis),v()}).then(void 0,e);return}M?importScripts(M.createScriptURL(m)):importScripts(m),v()})}function d(){require.config({baseUrl:n,catchError:!0,trustedTypesPolicy:M,amdModulesPattern:/^vs\//})}function g(v){u().then(()=>{d(),require([v],function(e){setTimeout(function(){const m=e.create((c,h)=>{globalThis.postMessage(c,h)},null);for(globalThis.onmessage=c=>m.onmessage(c.data,c.ports);s.length>0;){const c=s.shift();m.onmessage(c.data,c.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&d();let a=!0;const s=[];globalThis.onmessage=v=>{if(!a){s.push(v);return}a=!1,g(v.data)}}(),ne(ie[16],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CallbackIterable=n.ArrayQueue=n.findMaxIdxBy=n.findMinBy=n.findLastMaxBy=n.findMaxBy=n.reverseOrder=n.booleanComparator=n.numberComparator=n.tieBreakComparators=n.compareBy=n.CompareResult=n.splice=n.insertInto=n.mapFind=n.asArray=n.pushMany=n.pushToEnd=n.pushToStart=n.arrayInsert=n.range=n.firstOrDefault=n.findLastIndex=n.findLast=n.distinct=n.isNonEmptyArray=n.isFalsyOrEmpty=n.coalesceInPlace=n.coalesce=n.groupBy=n.quickSelect=n.findFirstInSorted=n.binarySearch2=n.binarySearch=n.removeFastWithoutKeepingOrder=n.equals=n.tail2=n.tail=void 0;function E(t,q=0){return t[t.length-(1+q)]}n.tail=E;function M(t){if(t.length===0)throw new Error("Invalid tail call");return[t.slice(0,t.length-1),t[t.length-1]]}n.tail2=M;function i(t,q,V=(Y,J)=>Y===J){if(t===q)return!0;if(!t||!q||t.length!==q.length)return!1;for(let Y=0,J=t.length;Y<J;Y++)if(!V(t[Y],q[Y]))return!1;return!0}n.equals=i;function u(t,q){const V=t.length-1;q<V&&(t[q]=t[V]),t.pop()}n.removeFastWithoutKeepingOrder=u;function d(t,q,V){return g(t.length,Y=>V(t[Y],q))}n.binarySearch=d;function g(t,q){let V=0,Y=t-1;for(;V<=Y;){const J=(V+Y)/2|0,ue=q(J);if(ue<0)V=J+1;else if(ue>0)Y=J-1;else return J}return-(V+1)}n.binarySearch2=g;function a(t,q){let V=0,Y=t.length;if(Y===0)return 0;for(;V<Y;){const J=Math.floor((V+Y)/2);q(t[J])?Y=J:V=J+1}return V}n.findFirstInSorted=a;function s(t,q,V){if(t=t|0,t>=q.length)throw new TypeError("invalid index");const Y=q[Math.floor(q.length*Math.random())],J=[],ue=[],le=[];for(const fe of q){const me=V(fe,Y);me<0?J.push(fe):me>0?ue.push(fe):le.push(fe)}return t<J.length?s(t,J,V):t<J.length+le.length?le[0]:s(t-(J.length+le.length),ue,V)}n.quickSelect=s;function v(t,q){const V=[];let Y;for(const J of t.slice(0).sort(q))!Y||q(Y[0],J)!==0?(Y=[J],V.push(Y)):Y.push(J);return V}n.groupBy=v;function e(t){return t.filter(q=>!!q)}n.coalesce=e;function m(t){let q=0;for(let V=0;V<t.length;V++)t[V]&&(t[q]=t[V],q+=1);t.length=q}n.coalesceInPlace=m;function c(t){return!Array.isArray(t)||t.length===0}n.isFalsyOrEmpty=c;function h(t){return Array.isArray(t)&&t.length>0}n.isNonEmptyArray=h;function p(t,q=V=>V){const V=new Set;return t.filter(Y=>{const J=q(Y);return V.has(J)?!1:(V.add(J),!0)})}n.distinct=p;function f(t,q){const V=y(t,q);if(V!==-1)return t[V]}n.findLast=f;function y(t,q){for(let V=t.length-1;V>=0;V--){const Y=t[V];if(q(Y))return V}return-1}n.findLastIndex=y;function w(t,q){return t.length>0?t[0]:q}n.firstOrDefault=w;function R(t,q){let V=typeof q=="number"?t:0;typeof q=="number"?V=t:(V=0,q=t);const Y=[];if(V<=q)for(let J=V;J<q;J++)Y.push(J);else for(let J=V;J>q;J--)Y.push(J);return Y}n.range=R;function S(t,q,V){const Y=t.slice(0,q),J=t.slice(q);return Y.concat(V,J)}n.arrayInsert=S;function L(t,q){const V=t.indexOf(q);V>-1&&(t.splice(V,1),t.unshift(q))}n.pushToStart=L;function r(t,q){const V=t.indexOf(q);V>-1&&(t.splice(V,1),t.push(q))}n.pushToEnd=r;function o(t,q){for(const V of q)t.push(V)}n.pushMany=o;function l(t){return Array.isArray(t)?t:[t]}n.asArray=l;function _(t,q){for(const V of t){const Y=q(V);if(Y!==void 0)return Y}}n.mapFind=_;function b(t,q,V){const Y=A(t,q),J=t.length,ue=V.length;t.length=J+ue;for(let le=J-1;le>=Y;le--)t[le+ue]=t[le];for(let le=0;le<ue;le++)t[le+Y]=V[le]}n.insertInto=b;function C(t,q,V,Y){const J=A(t,q),ue=t.splice(J,V);return b(t,J,Y),ue}n.splice=C;function A(t,q){return q<0?Math.max(q+t.length,0):Math.min(q,t.length)}var N;(function(t){function q(J){return J<0}t.isLessThan=q;function V(J){return J>0}t.isGreaterThan=V;function Y(J){return J===0}t.isNeitherLessOrGreaterThan=Y,t.greaterThan=1,t.lessThan=-1,t.neitherLessOrGreaterThan=0})(N||(n.CompareResult=N={}));function D(t,q){return(V,Y)=>q(t(V),t(Y))}n.compareBy=D;function x(...t){return(q,V)=>{for(const Y of t){const J=Y(q,V);if(!N.isNeitherLessOrGreaterThan(J))return J}return N.neitherLessOrGreaterThan}}n.tieBreakComparators=x;const W=(t,q)=>t-q;n.numberComparator=W;const I=(t,q)=>(0,n.numberComparator)(t?1:0,q?1:0);n.booleanComparator=I;function k(t){return(q,V)=>-t(q,V)}n.reverseOrder=k;function P(t,q){if(t.length===0)return;let V=t[0];for(let Y=1;Y<t.length;Y++){const J=t[Y];q(J,V)>0&&(V=J)}return V}n.findMaxBy=P;function T(t,q){if(t.length===0)return;let V=t[0];for(let Y=1;Y<t.length;Y++){const J=t[Y];q(J,V)>=0&&(V=J)}return V}n.findLastMaxBy=T;function z(t,q){return P(t,(V,Y)=>-q(V,Y))}n.findMinBy=z;function U(t,q){if(t.length===0)return-1;let V=0;for(let Y=1;Y<t.length;Y++){const J=t[Y];q(J,t[V])>0&&(V=Y)}return V}n.findMaxIdxBy=U;class Z{constructor(q){this.items=q,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(q){let V=this.firstIdx;for(;V<this.items.length&&q(this.items[V]);)V++;const Y=V===this.firstIdx?null:this.items.slice(this.firstIdx,V);return this.firstIdx=V,Y}takeFromEndWhile(q){let V=this.lastIdx;for(;V>=0&&q(this.items[V]);)V--;const Y=V===this.lastIdx?null:this.items.slice(V+1,this.lastIdx+1);return this.lastIdx=V,Y}peek(){if(this.length!==0)return this.items[this.firstIdx]}dequeue(){const q=this.items[this.firstIdx];return this.firstIdx++,q}takeCount(q){const V=this.items.slice(this.firstIdx,this.firstIdx+q);return this.firstIdx+=q,V}}n.ArrayQueue=Z;class ee{constructor(q){this.iterate=q}toArray(){const q=[];return this.iterate(V=>(q.push(V),!0)),q}filter(q){return new ee(V=>this.iterate(Y=>q(Y)?V(Y):!0))}map(q){return new ee(V=>this.iterate(Y=>V(q(Y))))}findLast(q){let V;return this.iterate(Y=>(q(Y)&&(V=Y),!0)),V}findLastMaxBy(q){let V,Y=!0;return this.iterate(J=>((Y||N.isGreaterThan(q(J,V)))&&(Y=!1,V=J),!0)),V}}n.CallbackIterable=ee,ee.empty=new ee(t=>{})}),ne(ie[27],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CachedFunction=n.LRUCachedFunction=void 0;class E{constructor(u){this.fn=u,this.lastCache=void 0,this.lastArgKey=void 0}get(u){const d=JSON.stringify(u);return this.lastArgKey!==d&&(this.lastArgKey=d,this.lastCache=this.fn(u)),this.lastCache}}n.LRUCachedFunction=E;class M{get cachedValues(){return this._map}constructor(u){this.fn=u,this._map=new Map}get(u){if(this._map.has(u))return this._map.get(u);const d=this.fn(u);return this._map.set(u,d),d}}n.CachedFunction=M}),ne(ie[28],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.SetMap=void 0;class E{constructor(){this.map=new Map}add(i,u){let d=this.map.get(i);d||(d=new Set,this.map.set(i,d)),d.add(u)}delete(i,u){const d=this.map.get(i);d&&(d.delete(u),d.size===0&&this.map.delete(i))}forEach(i,u){const d=this.map.get(i);d&&d.forEach(u)}get(i){const u=this.map.get(i);return u||new Set}}n.SetMap=E}),ne(ie[29],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Color=n.HSVA=n.HSLA=n.RGBA=void 0;function E(g,a){const s=Math.pow(10,a);return Math.round(g*s)/s}class M{constructor(a,s,v,e=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,a))|0,this.g=Math.min(255,Math.max(0,s))|0,this.b=Math.min(255,Math.max(0,v))|0,this.a=E(Math.max(Math.min(1,e),0),3)}static equals(a,s){return a.r===s.r&&a.g===s.g&&a.b===s.b&&a.a===s.a}}n.RGBA=M;class i{constructor(a,s,v,e){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=E(Math.max(Math.min(1,s),0),3),this.l=E(Math.max(Math.min(1,v),0),3),this.a=E(Math.max(Math.min(1,e),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.l===s.l&&a.a===s.a}static fromRGBA(a){const s=a.r/255,v=a.g/255,e=a.b/255,m=a.a,c=Math.max(s,v,e),h=Math.min(s,v,e);let p=0,f=0;const y=(h+c)/2,w=c-h;if(w>0){switch(f=Math.min(y<=.5?w/(2*y):w/(2-2*y),1),c){case s:p=(v-e)/w+(v<e?6:0);break;case v:p=(e-s)/w+2;break;case e:p=(s-v)/w+4;break}p*=60,p=Math.round(p)}return new i(p,f,y,m)}static _hue2rgb(a,s,v){return v<0&&(v+=1),v>1&&(v-=1),v<1/6?a+(s-a)*6*v:v<1/2?s:v<2/3?a+(s-a)*(2/3-v)*6:a}static toRGBA(a){const s=a.h/360,{s:v,l:e,a:m}=a;let c,h,p;if(v===0)c=h=p=e;else{const f=e<.5?e*(1+v):e+v-e*v,y=2*e-f;c=i._hue2rgb(y,f,s+1/3),h=i._hue2rgb(y,f,s),p=i._hue2rgb(y,f,s-1/3)}return new M(Math.round(c*255),Math.round(h*255),Math.round(p*255),m)}}n.HSLA=i;class u{constructor(a,s,v,e){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,a),0)|0,this.s=E(Math.max(Math.min(1,s),0),3),this.v=E(Math.max(Math.min(1,v),0),3),this.a=E(Math.max(Math.min(1,e),0),3)}static equals(a,s){return a.h===s.h&&a.s===s.s&&a.v===s.v&&a.a===s.a}static fromRGBA(a){const s=a.r/255,v=a.g/255,e=a.b/255,m=Math.max(s,v,e),c=Math.min(s,v,e),h=m-c,p=m===0?0:h/m;let f;return h===0?f=0:m===s?f=((v-e)/h%6+6)%6:m===v?f=(e-s)/h+2:f=(s-v)/h+4,new u(Math.round(f*60),p,m,a.a)}static toRGBA(a){const{h:s,s:v,v:e,a:m}=a,c=e*v,h=c*(1-Math.abs(s/60%2-1)),p=e-c;let[f,y,w]=[0,0,0];return s<60?(f=c,y=h):s<120?(f=h,y=c):s<180?(y=c,w=h):s<240?(y=h,w=c):s<300?(f=h,w=c):s<=360&&(f=c,w=h),f=Math.round((f+p)*255),y=Math.round((y+p)*255),w=Math.round((w+p)*255),new M(f,y,w,m)}}n.HSVA=u;class d{static fromHex(a){return d.Format.CSS.parseHex(a)||d.red}static equals(a,s){return!a&&!s?!0:!a||!s?!1:a.equals(s)}get hsla(){return this._hsla?this._hsla:i.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:u.fromRGBA(this.rgba)}constructor(a){if(a)if(a instanceof M)this.rgba=a;else if(a instanceof i)this._hsla=a,this.rgba=i.toRGBA(a);else if(a instanceof u)this._hsva=a,this.rgba=u.toRGBA(a);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(a){return!!a&&M.equals(this.rgba,a.rgba)&&i.equals(this.hsla,a.hsla)&&u.equals(this.hsva,a.hsva)}getRelativeLuminance(){const a=d._relativeLuminanceForComponent(this.rgba.r),s=d._relativeLuminanceForComponent(this.rgba.g),v=d._relativeLuminanceForComponent(this.rgba.b),e=.2126*a+.7152*s+.0722*v;return E(e,4)}static _relativeLuminanceForComponent(a){const s=a/255;return s<=.03928?s/12.92:Math.pow((s+.055)/1.055,2.4)}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(a){const s=this.getRelativeLuminance(),v=a.getRelativeLuminance();return s>v}isDarkerThan(a){const s=this.getRelativeLuminance(),v=a.getRelativeLuminance();return s<v}lighten(a){return new d(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*a,this.hsla.a))}darken(a){return new d(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*a,this.hsla.a))}transparent(a){const{r:s,g:v,b:e,a:m}=this.rgba;return new d(new M(s,v,e,m*a))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new d(new M(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}makeOpaque(a){if(this.isOpaque()||a.rgba.a!==1)return this;const{r:s,g:v,b:e,a:m}=this.rgba;return new d(new M(a.rgba.r-m*(a.rgba.r-s),a.rgba.g-m*(a.rgba.g-v),a.rgba.b-m*(a.rgba.b-e),1))}toString(){return this._toString||(this._toString=d.Format.CSS.format(this)),this._toString}static getLighterColor(a,s,v){if(a.isLighterThan(s))return a;v=v||.5;const e=a.getRelativeLuminance(),m=s.getRelativeLuminance();return v=v*(m-e)/m,a.lighten(v)}static getDarkerColor(a,s,v){if(a.isDarkerThan(s))return a;v=v||.5;const e=a.getRelativeLuminance(),m=s.getRelativeLuminance();return v=v*(e-m)/e,a.darken(v)}}n.Color=d,d.white=new d(new M(255,255,255,1)),d.black=new d(new M(0,0,0,1)),d.red=new d(new M(255,0,0,1)),d.blue=new d(new M(0,0,255,1)),d.green=new d(new M(0,255,0,1)),d.cyan=new d(new M(0,255,255,1)),d.lightgrey=new d(new M(211,211,211,1)),d.transparent=new d(new M(0,0,0,0)),function(g){let a;(function(s){let v;(function(e){function m(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:g.Format.CSS.formatRGBA(r)}e.formatRGB=m;function c(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}e.formatRGBA=c;function h(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:g.Format.CSS.formatHSLA(r)}e.formatHSL=h;function p(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}e.formatHSLA=p;function f(r){const o=r.toString(16);return o.length!==2?"0"+o:o}function y(r){return`#${f(r.rgba.r)}${f(r.rgba.g)}${f(r.rgba.b)}`}e.formatHex=y;function w(r,o=!1){return o&&r.rgba.a===1?g.Format.CSS.formatHex(r):`#${f(r.rgba.r)}${f(r.rgba.g)}${f(r.rgba.b)}${f(Math.round(r.rgba.a*255))}`}e.formatHexA=w;function R(r){return r.isOpaque()?g.Format.CSS.formatHex(r):g.Format.CSS.formatRGBA(r)}e.format=R;function S(r){const o=r.length;if(o===0||r.charCodeAt(0)!==35)return null;if(o===7){const l=16*L(r.charCodeAt(1))+L(r.charCodeAt(2)),_=16*L(r.charCodeAt(3))+L(r.charCodeAt(4)),b=16*L(r.charCodeAt(5))+L(r.charCodeAt(6));return new g(new M(l,_,b,1))}if(o===9){const l=16*L(r.charCodeAt(1))+L(r.charCodeAt(2)),_=16*L(r.charCodeAt(3))+L(r.charCodeAt(4)),b=16*L(r.charCodeAt(5))+L(r.charCodeAt(6)),C=16*L(r.charCodeAt(7))+L(r.charCodeAt(8));return new g(new M(l,_,b,C/255))}if(o===4){const l=L(r.charCodeAt(1)),_=L(r.charCodeAt(2)),b=L(r.charCodeAt(3));return new g(new M(16*l+l,16*_+_,16*b+b))}if(o===5){const l=L(r.charCodeAt(1)),_=L(r.charCodeAt(2)),b=L(r.charCodeAt(3)),C=L(r.charCodeAt(4));return new g(new M(16*l+l,16*_+_,16*b+b,(16*C+C)/255))}return null}e.parseHex=S;function L(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(v=s.CSS||(s.CSS={}))})(a=g.Format||(g.Format={}))}(d||(n.Color=d={}))}),ne(ie[30],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffChange=void 0;class E{constructor(i,u,d,g){this.originalStart=i,this.originalLength=u,this.modifiedStart=d,this.modifiedLength=g}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}n.DiffChange=E}),ne(ie[4],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BugIndicatingError=n.ErrorNoTelemetry=n.NotSupportedError=n.illegalState=n.illegalArgument=n.canceled=n.CancellationError=n.isCancellationError=n.transformErrorForSerialization=n.onUnexpectedExternalError=n.onUnexpectedError=n.errorHandler=n.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(f){setTimeout(()=>{throw f.stack?c.isErrorNoTelemetry(f)?new c(f.message+`

`+f.stack):new Error(f.message+`

`+f.stack):f},0)}}emit(f){this.listeners.forEach(y=>{y(f)})}onUnexpectedError(f){this.unexpectedErrorHandler(f),this.emit(f)}onUnexpectedExternalError(f){this.unexpectedErrorHandler(f)}}n.ErrorHandler=E,n.errorHandler=new E;function M(p){g(p)||n.errorHandler.onUnexpectedError(p)}n.onUnexpectedError=M;function i(p){g(p)||n.errorHandler.onUnexpectedExternalError(p)}n.onUnexpectedExternalError=i;function u(p){if(p instanceof Error){const{name:f,message:y}=p,w=p.stacktrace||p.stack;return{$isError:!0,name:f,message:y,stack:w,noTelemetry:c.isErrorNoTelemetry(p)}}return p}n.transformErrorForSerialization=u;const d="Canceled";function g(p){return p instanceof a?!0:p instanceof Error&&p.name===d&&p.message===d}n.isCancellationError=g;class a extends Error{constructor(){super(d),this.name=this.message}}n.CancellationError=a;function s(){const p=new Error(d);return p.name=p.message,p}n.canceled=s;function v(p){return p?new Error(`Illegal argument: ${p}`):new Error("Illegal argument")}n.illegalArgument=v;function e(p){return p?new Error(`Illegal state: ${p}`):new Error("Illegal state")}n.illegalState=e;class m extends Error{constructor(f){super("NotSupported"),f&&(this.message=f)}}n.NotSupportedError=m;class c extends Error{constructor(f){super(f),this.name="CodeExpectedError"}static fromError(f){if(f instanceof c)return f;const y=new c;return y.message=f.message,y.stack=f.stack,y}static isErrorNoTelemetry(f){return f.name==="CodeExpectedError"}}n.ErrorNoTelemetry=c;class h extends Error{constructor(f){super(f||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype)}}n.BugIndicatingError=h}),ne(ie[9],re([0,1,4]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.checkAdjacentItems=n.assertFn=n.assertNever=n.ok=void 0;function M(g,a){if(!g)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}n.ok=M;function i(g,a="Unreachable"){throw new Error(a)}n.assertNever=i;function u(g){if(!g()){debugger;g(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}n.assertFn=u;function d(g,a){let s=0;for(;s<g.length-1;){const v=g[s],e=g[s+1];if(!a(v,e))return!1;s++}return!0}n.checkAdjacentItems=d}),ne(ie[17],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.once=void 0;function E(M){const i=this;let u=!1,d;return function(){return u||(u=!0,d=M.apply(i,arguments)),d}}n.once=E}),ne(ie[18],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Iterable=void 0;var E;(function(M){function i(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}M.is=i;const u=Object.freeze([]);function d(){return u}M.empty=d;function*g(S){yield S}M.single=g;function a(S){return i(S)?S:g(S)}M.wrap=a;function s(S){return S||u}M.from=s;function v(S){return!S||S[Symbol.iterator]().next().done===!0}M.isEmpty=v;function e(S){return S[Symbol.iterator]().next().value}M.first=e;function m(S,L){for(const r of S)if(L(r))return!0;return!1}M.some=m;function c(S,L){for(const r of S)if(L(r))return r}M.find=c;function*h(S,L){for(const r of S)L(r)&&(yield r)}M.filter=h;function*p(S,L){let r=0;for(const o of S)yield L(o,r++)}M.map=p;function*f(...S){for(const L of S)for(const r of L)yield r}M.concat=f;function y(S,L,r){let o=r;for(const l of S)o=L(o,l);return o}M.reduce=y;function*w(S,L,r=S.length){for(L<0&&(L+=S.length),r<0?r+=S.length:r>S.length&&(r=S.length);L<r;L++)yield S[L]}M.slice=w;function R(S,L=Number.POSITIVE_INFINITY){const r=[];if(L===0)return[r,S];const o=S[Symbol.iterator]();for(let l=0;l<L;l++){const _=o.next();if(_.done)return[r,M.empty()];r.push(_.value)}return[r,{[Symbol.iterator](){return o}}]}M.consume=R})(E||(n.Iterable=E={}))}),ne(ie[31],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.KeyChord=n.KeyCodeUtils=n.IMMUTABLE_KEY_CODE_TO_CODE=n.IMMUTABLE_CODE_TO_KEY_CODE=n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=n.EVENT_KEY_CODE_MAP=void 0;class E{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(m,c){this._keyCodeToStr[m]=c,this._strToKeyCode[c.toLowerCase()]=m}keyCodeToStr(m){return this._keyCodeToStr[m]}strToKeyCode(m){return this._strToKeyCode[m.toLowerCase()]||0}}const M=new E,i=new E,u=new E;n.EVENT_KEY_CODE_MAP=new Array(230),n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const d=[],g=Object.create(null),a=Object.create(null);n.IMMUTABLE_CODE_TO_KEY_CODE=[],n.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)n.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)n.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",m=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],c=[],h=[];for(const p of m){const[f,y,w,R,S,L,r,o,l]=p;if(h[y]||(h[y]=!0,d[y]=w,g[w]=y,a[w.toLowerCase()]=y,f&&(n.IMMUTABLE_CODE_TO_KEY_CODE[y]=R,R!==0&&R!==3&&R!==5&&R!==4&&R!==6&&R!==57&&(n.IMMUTABLE_KEY_CODE_TO_CODE[R]=y))),!c[R]){if(c[R]=!0,!S)throw new Error(`String representation missing for key code ${R} around scan code ${w}`);M.define(R,S),i.define(R,o||S),u.define(R,l||o||S)}L&&(n.EVENT_KEY_CODE_MAP[L]=R),r&&(n.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[r]=R)}n.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var s;(function(e){function m(w){return M.keyCodeToStr(w)}e.toString=m;function c(w){return M.strToKeyCode(w)}e.fromString=c;function h(w){return i.keyCodeToStr(w)}e.toUserSettingsUS=h;function p(w){return u.keyCodeToStr(w)}e.toUserSettingsGeneral=p;function f(w){return i.strToKeyCode(w)||u.strToKeyCode(w)}e.fromUserSettings=f;function y(w){if(w>=98&&w<=113)return null;switch(w){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return M.keyCodeToStr(w)}e.toElectronAccelerator=y})(s||(n.KeyCodeUtils=s={}));function v(e,m){const c=(m&65535)<<16>>>0;return(e|c)>>>0}n.KeyChord=v}),ne(ie[32],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Lazy=void 0;class E{constructor(i){this.executor=i,this._didRun=!1}get value(){if(!this._didRun)try{this._value=this.executor()}catch(i){this._error=i}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}}n.Lazy=E}),ne(ie[10],re([0,1,17,18]),function(O,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DisposableMap=n.ImmortalReference=n.RefCountedDisposable=n.MutableDisposable=n.Disposable=n.DisposableStore=n.toDisposable=n.combinedDisposable=n.dispose=n.isDisposable=n.markAsSingleton=n.setDisposableTracker=void 0;const i=!1;let u=null;function d(r){u=r}if(n.setDisposableTracker=d,i){const r="__is_disposable_tracked__";d(new class{trackDisposable(o){const l=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[r]||console.log(l)},3e3)}setParent(o,l){if(o&&o!==y.None)try{o[r]=!0}catch{}}markAsDisposed(o){if(o&&o!==y.None)try{o[r]=!0}catch{}}markAsSingleton(o){}})}function g(r){return u?.trackDisposable(r),r}function a(r){u?.markAsDisposed(r)}function s(r,o){u?.setParent(r,o)}function v(r,o){if(u)for(const l of r)u.setParent(l,o)}function e(r){return u?.markAsSingleton(r),r}n.markAsSingleton=e;function m(r){return typeof r.dispose=="function"&&r.dispose.length===0}n.isDisposable=m;function c(r){if(M.Iterable.is(r)){const o=[];for(const l of r)if(l)try{l.dispose()}catch(_){o.push(_)}if(o.length===1)throw o[0];if(o.length>1)throw new AggregateError(o,"Encountered errors while disposing of store");return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}n.dispose=c;function h(...r){const o=p(()=>c(r));return v(r,o),o}n.combinedDisposable=h;function p(r){const o=g({dispose:(0,E.once)(()=>{a(o),r()})});return o}n.toDisposable=p;class f{constructor(){this._toDispose=new Set,this._isDisposed=!1,g(this)}dispose(){this._isDisposed||(a(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){if(this._toDispose.size!==0)try{c(this._toDispose)}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return s(o,this),this._isDisposed?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}n.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new f,g(this),s(this._store,this)}dispose(){a(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}n.Disposable=y,y.None=Object.freeze({dispose(){}});class w{constructor(){this._isDisposed=!1,g(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){var l;this._isDisposed||o===this._value||((l=this._value)===null||l===void 0||l.dispose(),o&&s(o,this),this._value=o)}clear(){this.value=void 0}dispose(){var o;this._isDisposed=!0,a(this),(o=this._value)===null||o===void 0||o.dispose(),this._value=void 0}}n.MutableDisposable=w;class R{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter===0&&this._disposable.dispose(),this}}n.RefCountedDisposable=R;class S{constructor(o){this.object=o}dispose(){}}n.ImmortalReference=S;class L{constructor(){this._store=new Map,this._isDisposed=!1,g(this)}dispose(){a(this),this._isDisposed=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this._store.size)try{c(this._store.values())}finally{this._store.clear()}}get(o){return this._store.get(o)}set(o,l,_=!1){var b;this._isDisposed&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),_||(b=this._store.get(o))===null||b===void 0||b.dispose(),this._store.set(o,l)}deleteAndDispose(o){var l;(l=this._store.get(o))===null||l===void 0||l.dispose(),this._store.delete(o)}[Symbol.iterator](){return this._store[Symbol.iterator]()}}n.DisposableMap=L}),ne(ie[19],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinkedList=void 0;class E{constructor(u){this.element=u,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class M{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let u=this._first;for(;u!==E.Undefined;){const d=u.next;u.prev=E.Undefined,u.next=E.Undefined,u=d}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(u){return this._insert(u,!1)}push(u){return this._insert(u,!0)}_insert(u,d){const g=new E(u);if(this._first===E.Undefined)this._first=g,this._last=g;else if(d){const s=this._last;this._last=g,g.prev=s,s.next=g}else{const s=this._first;this._first=g,g.next=s,s.prev=g}this._size+=1;let a=!1;return()=>{a||(a=!0,this._remove(g))}}shift(){if(this._first!==E.Undefined){const u=this._first.element;return this._remove(this._first),u}}pop(){if(this._last!==E.Undefined){const u=this._last.element;return this._remove(this._last),u}}_remove(u){if(u.prev!==E.Undefined&&u.next!==E.Undefined){const d=u.prev;d.next=u.next,u.next.prev=d}else u.prev===E.Undefined&&u.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):u.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):u.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let u=this._first;for(;u!==E.Undefined;)yield u.element,u=u.next}}n.LinkedList=M}),ne(ie[20],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StopWatch=void 0;const E=globalThis.performance&&typeof globalThis.performance.now=="function";class M{static create(u){return new M(u)}constructor(u){this._now=E&&u===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this._startTime=this._now(),this._stopTime=-1}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}}n.StopWatch=M}),ne(ie[7],re([0,1,4,17,10,19,20]),function(O,n,E,M,i,u,d){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Relay=n.EventBufferer=n.EventMultiplexer=n.MicrotaskEmitter=n.DebounceEmitter=n.PauseableEmitter=n.createEventDeliveryQueue=n.Emitter=n.EventProfiling=n.Event=void 0;const g=!1,a=!1;var s;(function(b){b.None=()=>i.Disposable.None;function C($){if(a){const{onDidAddListener:H}=$,j=c.create();let G=0;$.onDidAddListener=()=>{++G===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),j.print()),H?.()}}}function A($,H){return z($,()=>{},0,void 0,!0,void 0,H)}b.defer=A;function N($){return(H,j=null,G)=>{let X=!1,te;return te=$(ae=>{if(!X)return te?te.dispose():X=!0,H.call(j,ae)},null,G),X&&te.dispose(),te}}b.once=N;function D($,H,j){return T((G,X=null,te)=>$(ae=>G.call(X,H(ae)),null,te),j)}b.map=D;function x($,H,j){return T((G,X=null,te)=>$(ae=>{H(ae),G.call(X,ae)},null,te),j)}b.forEach=x;function W($,H,j){return T((G,X=null,te)=>$(ae=>H(ae)&&G.call(X,ae),null,te),j)}b.filter=W;function I($){return $}b.signal=I;function k(...$){return(H,j=null,G)=>(0,i.combinedDisposable)(...$.map(X=>X(te=>H.call(j,te),null,G)))}b.any=k;function P($,H,j,G){let X=j;return D($,te=>(X=H(X,te),X),G)}b.reduce=P;function T($,H){let j;const G={onWillAddFirstListener(){j=$(X.fire,X)},onDidRemoveLastListener(){j?.dispose()}};H||C(G);const X=new y(G);return H?.add(X),X.event}function z($,H,j=100,G=!1,X=!1,te,ae){let oe,he,F,B=0,Q;const K={leakWarningThreshold:te,onWillAddFirstListener(){oe=$(ce=>{B++,he=H(he,ce),G&&!F&&(se.fire(he),he=void 0),Q=()=>{const _e=he;he=void 0,F=void 0,(!G||B>1)&&se.fire(_e),B=0},typeof j=="number"?(clearTimeout(F),F=setTimeout(Q,j)):F===void 0&&(F=0,queueMicrotask(Q))})},onWillRemoveListener(){X&&B>0&&Q?.()},onDidRemoveLastListener(){Q=void 0,oe.dispose()}};ae||C(K);const se=new y(K);return ae?.add(se),se.event}b.debounce=z;function U($,H=0,j){return b.debounce($,(G,X)=>G?(G.push(X),G):[X],H,void 0,!0,void 0,j)}b.accumulate=U;function Z($,H=(G,X)=>G===X,j){let G=!0,X;return W($,te=>{const ae=G||!H(te,X);return G=!1,X=te,ae},j)}b.latch=Z;function ee($,H,j){return[b.filter($,H,j),b.filter($,G=>!H(G),j)]}b.split=ee;function t($,H=!1,j=[]){let G=j.slice(),X=$(oe=>{G?G.push(oe):ae.fire(oe)});const te=()=>{G?.forEach(oe=>ae.fire(oe)),G=null},ae=new y({onWillAddFirstListener(){X||(X=$(oe=>ae.fire(oe)))},onDidAddFirstListener(){G&&(H?setTimeout(te):te())},onDidRemoveLastListener(){X&&X.dispose(),X=null}});return ae.event}b.buffer=t;class q{constructor(H){this.event=H,this.disposables=new i.DisposableStore}map(H){return new q(D(this.event,H,this.disposables))}forEach(H){return new q(x(this.event,H,this.disposables))}filter(H){return new q(W(this.event,H,this.disposables))}reduce(H,j){return new q(P(this.event,H,j,this.disposables))}latch(){return new q(Z(this.event,void 0,this.disposables))}debounce(H,j=100,G=!1,X=!1,te){return new q(z(this.event,H,j,G,X,te,this.disposables))}on(H,j,G){return this.event(H,j,G)}once(H,j,G){return N(this.event)(H,j,G)}dispose(){this.disposables.dispose()}}function V($){return new q($)}b.chain=V;function Y($,H,j=G=>G){const G=(...oe)=>ae.fire(j(...oe)),X=()=>$.on(H,G),te=()=>$.removeListener(H,G),ae=new y({onWillAddFirstListener:X,onDidRemoveLastListener:te});return ae.event}b.fromNodeEventEmitter=Y;function J($,H,j=G=>G){const G=(...oe)=>ae.fire(j(...oe)),X=()=>$.addEventListener(H,G),te=()=>$.removeEventListener(H,G),ae=new y({onWillAddFirstListener:X,onDidRemoveLastListener:te});return ae.event}b.fromDOMEventEmitter=J;function ue($){return new Promise(H=>N($)(H))}b.toPromise=ue;function le($,H){return H(void 0),$(j=>H(j))}b.runAndSubscribe=le;function fe($,H){let j=null;function G(te){j?.dispose(),j=new i.DisposableStore,H(te,j)}G(void 0);const X=$(te=>G(te));return(0,i.toDisposable)(()=>{X.dispose(),j?.dispose()})}b.runAndSubscribeWithStore=fe;class me{constructor(H,j){this._observable=H,this._counter=0,this._hasChanged=!1;const G={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};j||C(G),this.emitter=new y(G),j&&j.add(this.emitter)}beginUpdate(H){this._counter++}handlePossibleChange(H){}handleChange(H,j){this._hasChanged=!0}endUpdate(H){this._counter--,this._counter===0&&(this._observable.reportChanges(),this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this._observable.get())))}}function be($,H){return new me($,H).emitter.event}b.fromObservable=be;function ve($){return H=>{let j=0,G=!1;const X={beginUpdate(){j++},endUpdate(){j--,j===0&&($.reportChanges(),G&&(G=!1,H()))},handlePossibleChange(){},handleChange(){G=!0}};return $.addObserver(X),$.reportChanges(),{dispose(){$.removeObserver(X)}}}}b.fromObservableLight=ve})(s||(n.Event=s={}));class v{constructor(C){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${C}_${v._idPool++}`,v.all.add(this)}start(C){this._stopWatch=new d.StopWatch,this.listenerCount=C}stop(){if(this._stopWatch){const C=this._stopWatch.elapsed();this.durations.push(C),this.elapsedOverall+=C,this.invocationCount+=1,this._stopWatch=void 0}}}n.EventProfiling=v,v.all=new Set,v._idPool=0;let e=-1;class m{constructor(C,A=Math.random().toString(18).slice(2,5)){this.threshold=C,this.name=A,this._warnCountdown=0}dispose(){var C;(C=this._stacks)===null||C===void 0||C.clear()}check(C,A){const N=this.threshold;if(N<=0||A<N)return;this._stacks||(this._stacks=new Map);const D=this._stacks.get(C.value)||0;if(this._stacks.set(C.value,D+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=N*.5;let x,W=0;for(const[I,k]of this._stacks)(!x||W<k)&&(x=I,W=k);console.warn(`[${this.name}] potential listener LEAK detected, having ${A} listeners already. MOST frequent listener (${W}):`),console.warn(x)}return()=>{const x=this._stacks.get(C.value)||0;this._stacks.set(C.value,x-1)}}}class c{static create(){var C;return new c((C=new Error().stack)!==null&&C!==void 0?C:"")}constructor(C){this.value=C}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class h{constructor(C){this.value=C}}const p=2,f=(b,C)=>{if(b instanceof h)C(b);else for(let A=0;A<b.length;A++){const N=b[A];N&&C(N)}};class y{constructor(C){var A,N,D,x,W;this._size=0,this._options=C,this._leakageMon=e>0||!((A=this._options)===null||A===void 0)&&A.leakWarningThreshold?new m((D=(N=this._options)===null||N===void 0?void 0:N.leakWarningThreshold)!==null&&D!==void 0?D:e):void 0,this._perfMon=!((x=this._options)===null||x===void 0)&&x._profName?new v(this._options._profName):void 0,this._deliveryQueue=(W=this._options)===null||W===void 0?void 0:W.deliveryQueue}dispose(){var C,A,N,D;if(!this._disposed){if(this._disposed=!0,((C=this._deliveryQueue)===null||C===void 0?void 0:C.current)===this&&this._deliveryQueue.reset(),this._listeners){if(g){const x=this._listeners;queueMicrotask(()=>{f(x,W=>{var I;return(I=W.stack)===null||I===void 0?void 0:I.print()})})}this._listeners=void 0,this._size=0}(N=(A=this._options)===null||A===void 0?void 0:A.onDidRemoveLastListener)===null||N===void 0||N.call(A),(D=this._leakageMon)===null||D===void 0||D.dispose()}}get event(){var C;return(C=this._event)!==null&&C!==void 0||(this._event=(A,N,D)=>{var x,W,I,k,P;if(this._leakageMon&&this._size>this._leakageMon.threshold*3)return console.warn(`[${this._leakageMon.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;if(this._disposed)return i.Disposable.None;N&&(A=A.bind(N));const T=new h(A);let z,U;this._leakageMon&&this._size>=Math.ceil(this._leakageMon.threshold*.2)&&(T.stack=c.create(),z=this._leakageMon.check(T.stack,this._size+1)),g&&(T.stack=U??c.create()),this._listeners?this._listeners instanceof h?((P=this._deliveryQueue)!==null&&P!==void 0||(this._deliveryQueue=new R),this._listeners=[this._listeners,T]):this._listeners.push(T):((W=(x=this._options)===null||x===void 0?void 0:x.onWillAddFirstListener)===null||W===void 0||W.call(x,this),this._listeners=T,(k=(I=this._options)===null||I===void 0?void 0:I.onDidAddFirstListener)===null||k===void 0||k.call(I,this)),this._size++;const Z=(0,i.toDisposable)(()=>{z?.(),this._removeListener(T)});return D instanceof i.DisposableStore?D.add(Z):Array.isArray(D)&&D.push(Z),Z}),this._event}_removeListener(C){var A,N,D,x;if((N=(A=this._options)===null||A===void 0?void 0:A.onWillRemoveListener)===null||N===void 0||N.call(A,this),!this._listeners)return;if(this._size===1){this._listeners=void 0,(x=(D=this._options)===null||D===void 0?void 0:D.onDidRemoveLastListener)===null||x===void 0||x.call(D,this),this._size=0;return}const W=this._listeners,I=W.indexOf(C);if(I===-1)throw console.log("disposed?",this._disposed),console.log("size?",this._size),console.log("arr?",JSON.stringify(this._listeners)),new Error("Attempted to dispose unknown listener");this._size--,W[I]=void 0;const k=this._deliveryQueue.current===this;if(this._size*p<=W.length){let P=0;for(let T=0;T<W.length;T++)W[T]?W[P++]=W[T]:k&&(this._deliveryQueue.end--,P<this._deliveryQueue.i&&this._deliveryQueue.i--);W.length=P}}_deliver(C,A){var N;if(!C)return;const D=((N=this._options)===null||N===void 0?void 0:N.onListenerError)||E.onUnexpectedError;if(!D){C.value(A);return}try{C.value(A)}catch(x){D(x)}}_deliverQueue(C){const A=C.current._listeners;for(;C.i<C.end;)this._deliver(A[C.i++],C.value);C.reset()}fire(C){var A,N,D,x;if(!((A=this._deliveryQueue)===null||A===void 0)&&A.current&&(this._deliverQueue(this._deliveryQueue),(N=this._perfMon)===null||N===void 0||N.stop()),(D=this._perfMon)===null||D===void 0||D.start(this._size),this._listeners)if(this._listeners instanceof h)this._deliver(this._listeners,C);else{const W=this._deliveryQueue;W.enqueue(this,C,this._listeners.length),this._deliverQueue(W)}(x=this._perfMon)===null||x===void 0||x.stop()}hasListeners(){return this._size>0}}n.Emitter=y;const w=()=>new R;n.createEventDeliveryQueue=w;class R{constructor(){this.i=-1,this.end=0}enqueue(C,A,N){this.i=0,this.end=N,this.current=C,this.value=A}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class S extends y{constructor(C){super(C),this._isPaused=0,this._eventQueue=new u.LinkedList,this._mergeFn=C?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused===0)if(this._mergeFn){if(this._eventQueue.size>0){const C=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(C))}}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(C){this._size&&(this._isPaused!==0?this._eventQueue.push(C):super.fire(C))}}n.PauseableEmitter=S;class L extends S{constructor(C){var A;super(C),this._delay=(A=C.delay)!==null&&A!==void 0?A:100}fire(C){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(C)}}n.DebounceEmitter=L;class r extends y{constructor(C){super(C),this._queuedEvents=[],this._mergeFn=C?.merge}fire(C){this.hasListeners()&&(this._queuedEvents.push(C),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(A=>super.fire(A)),this._queuedEvents=[]}))}}n.MicrotaskEmitter=r;class o{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new y({onWillAddFirstListener:()=>this.onFirstListenerAdd(),onDidRemoveLastListener:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(C){const A={event:C,listener:null};this.events.push(A),this.hasListeners&&this.hook(A);const N=()=>{this.hasListeners&&this.unhook(A);const D=this.events.indexOf(A);this.events.splice(D,1)};return(0,i.toDisposable)((0,M.once)(N))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(C=>this.hook(C))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(C=>this.unhook(C))}hook(C){C.listener=C.event(A=>this.emitter.fire(A))}unhook(C){C.listener&&C.listener.dispose(),C.listener=null}dispose(){this.emitter.dispose()}}n.EventMultiplexer=o;class l{constructor(){this.buffers=[]}wrapEvent(C){return(A,N,D)=>C(x=>{const W=this.buffers[this.buffers.length-1];W?W.push(()=>A.call(N,x)):A.call(N,x)},void 0,D)}bufferEvents(C){const A=[];this.buffers.push(A);const N=C();return this.buffers.pop(),A.forEach(D=>D()),N}}n.EventBufferer=l;class _{constructor(){this.listening=!1,this.inputEvent=s.None,this.inputEventListener=i.Disposable.None,this.emitter=new y({onDidAddFirstListener:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onDidRemoveLastListener:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(C){this.inputEvent=C,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=C(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}n.Relay=_}),ne(ie[33],re([0,1,7]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CancellationTokenSource=n.CancellationToken=void 0;const M=Object.freeze(function(g,a){const s=setTimeout(g.bind(a),0);return{dispose(){clearTimeout(s)}}});var i;(function(g){function a(s){return s===g.None||s===g.Cancelled||s instanceof u?!0:!s||typeof s!="object"?!1:typeof s.isCancellationRequested=="boolean"&&typeof s.onCancellationRequested=="function"}g.isCancellationToken=a,g.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),g.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(i||(n.CancellationToken=i={}));class u{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?M:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class d{constructor(a){this._token=void 0,this._parentListener=void 0,this._parentListener=a&&a.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new u),this._token}cancel(){this._token?this._token instanceof u&&this._token.cancel():this._token=i.Cancelled}dispose(a=!1){var s;a&&this.cancel(),(s=this._parentListener)===null||s===void 0||s.dispose(),this._token?this._token instanceof u&&this._token.dispose():this._token=i.None}}n.CancellationTokenSource=d}),ne(ie[5],re([0,1,27,32]),function(O,n,E,M){"use strict";var i;Object.defineProperty(n,"__esModule",{value:!0}),n.InvisibleCharacters=n.AmbiguousCharacters=n.noBreakWhitespace=n.getLeftDeleteOffset=n.singleLetterHash=n.containsUppercaseCharacter=n.startsWithUTF8BOM=n.UTF8_BOM_CHARACTER=n.isEmojiImprecise=n.isFullWidthCharacter=n.containsUnusualLineTerminators=n.UNUSUAL_LINE_TERMINATORS=n.isBasicASCII=n.containsRTL=n.getCharContainingOffset=n.prevCharLength=n.nextCharLength=n.GraphemeIterator=n.CodePointIterator=n.getNextCodePoint=n.computeCodePoint=n.isLowSurrogate=n.isHighSurrogate=n.commonSuffixLength=n.commonPrefixLength=n.startsWithIgnoreCase=n.equalsIgnoreCase=n.isUpperAsciiLetter=n.isLowerAsciiLetter=n.isAsciiDigit=n.compareSubstringIgnoreCase=n.compareIgnoreCase=n.compareSubstring=n.compare=n.lastNonWhitespaceIndex=n.getLeadingWhitespace=n.firstNonWhitespaceIndex=n.splitLines=n.regExpLeadsToEndlessLoop=n.createRegExp=n.stripWildcards=n.convertSimple2RegExpPattern=n.rtrim=n.ltrim=n.trim=n.escapeRegExpCharacters=n.escape=n.format=n.isFalsyOrWhitespace=void 0;function u(F){return!F||typeof F!="string"?!0:F.trim().length===0}n.isFalsyOrWhitespace=u;const d=/{(\d+)}/g;function g(F,...B){return B.length===0?F:F.replace(d,function(Q,K){const se=parseInt(K,10);return isNaN(se)||se<0||se>=B.length?Q:B[se]})}n.format=g;function a(F){return F.replace(/[<>&]/g,function(B){switch(B){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return B}})}n.escape=a;function s(F){return F.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}n.escapeRegExpCharacters=s;function v(F,B=" "){const Q=e(F,B);return m(Q,B)}n.trim=v;function e(F,B){if(!F||!B)return F;const Q=B.length;if(Q===0||F.length===0)return F;let K=0;for(;F.indexOf(B,K)===K;)K=K+Q;return F.substring(K)}n.ltrim=e;function m(F,B){if(!F||!B)return F;const Q=B.length,K=F.length;if(Q===0||K===0)return F;let se=K,ce=-1;for(;ce=F.lastIndexOf(B,se-1),!(ce===-1||ce+Q!==se);){if(ce===0)return"";se=ce}return F.substring(0,se)}n.rtrim=m;function c(F){return F.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}n.convertSimple2RegExpPattern=c;function h(F){return F.replace(/\*/g,"")}n.stripWildcards=h;function p(F,B,Q={}){if(!F)throw new Error("Cannot create regex from empty string");B||(F=s(F)),Q.wholeWord&&(/\B/.test(F.charAt(0))||(F="\\b"+F),/\B/.test(F.charAt(F.length-1))||(F=F+"\\b"));let K="";return Q.global&&(K+="g"),Q.matchCase||(K+="i"),Q.multiline&&(K+="m"),Q.unicode&&(K+="u"),new RegExp(F,K)}n.createRegExp=p;function f(F){return F.source==="^"||F.source==="^$"||F.source==="$"||F.source==="^\\s*$"?!1:!!(F.exec("")&&F.lastIndex===0)}n.regExpLeadsToEndlessLoop=f;function y(F){return F.split(/\r\n|\r|\n/)}n.splitLines=y;function w(F){for(let B=0,Q=F.length;B<Q;B++){const K=F.charCodeAt(B);if(K!==32&&K!==9)return B}return-1}n.firstNonWhitespaceIndex=w;function R(F,B=0,Q=F.length){for(let K=B;K<Q;K++){const se=F.charCodeAt(K);if(se!==32&&se!==9)return F.substring(B,K)}return F.substring(B,Q)}n.getLeadingWhitespace=R;function S(F,B=F.length-1){for(let Q=B;Q>=0;Q--){const K=F.charCodeAt(Q);if(K!==32&&K!==9)return Q}return-1}n.lastNonWhitespaceIndex=S;function L(F,B){return F<B?-1:F>B?1:0}n.compare=L;function r(F,B,Q=0,K=F.length,se=0,ce=B.length){for(;Q<K&&se<ce;Q++,se++){const Ce=F.charCodeAt(Q),de=B.charCodeAt(se);if(Ce<de)return-1;if(Ce>de)return 1}const _e=K-Q,Se=ce-se;return _e<Se?-1:_e>Se?1:0}n.compareSubstring=r;function o(F,B){return l(F,B,0,F.length,0,B.length)}n.compareIgnoreCase=o;function l(F,B,Q=0,K=F.length,se=0,ce=B.length){for(;Q<K&&se<ce;Q++,se++){let Ce=F.charCodeAt(Q),de=B.charCodeAt(se);if(Ce===de)continue;if(Ce>=128||de>=128)return r(F.toLowerCase(),B.toLowerCase(),Q,K,se,ce);b(Ce)&&(Ce-=32),b(de)&&(de-=32);const Le=Ce-de;if(Le!==0)return Le}const _e=K-Q,Se=ce-se;return _e<Se?-1:_e>Se?1:0}n.compareSubstringIgnoreCase=l;function _(F){return F>=48&&F<=57}n.isAsciiDigit=_;function b(F){return F>=97&&F<=122}n.isLowerAsciiLetter=b;function C(F){return F>=65&&F<=90}n.isUpperAsciiLetter=C;function A(F,B){return F.length===B.length&&l(F,B)===0}n.equalsIgnoreCase=A;function N(F,B){const Q=B.length;return B.length>F.length?!1:l(F,B,0,Q)===0}n.startsWithIgnoreCase=N;function D(F,B){const Q=Math.min(F.length,B.length);let K;for(K=0;K<Q;K++)if(F.charCodeAt(K)!==B.charCodeAt(K))return K;return Q}n.commonPrefixLength=D;function x(F,B){const Q=Math.min(F.length,B.length);let K;const se=F.length-1,ce=B.length-1;for(K=0;K<Q;K++)if(F.charCodeAt(se-K)!==B.charCodeAt(ce-K))return K;return Q}n.commonSuffixLength=x;function W(F){return 55296<=F&&F<=56319}n.isHighSurrogate=W;function I(F){return 56320<=F&&F<=57343}n.isLowSurrogate=I;function k(F,B){return(F-55296<<10)+(B-56320)+65536}n.computeCodePoint=k;function P(F,B,Q){const K=F.charCodeAt(Q);if(W(K)&&Q+1<B){const se=F.charCodeAt(Q+1);if(I(se))return k(K,se)}return K}n.getNextCodePoint=P;function T(F,B){const Q=F.charCodeAt(B-1);if(I(Q)&&B>1){const K=F.charCodeAt(B-2);if(W(K))return k(K,Q)}return Q}class z{get offset(){return this._offset}constructor(B,Q=0){this._str=B,this._len=B.length,this._offset=Q}setOffset(B){this._offset=B}prevCodePoint(){const B=T(this._str,this._offset);return this._offset-=B>=65536?2:1,B}nextCodePoint(){const B=P(this._str,this._len,this._offset);return this._offset+=B>=65536?2:1,B}eol(){return this._offset>=this._len}}n.CodePointIterator=z;class U{get offset(){return this._iterator.offset}constructor(B,Q=0){this._iterator=new z(B,Q)}nextGraphemeLength(){const B=j.getInstance(),Q=this._iterator,K=Q.offset;let se=B.getGraphemeBreakType(Q.nextCodePoint());for(;!Q.eol();){const ce=Q.offset,_e=B.getGraphemeBreakType(Q.nextCodePoint());if(H(se,_e)){Q.setOffset(ce);break}se=_e}return Q.offset-K}prevGraphemeLength(){const B=j.getInstance(),Q=this._iterator,K=Q.offset;let se=B.getGraphemeBreakType(Q.prevCodePoint());for(;Q.offset>0;){const ce=Q.offset,_e=B.getGraphemeBreakType(Q.prevCodePoint());if(H(_e,se)){Q.setOffset(ce);break}se=_e}return K-Q.offset}eol(){return this._iterator.eol()}}n.GraphemeIterator=U;function Z(F,B){return new U(F,B).nextGraphemeLength()}n.nextCharLength=Z;function ee(F,B){return new U(F,B).prevGraphemeLength()}n.prevCharLength=ee;function t(F,B){B>0&&I(F.charCodeAt(B))&&B--;const Q=B+Z(F,B);return[Q-ee(F,Q),Q]}n.getCharContainingOffset=t;let q;function V(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Y(F){return q||(q=V()),q.test(F)}n.containsRTL=Y;const J=/^[\t\n\r\x20-\x7E]*$/;function ue(F){return J.test(F)}n.isBasicASCII=ue,n.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function le(F){return n.UNUSUAL_LINE_TERMINATORS.test(F)}n.containsUnusualLineTerminators=le;function fe(F){return F>=11904&&F<=55215||F>=63744&&F<=64255||F>=65281&&F<=65374}n.isFullWidthCharacter=fe;function me(F){return F>=127462&&F<=127487||F===8986||F===8987||F===9200||F===9203||F>=9728&&F<=10175||F===11088||F===11093||F>=127744&&F<=128591||F>=128640&&F<=128764||F>=128992&&F<=129008||F>=129280&&F<=129535||F>=129648&&F<=129782}n.isEmojiImprecise=me,n.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(F){return!!(F&&F.length>0&&F.charCodeAt(0)===65279)}n.startsWithUTF8BOM=be;function ve(F,B=!1){return F?(B&&(F=F.replace(/\\./g,"")),F.toLowerCase()!==F):!1}n.containsUppercaseCharacter=ve;function $(F){return F=F%(2*26),F<26?String.fromCharCode(97+F):String.fromCharCode(65+F-26)}n.singleLetterHash=$;function H(F,B){return F===0?B!==5&&B!==7:F===2&&B===3?!1:F===4||F===2||F===3||B===4||B===2||B===3?!0:!(F===8&&(B===8||B===9||B===11||B===12)||(F===11||F===9)&&(B===9||B===10)||(F===12||F===10)&&B===10||B===5||B===13||B===7||F===1||F===13&&B===14||F===6&&B===6)}class j{static getInstance(){return j._INSTANCE||(j._INSTANCE=new j),j._INSTANCE}constructor(){this._data=G()}getGraphemeBreakType(B){if(B<32)return B===10?3:B===13?2:4;if(B<127)return 0;const Q=this._data,K=Q.length/3;let se=1;for(;se<=K;)if(B<Q[3*se])se=2*se;else if(B>Q[3*se+1])se=2*se+1;else return Q[3*se+2];return 0}}j._INSTANCE=null;function G(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function X(F,B){if(F===0)return 0;const Q=te(F,B);if(Q!==void 0)return Q;const K=new z(B,F);return K.prevCodePoint(),K.offset}n.getLeftDeleteOffset=X;function te(F,B){const Q=new z(B,F);let K=Q.prevCodePoint();for(;ae(K)||K===65039||K===8419;){if(Q.offset===0)return;K=Q.prevCodePoint()}if(!me(K))return;let se=Q.offset;return se>0&&Q.prevCodePoint()===8205&&(se=Q.offset),se}function ae(F){return 127995<=F&&F<=127999}n.noBreakWhitespace="\xA0";class oe{static getInstance(B){return i.cache.get(Array.from(B))}static getLocales(){return i._locales.value}constructor(B){this.confusableDictionary=B}isAmbiguous(B){return this.confusableDictionary.has(B)}getPrimaryConfusable(B){return this.confusableDictionary.get(B)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}n.AmbiguousCharacters=oe,i=oe,oe.ambiguousCharacterData=new M.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),oe.cache=new E.LRUCachedFunction(F=>{function B(de){const Le=new Map;for(let we=0;we<de.length;we+=2)Le.set(de[we],de[we+1]);return Le}function Q(de,Le){const we=new Map(de);for(const[ye,Re]of Le)we.set(ye,Re);return we}function K(de,Le){if(!de)return Le;const we=new Map;for(const[ye,Re]of de)Le.has(ye)&&we.set(ye,Re);return we}const se=i.ambiguousCharacterData.value;let ce=F.filter(de=>!de.startsWith("_")&&de in se);ce.length===0&&(ce=["_default"]);let _e;for(const de of ce){const Le=B(se[de]);_e=K(_e,Le)}const Se=B(se._common),Ce=Q(Se,_e);return new i(Ce)}),oe._locales=new M.Lazy(()=>Object.keys(i.ambiguousCharacterData.value).filter(F=>!F.startsWith("_")));class he{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(he.getRawData())),this._data}static isInvisibleCharacter(B){return he.getData().has(B)}static get codePoints(){return he.getData()}}n.InvisibleCharacters=he,he._data=void 0}),ne(ie[34],re([0,1,5]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.StringSHA1=n.toHexString=n.stringHash=n.numberHash=n.doHash=n.hash=void 0;function M(p){return i(p,0)}n.hash=M;function i(p,f){switch(typeof p){case"object":return p===null?u(349,f):Array.isArray(p)?a(p,f):s(p,f);case"string":return g(p,f);case"boolean":return d(p,f);case"number":return u(p,f);case"undefined":return u(937,f);default:return u(617,f)}}n.doHash=i;function u(p,f){return(f<<5)-f+p|0}n.numberHash=u;function d(p,f){return u(p?433:863,f)}function g(p,f){f=u(149417,f);for(let y=0,w=p.length;y<w;y++)f=u(p.charCodeAt(y),f);return f}n.stringHash=g;function a(p,f){return f=u(104579,f),p.reduce((y,w)=>i(w,y),f)}function s(p,f){return f=u(181387,f),Object.keys(p).sort().reduce((y,w)=>(y=g(w,y),i(p[w],y)),f)}function v(p,f,y=32){const w=y-f,R=~((1<<w)-1);return(p<<f|(R&p)>>>w)>>>0}function e(p,f=0,y=p.byteLength,w=0){for(let R=0;R<y;R++)p[f+R]=w}function m(p,f,y="0"){for(;p.length<f;)p=y+p;return p}function c(p,f=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(y=>y.toString(16).padStart(2,"0")).join(""):m((p>>>0).toString(16),f/4)}n.toHexString=c;class h{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(f){const y=f.length;if(y===0)return;const w=this._buff;let R=this._buffLen,S=this._leftoverHighSurrogate,L,r;for(S!==0?(L=S,r=-1,S=0):(L=f.charCodeAt(0),r=0);;){let o=L;if(E.isHighSurrogate(L))if(r+1<y){const l=f.charCodeAt(r+1);E.isLowSurrogate(l)?(r++,o=E.computeCodePoint(L,l)):o=65533}else{S=L;break}else E.isLowSurrogate(L)&&(o=65533);if(R=this._push(w,R,o),r++,r<y)L=f.charCodeAt(r);else break}this._buffLen=R,this._leftoverHighSurrogate=S}_push(f,y,w){return w<128?f[y++]=w:w<2048?(f[y++]=192|(w&1984)>>>6,f[y++]=128|(w&63)>>>0):w<65536?(f[y++]=224|(w&61440)>>>12,f[y++]=128|(w&4032)>>>6,f[y++]=128|(w&63)>>>0):(f[y++]=240|(w&1835008)>>>18,f[y++]=128|(w&258048)>>>12,f[y++]=128|(w&4032)>>>6,f[y++]=128|(w&63)>>>0),y>=64&&(this._step(),y-=64,this._totalLen+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),y}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),c(this._h0)+c(this._h1)+c(this._h2)+c(this._h3)+c(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,e(this._buff,this._buffLen),this._buffLen>56&&(this._step(),e(this._buff));const f=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(f/4294967296),!1),this._buffDV.setUint32(60,f%4294967296,!1),this._step()}_step(){const f=h._bigBlock32,y=this._buffDV;for(let b=0;b<64;b+=4)f.setUint32(b,y.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)f.setUint32(b,v(f.getUint32(b-12,!1)^f.getUint32(b-32,!1)^f.getUint32(b-56,!1)^f.getUint32(b-64,!1),1),!1);let w=this._h0,R=this._h1,S=this._h2,L=this._h3,r=this._h4,o,l,_;for(let b=0;b<80;b++)b<20?(o=R&S|~R&L,l=1518500249):b<40?(o=R^S^L,l=1859775393):b<60?(o=R&S|R&L|S&L,l=2400959708):(o=R^S^L,l=3395469782),_=v(w,5)+o+r+l+f.getUint32(b*4,!1)&4294967295,r=L,L=S,S=v(R,30),R=w,w=_;this._h0=this._h0+w&4294967295,this._h1=this._h1+R&4294967295,this._h2=this._h2+S&4294967295,this._h3=this._h3+L&4294967295,this._h4=this._h4+r&4294967295}}n.StringSHA1=h,h._bigBlock32=new DataView(new ArrayBuffer(320))}),ne(ie[21],re([0,1,30,34]),function(O,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LcsDiff=n.stringDiff=n.StringDiffSequence=void 0;class i{constructor(e){this.source=e}getElements(){const e=this.source,m=new Int32Array(e.length);for(let c=0,h=e.length;c<h;c++)m[c]=e.charCodeAt(c);return m}}n.StringDiffSequence=i;function u(v,e,m){return new s(new i(v),new i(e)).ComputeDiff(m).changes}n.stringDiff=u;class d{static Assert(e,m){if(!e)throw new Error(m)}}class g{static Copy(e,m,c,h,p){for(let f=0;f<p;f++)c[h+f]=e[m+f]}static Copy2(e,m,c,h,p){for(let f=0;f<p;f++)c[h+f]=e[m+f]}}class a{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new E.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(e,m){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,m),this.m_originalCount++}AddModifiedElement(e,m){this.m_originalStart=Math.min(this.m_originalStart,e),this.m_modifiedStart=Math.min(this.m_modifiedStart,m),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class s{constructor(e,m,c=null){this.ContinueProcessingPredicate=c,this._originalSequence=e,this._modifiedSequence=m;const[h,p,f]=s._getElements(e),[y,w,R]=s._getElements(m);this._hasStrings=f&&R,this._originalStringElements=h,this._originalElementsOrHash=p,this._modifiedStringElements=y,this._modifiedElementsOrHash=w,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(e){return e.length>0&&typeof e[0]=="string"}static _getElements(e){const m=e.getElements();if(s._isStringArray(m)){const c=new Int32Array(m.length);for(let h=0,p=m.length;h<p;h++)c[h]=(0,M.stringHash)(m[h],0);return[m,c,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}ElementsAreEqual(e,m){return this._originalElementsOrHash[e]!==this._modifiedElementsOrHash[m]?!1:this._hasStrings?this._originalStringElements[e]===this._modifiedStringElements[m]:!0}ElementsAreStrictEqual(e,m){if(!this.ElementsAreEqual(e,m))return!1;const c=s._getStrictElement(this._originalSequence,e),h=s._getStrictElement(this._modifiedSequence,m);return c===h}static _getStrictElement(e,m){return typeof e.getStrictElement=="function"?e.getStrictElement(m):null}OriginalElementsAreEqual(e,m){return this._originalElementsOrHash[e]!==this._originalElementsOrHash[m]?!1:this._hasStrings?this._originalStringElements[e]===this._originalStringElements[m]:!0}ModifiedElementsAreEqual(e,m){return this._modifiedElementsOrHash[e]!==this._modifiedElementsOrHash[m]?!1:this._hasStrings?this._modifiedStringElements[e]===this._modifiedStringElements[m]:!0}ComputeDiff(e){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,e)}_ComputeDiff(e,m,c,h,p){const f=[!1];let y=this.ComputeDiffRecursive(e,m,c,h,f);return p&&(y=this.PrettifyChanges(y)),{quitEarly:f[0],changes:y}}ComputeDiffRecursive(e,m,c,h,p){for(p[0]=!1;e<=m&&c<=h&&this.ElementsAreEqual(e,c);)e++,c++;for(;m>=e&&h>=c&&this.ElementsAreEqual(m,h);)m--,h--;if(e>m||c>h){let L;return c<=h?(d.Assert(e===m+1,"originalStart should only be one more than originalEnd"),L=[new E.DiffChange(e,0,c,h-c+1)]):e<=m?(d.Assert(c===h+1,"modifiedStart should only be one more than modifiedEnd"),L=[new E.DiffChange(e,m-e+1,c,0)]):(d.Assert(e===m+1,"originalStart should only be one more than originalEnd"),d.Assert(c===h+1,"modifiedStart should only be one more than modifiedEnd"),L=[]),L}const f=[0],y=[0],w=this.ComputeRecursionPoint(e,m,c,h,f,y,p),R=f[0],S=y[0];if(w!==null)return w;if(!p[0]){const L=this.ComputeDiffRecursive(e,R,c,S,p);let r=[];return p[0]?r=[new E.DiffChange(R+1,m-(R+1)+1,S+1,h-(S+1)+1)]:r=this.ComputeDiffRecursive(R+1,m,S+1,h,p),this.ConcatenateChanges(L,r)}return[new E.DiffChange(e,m-e+1,c,h-c+1)]}WALKTRACE(e,m,c,h,p,f,y,w,R,S,L,r,o,l,_,b,C,A){let N=null,D=null,x=new a,W=m,I=c,k=o[0]-b[0]-h,P=-1073741824,T=this.m_forwardHistory.length-1;do{const z=k+e;z===W||z<I&&R[z-1]<R[z+1]?(L=R[z+1],l=L-k-h,L<P&&x.MarkNextChange(),P=L,x.AddModifiedElement(L+1,l),k=z+1-e):(L=R[z-1]+1,l=L-k-h,L<P&&x.MarkNextChange(),P=L-1,x.AddOriginalElement(L,l+1),k=z-1-e),T>=0&&(R=this.m_forwardHistory[T],e=R[0],W=1,I=R.length-1)}while(--T>=-1);if(N=x.getReverseChanges(),A[0]){let z=o[0]+1,U=b[0]+1;if(N!==null&&N.length>0){const Z=N[N.length-1];z=Math.max(z,Z.getOriginalEnd()),U=Math.max(U,Z.getModifiedEnd())}D=[new E.DiffChange(z,r-z+1,U,_-U+1)]}else{x=new a,W=f,I=y,k=o[0]-b[0]-w,P=1073741824,T=C?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const z=k+p;z===W||z<I&&S[z-1]>=S[z+1]?(L=S[z+1]-1,l=L-k-w,L>P&&x.MarkNextChange(),P=L+1,x.AddOriginalElement(L+1,l+1),k=z+1-p):(L=S[z-1],l=L-k-w,L>P&&x.MarkNextChange(),P=L,x.AddModifiedElement(L+1,l+1),k=z-1-p),T>=0&&(S=this.m_reverseHistory[T],p=S[0],W=1,I=S.length-1)}while(--T>=-1);D=x.getChanges()}return this.ConcatenateChanges(N,D)}ComputeRecursionPoint(e,m,c,h,p,f,y){let w=0,R=0,S=0,L=0,r=0,o=0;e--,c--,p[0]=0,f[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const l=m-e+(h-c),_=l+1,b=new Int32Array(_),C=new Int32Array(_),A=h-c,N=m-e,D=e-c,x=m-h,I=(N-A)%2===0;b[A]=e,C[N]=m,y[0]=!1;for(let k=1;k<=l/2+1;k++){let P=0,T=0;S=this.ClipDiagonalBound(A-k,k,A,_),L=this.ClipDiagonalBound(A+k,k,A,_);for(let U=S;U<=L;U+=2){U===S||U<L&&b[U-1]<b[U+1]?w=b[U+1]:w=b[U-1]+1,R=w-(U-A)-D;const Z=w;for(;w<m&&R<h&&this.ElementsAreEqual(w+1,R+1);)w++,R++;if(b[U]=w,w+R>P+T&&(P=w,T=R),!I&&Math.abs(U-N)<=k-1&&w>=C[U])return p[0]=w,f[0]=R,Z<=C[U]&&1447>0&&k<=1447+1?this.WALKTRACE(A,S,L,D,N,r,o,x,b,C,w,m,p,R,h,f,I,y):null}const z=(P-e+(T-c)-k)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(P,z))return y[0]=!0,p[0]=P,f[0]=T,z>0&&1447>0&&k<=1447+1?this.WALKTRACE(A,S,L,D,N,r,o,x,b,C,w,m,p,R,h,f,I,y):(e++,c++,[new E.DiffChange(e,m-e+1,c,h-c+1)]);r=this.ClipDiagonalBound(N-k,k,N,_),o=this.ClipDiagonalBound(N+k,k,N,_);for(let U=r;U<=o;U+=2){U===r||U<o&&C[U-1]>=C[U+1]?w=C[U+1]-1:w=C[U-1],R=w-(U-N)-x;const Z=w;for(;w>e&&R>c&&this.ElementsAreEqual(w,R);)w--,R--;if(C[U]=w,I&&Math.abs(U-A)<=k&&w<=b[U])return p[0]=w,f[0]=R,Z>=b[U]&&1447>0&&k<=1447+1?this.WALKTRACE(A,S,L,D,N,r,o,x,b,C,w,m,p,R,h,f,I,y):null}if(k<=1447){let U=new Int32Array(L-S+2);U[0]=A-S+1,g.Copy2(b,S,U,1,L-S+1),this.m_forwardHistory.push(U),U=new Int32Array(o-r+2),U[0]=N-r+1,g.Copy2(C,r,U,1,o-r+1),this.m_reverseHistory.push(U)}}return this.WALKTRACE(A,S,L,D,N,r,o,x,b,C,w,m,p,R,h,f,I,y)}PrettifyChanges(e){for(let m=0;m<e.length;m++){const c=e[m],h=m<e.length-1?e[m+1].originalStart:this._originalElementsOrHash.length,p=m<e.length-1?e[m+1].modifiedStart:this._modifiedElementsOrHash.length,f=c.originalLength>0,y=c.modifiedLength>0;for(;c.originalStart+c.originalLength<h&&c.modifiedStart+c.modifiedLength<p&&(!f||this.OriginalElementsAreEqual(c.originalStart,c.originalStart+c.originalLength))&&(!y||this.ModifiedElementsAreEqual(c.modifiedStart,c.modifiedStart+c.modifiedLength));){const R=this.ElementsAreStrictEqual(c.originalStart,c.modifiedStart);if(this.ElementsAreStrictEqual(c.originalStart+c.originalLength,c.modifiedStart+c.modifiedLength)&&!R)break;c.originalStart++,c.modifiedStart++}const w=[null];if(m<e.length-1&&this.ChangesOverlap(e[m],e[m+1],w)){e[m]=w[0],e.splice(m+1,1),m--;continue}}for(let m=e.length-1;m>=0;m--){const c=e[m];let h=0,p=0;if(m>0){const L=e[m-1];h=L.originalStart+L.originalLength,p=L.modifiedStart+L.modifiedLength}const f=c.originalLength>0,y=c.modifiedLength>0;let w=0,R=this._boundaryScore(c.originalStart,c.originalLength,c.modifiedStart,c.modifiedLength);for(let L=1;;L++){const r=c.originalStart-L,o=c.modifiedStart-L;if(r<h||o<p||f&&!this.OriginalElementsAreEqual(r,r+c.originalLength)||y&&!this.ModifiedElementsAreEqual(o,o+c.modifiedLength))break;const _=(r===h&&o===p?5:0)+this._boundaryScore(r,c.originalLength,o,c.modifiedLength);_>R&&(R=_,w=L)}c.originalStart-=w,c.modifiedStart-=w;const S=[null];if(m>0&&this.ChangesOverlap(e[m-1],e[m],S)){e[m-1]=S[0],e.splice(m,1),m++;continue}}if(this._hasStrings)for(let m=1,c=e.length;m<c;m++){const h=e[m-1],p=e[m],f=p.originalStart-h.originalStart-h.originalLength,y=h.originalStart,w=p.originalStart+p.originalLength,R=w-y,S=h.modifiedStart,L=p.modifiedStart+p.modifiedLength,r=L-S;if(f<5&&R<20&&r<20){const o=this._findBetterContiguousSequence(y,R,S,r,f);if(o){const[l,_]=o;(l!==h.originalStart+h.originalLength||_!==h.modifiedStart+h.modifiedLength)&&(h.originalLength=l-h.originalStart,h.modifiedLength=_-h.modifiedStart,p.originalStart=l+f,p.modifiedStart=_+f,p.originalLength=w-p.originalStart,p.modifiedLength=L-p.modifiedStart)}}}return e}_findBetterContiguousSequence(e,m,c,h,p){if(m<p||h<p)return null;const f=e+m-p+1,y=c+h-p+1;let w=0,R=0,S=0;for(let L=e;L<f;L++)for(let r=c;r<y;r++){const o=this._contiguousSequenceScore(L,r,p);o>0&&o>w&&(w=o,R=L,S=r)}return w>0?[R,S]:null}_contiguousSequenceScore(e,m,c){let h=0;for(let p=0;p<c;p++){if(!this.ElementsAreEqual(e+p,m+p))return 0;h+=this._originalStringElements[e+p].length}return h}_OriginalIsBoundary(e){return e<=0||e>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[e])}_OriginalRegionIsBoundary(e,m){if(this._OriginalIsBoundary(e)||this._OriginalIsBoundary(e-1))return!0;if(m>0){const c=e+m;if(this._OriginalIsBoundary(c-1)||this._OriginalIsBoundary(c))return!0}return!1}_ModifiedIsBoundary(e){return e<=0||e>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[e])}_ModifiedRegionIsBoundary(e,m){if(this._ModifiedIsBoundary(e)||this._ModifiedIsBoundary(e-1))return!0;if(m>0){const c=e+m;if(this._ModifiedIsBoundary(c-1)||this._ModifiedIsBoundary(c))return!0}return!1}_boundaryScore(e,m,c,h){const p=this._OriginalRegionIsBoundary(e,m)?1:0,f=this._ModifiedRegionIsBoundary(c,h)?1:0;return p+f}ConcatenateChanges(e,m){const c=[];if(e.length===0||m.length===0)return m.length>0?m:e;if(this.ChangesOverlap(e[e.length-1],m[0],c)){const h=new Array(e.length+m.length-1);return g.Copy(e,0,h,0,e.length-1),h[e.length-1]=c[0],g.Copy(m,1,h,e.length,m.length-1),h}else{const h=new Array(e.length+m.length);return g.Copy(e,0,h,0,e.length),g.Copy(m,0,h,e.length,m.length),h}}ChangesOverlap(e,m,c){if(d.Assert(e.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),d.Assert(e.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=m.originalStart||e.modifiedStart+e.modifiedLength>=m.modifiedStart){const h=e.originalStart;let p=e.originalLength;const f=e.modifiedStart;let y=e.modifiedLength;return e.originalStart+e.originalLength>=m.originalStart&&(p=m.originalStart+m.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=m.modifiedStart&&(y=m.modifiedStart+m.modifiedLength-e.modifiedStart),c[0]=new E.DiffChange(h,p,f,y),!0}else return c[0]=null,!1}ClipDiagonalBound(e,m,c,h){if(e>=0&&e<h)return e;const p=c,f=h-c-1,y=m%2===0;if(e<0){const w=p%2===0;return y===w?0:1}else{const w=f%2===0;return y===w?h-1:h-2}}}n.LcsDiff=s}),ne(ie[22],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.validateConstraint=n.validateConstraints=n.isFunction=n.assertIsDefined=n.assertType=n.isUndefinedOrNull=n.isDefined=n.isUndefined=n.isBoolean=n.isIterable=n.isNumber=n.isTypedArray=n.isObject=n.isString=void 0;function E(f){return typeof f=="string"}n.isString=E;function M(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}n.isObject=M;function i(f){const y=Object.getPrototypeOf(Uint8Array);return typeof f=="object"&&f instanceof y}n.isTypedArray=i;function u(f){return typeof f=="number"&&!isNaN(f)}n.isNumber=u;function d(f){return!!f&&typeof f[Symbol.iterator]=="function"}n.isIterable=d;function g(f){return f===!0||f===!1}n.isBoolean=g;function a(f){return typeof f>"u"}n.isUndefined=a;function s(f){return!v(f)}n.isDefined=s;function v(f){return a(f)||f===null}n.isUndefinedOrNull=v;function e(f,y){if(!f)throw new Error(y?`Unexpected type, expected '${y}'`:"Unexpected type")}n.assertType=e;function m(f){if(v(f))throw new Error("Assertion Failed: argument is undefined or null");return f}n.assertIsDefined=m;function c(f){return typeof f=="function"}n.isFunction=c;function h(f,y){const w=Math.min(f.length,y.length);for(let R=0;R<w;R++)p(f[R],y[R])}n.validateConstraints=h;function p(f,y){if(E(y)){if(typeof f!==y)throw new Error(`argument does not match constraint: typeof ${y}`)}else if(c(y)){try{if(f instanceof y)return}catch{}if(!v(f)&&f.constructor===y||y.length===1&&y.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}n.validateConstraint=p}),ne(ie[35],re([0,1,22]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Codicon=n.getCodiconFontCharacters=void 0;const M=Object.create(null);function i(d,g){if((0,E.isString)(g)){const a=M[g];if(a===void 0)throw new Error(`${d} references an unknown codicon: ${g}`);g=a}return M[d]=g,{id:d}}function u(){return M}n.getCodiconFontCharacters=u,n.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),ne(ie[11],re([0,1,22]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createProxyObject=n.getAllMethodNames=n.getAllPropertyNames=n.equals=n.mixin=n.cloneAndChange=n.deepFreeze=n.deepClone=void 0;function M(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const h=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([p,f])=>{h[p]=f&&typeof f=="object"?M(f):f}),h}n.deepClone=M;function i(c){if(!c||typeof c!="object")return c;const h=[c];for(;h.length>0;){const p=h.shift();Object.freeze(p);for(const f in p)if(u.call(p,f)){const y=p[f];typeof y=="object"&&!Object.isFrozen(y)&&!(0,E.isTypedArray)(y)&&h.push(y)}}return c}n.deepFreeze=i;const u=Object.prototype.hasOwnProperty;function d(c,h){return g(c,h,new Set)}n.cloneAndChange=d;function g(c,h,p){if((0,E.isUndefinedOrNull)(c))return c;const f=h(c);if(typeof f<"u")return f;if(Array.isArray(c)){const y=[];for(const w of c)y.push(g(w,h,p));return y}if((0,E.isObject)(c)){if(p.has(c))throw new Error("Cannot clone recursive data-structure");p.add(c);const y={};for(const w in c)u.call(c,w)&&(y[w]=g(c[w],h,p));return p.delete(c),y}return c}function a(c,h,p=!0){return(0,E.isObject)(c)?((0,E.isObject)(h)&&Object.keys(h).forEach(f=>{f in c?p&&((0,E.isObject)(c[f])&&(0,E.isObject)(h[f])?a(c[f],h[f],p):c[f]=h[f]):c[f]=h[f]}),c):h}n.mixin=a;function s(c,h){if(c===h)return!0;if(c==null||h===null||h===void 0||typeof c!=typeof h||typeof c!="object"||Array.isArray(c)!==Array.isArray(h))return!1;let p,f;if(Array.isArray(c)){if(c.length!==h.length)return!1;for(p=0;p<c.length;p++)if(!s(c[p],h[p]))return!1}else{const y=[];for(f in c)y.push(f);y.sort();const w=[];for(f in h)w.push(f);if(w.sort(),!s(y,w))return!1;for(p=0;p<y.length;p++)if(!s(c[y[p]],h[y[p]]))return!1}return!0}n.equals=s;function v(c){let h=[];for(;Object.prototype!==c;)h=h.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return h}n.getAllPropertyNames=v;function e(c){const h=[];for(const p of v(c))typeof c[p]=="function"&&h.push(p);return h}n.getAllMethodNames=e;function m(c,h){const p=y=>function(){const w=Array.prototype.slice.call(arguments,0);return h(y,w)},f={};for(const y of c)f[y]=p(y);return f}n.createProxyObject=m}),ne(ie[23],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.toUint32=n.toUint8=void 0;function E(i){return i<0?0:i>255?255:i|0}n.toUint8=E;function M(i){return i<0?0:i>4294967295?4294967295:i|0}n.toUint32=M}),ne(ie[24],re([0,1,23]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.CharacterSet=n.CharacterClassifier=void 0;class M{constructor(d){const g=(0,E.toUint8)(d);this._defaultValue=g,this._asciiMap=M._createAsciiMap(g),this._map=new Map}static _createAsciiMap(d){const g=new Uint8Array(256);return g.fill(d),g}set(d,g){const a=(0,E.toUint8)(g);d>=0&&d<256?this._asciiMap[d]=a:this._map.set(d,a)}get(d){return d>=0&&d<256?this._asciiMap[d]:this._map.get(d)||this._defaultValue}clear(){this._asciiMap.fill(this._defaultValue),this._map.clear()}}n.CharacterClassifier=M;class i{constructor(){this._actual=new M(0)}add(d){this._actual.set(d,1)}has(d){return this._actual.get(d)===1}clear(){return this._actual.clear()}}n.CharacterSet=i}),ne(ie[6],re([0,1,4]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.OffsetRangeSet=n.OffsetRange=void 0;class M{static addRange(d,g){let a=0;for(;a<g.length&&g[a].endExclusive<d.start;)a++;let s=a;for(;s<g.length&&g[s].start<=d.endExclusive;)s++;if(a===s)g.splice(a,0,d);else{const v=Math.min(d.start,g[a].start),e=Math.max(d.endExclusive,g[s-1].endExclusive);g.splice(a,s-a,new M(v,e))}}static tryCreate(d,g){if(!(d>g))return new M(d,g)}constructor(d,g){if(this.start=d,this.endExclusive=g,d>g)throw new E.BugIndicatingError(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(d){return new M(this.start+d,this.endExclusive+d)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(d){return this.start===d.start&&this.endExclusive===d.endExclusive}containsRange(d){return this.start<=d.start&&d.endExclusive<=this.endExclusive}contains(d){return this.start<=d&&d<this.endExclusive}join(d){return new M(Math.min(this.start,d.start),Math.max(this.endExclusive,d.endExclusive))}intersect(d){const g=Math.max(this.start,d.start),a=Math.min(this.endExclusive,d.endExclusive);if(g<=a)return new M(g,a)}slice(d){return d.slice(this.start,this.endExclusive)}}n.OffsetRange=M;class i{constructor(){this._sortedRanges=[]}addRange(d){let g=0;for(;g<this._sortedRanges.length&&this._sortedRanges[g].endExclusive<d.start;)g++;let a=g;for(;a<this._sortedRanges.length&&this._sortedRanges[a].start<=d.endExclusive;)a++;if(g===a)this._sortedRanges.splice(g,0,d);else{const s=Math.min(d.start,this._sortedRanges[g].start),v=Math.max(d.endExclusive,this._sortedRanges[a-1].endExclusive);this._sortedRanges.splice(g,a-g,new M(s,v))}}toString(){return this._sortedRanges.map(d=>d.toString()).join(", ")}intersectsStrict(d){let g=0;for(;g<this._sortedRanges.length&&this._sortedRanges[g].endExclusive<=d.start;)g++;return g<this._sortedRanges.length&&this._sortedRanges[g].start<d.endExclusive}intersectWithRange(d){const g=new i;for(const a of this._sortedRanges){const s=a.intersect(d);s&&g.addRange(s)}return g}intersectWithRangeLength(d){return this.intersectWithRange(d).length}get length(){return this._sortedRanges.reduce((d,g)=>d+g.length,0)}}n.OffsetRangeSet=i}),ne(ie[3],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Position=void 0;class E{constructor(i,u){this.lineNumber=i,this.column=u}with(i=this.lineNumber,u=this.column){return i===this.lineNumber&&u===this.column?this:new E(i,u)}delta(i=0,u=0){return this.with(this.lineNumber+i,this.column+u)}equals(i){return E.equals(this,i)}static equals(i,u){return!i&&!u?!0:!!i&&!!u&&i.lineNumber===u.lineNumber&&i.column===u.column}isBefore(i){return E.isBefore(this,i)}static isBefore(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<u.column}isBeforeOrEqual(i){return E.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,u){return i.lineNumber<u.lineNumber?!0:u.lineNumber<i.lineNumber?!1:i.column<=u.column}static compare(i,u){const d=i.lineNumber|0,g=u.lineNumber|0;if(d===g){const a=i.column|0,s=u.column|0;return a-s}return d-g}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new E(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}n.Position=E}),ne(ie[2],re([0,1,3]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Range=void 0;class M{constructor(u,d,g,a){u>g||u===g&&d>a?(this.startLineNumber=g,this.startColumn=a,this.endLineNumber=u,this.endColumn=d):(this.startLineNumber=u,this.startColumn=d,this.endLineNumber=g,this.endColumn=a)}isEmpty(){return M.isEmpty(this)}static isEmpty(u){return u.startLineNumber===u.endLineNumber&&u.startColumn===u.endColumn}containsPosition(u){return M.containsPosition(this,u)}static containsPosition(u,d){return!(d.lineNumber<u.startLineNumber||d.lineNumber>u.endLineNumber||d.lineNumber===u.startLineNumber&&d.column<u.startColumn||d.lineNumber===u.endLineNumber&&d.column>u.endColumn)}static strictContainsPosition(u,d){return!(d.lineNumber<u.startLineNumber||d.lineNumber>u.endLineNumber||d.lineNumber===u.startLineNumber&&d.column<=u.startColumn||d.lineNumber===u.endLineNumber&&d.column>=u.endColumn)}containsRange(u){return M.containsRange(this,u)}static containsRange(u,d){return!(d.startLineNumber<u.startLineNumber||d.endLineNumber<u.startLineNumber||d.startLineNumber>u.endLineNumber||d.endLineNumber>u.endLineNumber||d.startLineNumber===u.startLineNumber&&d.startColumn<u.startColumn||d.endLineNumber===u.endLineNumber&&d.endColumn>u.endColumn)}strictContainsRange(u){return M.strictContainsRange(this,u)}static strictContainsRange(u,d){return!(d.startLineNumber<u.startLineNumber||d.endLineNumber<u.startLineNumber||d.startLineNumber>u.endLineNumber||d.endLineNumber>u.endLineNumber||d.startLineNumber===u.startLineNumber&&d.startColumn<=u.startColumn||d.endLineNumber===u.endLineNumber&&d.endColumn>=u.endColumn)}plusRange(u){return M.plusRange(this,u)}static plusRange(u,d){let g,a,s,v;return d.startLineNumber<u.startLineNumber?(g=d.startLineNumber,a=d.startColumn):d.startLineNumber===u.startLineNumber?(g=d.startLineNumber,a=Math.min(d.startColumn,u.startColumn)):(g=u.startLineNumber,a=u.startColumn),d.endLineNumber>u.endLineNumber?(s=d.endLineNumber,v=d.endColumn):d.endLineNumber===u.endLineNumber?(s=d.endLineNumber,v=Math.max(d.endColumn,u.endColumn)):(s=u.endLineNumber,v=u.endColumn),new M(g,a,s,v)}intersectRanges(u){return M.intersectRanges(this,u)}static intersectRanges(u,d){let g=u.startLineNumber,a=u.startColumn,s=u.endLineNumber,v=u.endColumn;const e=d.startLineNumber,m=d.startColumn,c=d.endLineNumber,h=d.endColumn;return g<e?(g=e,a=m):g===e&&(a=Math.max(a,m)),s>c?(s=c,v=h):s===c&&(v=Math.min(v,h)),g>s||g===s&&a>v?null:new M(g,a,s,v)}equalsRange(u){return M.equalsRange(this,u)}static equalsRange(u,d){return!u&&!d?!0:!!u&&!!d&&u.startLineNumber===d.startLineNumber&&u.startColumn===d.startColumn&&u.endLineNumber===d.endLineNumber&&u.endColumn===d.endColumn}getEndPosition(){return M.getEndPosition(this)}static getEndPosition(u){return new E.Position(u.endLineNumber,u.endColumn)}getStartPosition(){return M.getStartPosition(this)}static getStartPosition(u){return new E.Position(u.startLineNumber,u.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(u,d){return new M(this.startLineNumber,this.startColumn,u,d)}setStartPosition(u,d){return new M(u,d,this.endLineNumber,this.endColumn)}collapseToStart(){return M.collapseToStart(this)}static collapseToStart(u){return new M(u.startLineNumber,u.startColumn,u.startLineNumber,u.startColumn)}collapseToEnd(){return M.collapseToEnd(this)}static collapseToEnd(u){return new M(u.endLineNumber,u.endColumn,u.endLineNumber,u.endColumn)}delta(u){return new M(this.startLineNumber+u,this.startColumn,this.endLineNumber+u,this.endColumn)}static fromPositions(u,d=u){return new M(u.lineNumber,u.column,d.lineNumber,d.column)}static lift(u){return u?new M(u.startLineNumber,u.startColumn,u.endLineNumber,u.endColumn):null}static isIRange(u){return u&&typeof u.startLineNumber=="number"&&typeof u.startColumn=="number"&&typeof u.endLineNumber=="number"&&typeof u.endColumn=="number"}static areIntersectingOrTouching(u,d){return!(u.endLineNumber<d.startLineNumber||u.endLineNumber===d.startLineNumber&&u.endColumn<d.startColumn||d.endLineNumber<u.startLineNumber||d.endLineNumber===u.startLineNumber&&d.endColumn<u.startColumn)}static areIntersecting(u,d){return!(u.endLineNumber<d.startLineNumber||u.endLineNumber===d.startLineNumber&&u.endColumn<=d.startColumn||d.endLineNumber<u.startLineNumber||d.endLineNumber===u.startLineNumber&&d.endColumn<=u.startColumn)}static compareRangesUsingStarts(u,d){if(u&&d){const s=u.startLineNumber|0,v=d.startLineNumber|0;if(s===v){const e=u.startColumn|0,m=d.startColumn|0;if(e===m){const c=u.endLineNumber|0,h=d.endLineNumber|0;if(c===h){const p=u.endColumn|0,f=d.endColumn|0;return p-f}return c-h}return e-m}return s-v}return(u?1:0)-(d?1:0)}static compareRangesUsingEnds(u,d){return u.endLineNumber===d.endLineNumber?u.endColumn===d.endColumn?u.startLineNumber===d.startLineNumber?u.startColumn-d.startColumn:u.startLineNumber-d.startLineNumber:u.endColumn-d.endColumn:u.endLineNumber-d.endLineNumber}static spansMultipleLines(u){return u.endLineNumber>u.startLineNumber}toJSON(){return this}}n.Range=M}),ne(ie[12],re([0,1,4,6,2]),function(O,n,E,M,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LineRange=void 0;class u{static fromRange(g){return new u(g.startLineNumber,g.endLineNumber)}static subtract(g,a){return a?g.startLineNumber<a.startLineNumber&&a.endLineNumberExclusive<g.endLineNumberExclusive?[new u(g.startLineNumber,a.startLineNumber),new u(a.endLineNumberExclusive,g.endLineNumberExclusive)]:a.startLineNumber<=g.startLineNumber&&g.endLineNumberExclusive<=a.endLineNumberExclusive?[]:a.endLineNumberExclusive<g.endLineNumberExclusive?[new u(Math.max(a.endLineNumberExclusive,g.startLineNumber),g.endLineNumberExclusive)]:[new u(g.startLineNumber,Math.min(a.startLineNumber,g.endLineNumberExclusive))]:[g]}static joinMany(g){if(g.length===0)return[];let a=g[0];for(let s=1;s<g.length;s++)a=this.join(a,g[s]);return a}static join(g,a){if(g.length===0)return a;if(a.length===0)return g;const s=[];let v=0,e=0,m=null;for(;v<g.length||e<a.length;){let c=null;if(v<g.length&&e<a.length){const h=g[v],p=a[e];h.startLineNumber<p.startLineNumber?(c=h,v++):(c=p,e++)}else v<g.length?(c=g[v],v++):(c=a[e],e++);m===null?m=c:m.endLineNumberExclusive>=c.startLineNumber?m=new u(m.startLineNumber,Math.max(m.endLineNumberExclusive,c.endLineNumberExclusive)):(s.push(m),m=c)}return m!==null&&s.push(m),s}static ofLength(g,a){return new u(g,g+a)}static deserialize(g){return new u(g[0],g[1])}constructor(g,a){if(g>a)throw new E.BugIndicatingError(`startLineNumber ${g} cannot be after endLineNumberExclusive ${a}`);this.startLineNumber=g,this.endLineNumberExclusive=a}contains(g){return this.startLineNumber<=g&&g<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(g){return new u(this.startLineNumber+g,this.endLineNumberExclusive+g)}deltaLength(g){return new u(this.startLineNumber,this.endLineNumberExclusive+g)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(g){return new u(Math.min(this.startLineNumber,g.startLineNumber),Math.max(this.endLineNumberExclusive,g.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(g){const a=Math.max(this.startLineNumber,g.startLineNumber),s=Math.min(this.endLineNumberExclusive,g.endLineNumberExclusive);if(a<=s)return new u(a,s)}intersectsStrict(g){return this.startLineNumber<g.endLineNumberExclusive&&g.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(g){return this.startLineNumber<=g.endLineNumberExclusive&&g.startLineNumber<=this.endLineNumberExclusive}equals(g){return this.startLineNumber===g.startLineNumber&&this.endLineNumberExclusive===g.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new i.Range(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new i.Range(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(g){const a=[];for(let s=this.startLineNumber;s<this.endLineNumberExclusive;s++)a.push(g(s));return a}forEach(g){for(let a=this.startLineNumber;a<this.endLineNumberExclusive;a++)g(a)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(g){return this.startLineNumber<=g&&g<this.endLineNumberExclusive}toOffsetRange(){return new M.OffsetRange(this.startLineNumber-1,this.endLineNumberExclusive-1)}}n.LineRange=u}),ne(ie[36],re([0,1,3,2]),function(O,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Selection=void 0;class i extends M.Range{constructor(d,g,a,s){super(d,g,a,s),this.selectionStartLineNumber=d,this.selectionStartColumn=g,this.positionLineNumber=a,this.positionColumn=s}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(d){return i.selectionsEqual(this,d)}static selectionsEqual(d,g){return d.selectionStartLineNumber===g.selectionStartLineNumber&&d.selectionStartColumn===g.selectionStartColumn&&d.positionLineNumber===g.positionLineNumber&&d.positionColumn===g.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(d,g){return this.getDirection()===0?new i(this.startLineNumber,this.startColumn,d,g):new i(d,g,this.startLineNumber,this.startColumn)}getPosition(){return new E.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new E.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(d,g){return this.getDirection()===0?new i(d,g,this.endLineNumber,this.endColumn):new i(this.endLineNumber,this.endColumn,d,g)}static fromPositions(d,g=d){return new i(d.lineNumber,d.column,g.lineNumber,g.column)}static fromRange(d,g){return g===0?new i(d.startLineNumber,d.startColumn,d.endLineNumber,d.endColumn):new i(d.endLineNumber,d.endColumn,d.startLineNumber,d.startColumn)}static liftSelection(d){return new i(d.selectionStartLineNumber,d.selectionStartColumn,d.positionLineNumber,d.positionColumn)}static selectionsArrEqual(d,g){if(d&&!g||!d&&g)return!1;if(!d&&!g)return!0;if(d.length!==g.length)return!1;for(let a=0,s=d.length;a<s;a++)if(!this.selectionsEqual(d[a],g[a]))return!1;return!0}static isISelection(d){return d&&typeof d.selectionStartLineNumber=="number"&&typeof d.selectionStartColumn=="number"&&typeof d.positionLineNumber=="number"&&typeof d.positionColumn=="number"}static createWithDirection(d,g,a,s,v){return v===0?new i(d,g,a,s):new i(a,s,d,g)}}n.Selection=i}),ne(ie[37],re([0,1,24]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getMapForWordSeparators=n.WordCharacterClassifier=void 0;class M extends E.CharacterClassifier{constructor(d){super(0);for(let g=0,a=d.length;g<a;g++)this.set(d.charCodeAt(g),2);this.set(32,1),this.set(9,1)}}n.WordCharacterClassifier=M;function i(u){const d={};return g=>(d.hasOwnProperty(g)||(d[g]=u(g)),d[g])}n.getMapForWordSeparators=i(u=>new M(u))}),ne(ie[25],re([0,1,18,19]),function(O,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.getWordAtText=n.ensureValidWordDefinition=n.DEFAULT_WORD_REGEXP=n.USUAL_WORD_SEPARATORS=void 0,n.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function i(s=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const e of n.USUAL_WORD_SEPARATORS)s.indexOf(e)>=0||(v+="\\"+e);return v+="\\s]+)",new RegExp(v,"g")}n.DEFAULT_WORD_REGEXP=i();function u(s){let v=n.DEFAULT_WORD_REGEXP;if(s&&s instanceof RegExp)if(s.global)v=s;else{let e="g";s.ignoreCase&&(e+="i"),s.multiline&&(e+="m"),s.unicode&&(e+="u"),v=new RegExp(s.source,e)}return v.lastIndex=0,v}n.ensureValidWordDefinition=u;const d=new M.LinkedList;d.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function g(s,v,e,m,c){if(c||(c=E.Iterable.first(d)),e.length>c.maxLen){let w=s-c.maxLen/2;return w<0?w=0:m+=w,e=e.substring(w,s+c.maxLen/2),g(s,v,e,m,c)}const h=Date.now(),p=s-1-m;let f=-1,y=null;for(let w=1;!(Date.now()-h>=c.timeBudget);w++){const R=p-c.windowSize*w;v.lastIndex=Math.max(0,R);const S=a(v,e,p,f);if(!S&&y||(y=S,R<=0))break;f=R}if(y){const w={word:y[0],startColumn:m+1+y.index,endColumn:m+1+y.index+y[0].length};return v.lastIndex=0,w}return null}n.getWordAtText=g;function a(s,v,e,m){let c;for(;c=s.exec(v);){const h=c.index||0;if(h<=e&&s.lastIndex>=e)return c;if(m>0&&h>m)return null}return null}}),ne(ie[8],re([0,1,4,6]),function(O,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DateTimeout=n.InfiniteTimeout=n.SequenceDiff=n.DiffAlgorithmResult=void 0;class i{static trivial(s,v){return new i([new u(new M.OffsetRange(0,s.length),new M.OffsetRange(0,v.length))],!1)}static trivialTimedOut(s,v){return new i([new u(new M.OffsetRange(0,s.length),new M.OffsetRange(0,v.length))],!0)}constructor(s,v){this.diffs=s,this.hitTimeout=v}}n.DiffAlgorithmResult=i;class u{constructor(s,v){this.seq1Range=s,this.seq2Range=v}reverse(){return new u(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(s){return new u(this.seq1Range.join(s.seq1Range),this.seq2Range.join(s.seq2Range))}delta(s){return s===0?this:new u(this.seq1Range.delta(s),this.seq2Range.delta(s))}}n.SequenceDiff=u;class d{isValid(){return!0}}n.InfiniteTimeout=d,d.instance=new d;class g{constructor(s){if(this.timeout=s,this.startTime=Date.now(),this.valid=!0,s<=0)throw new E.BugIndicatingError("timeout must be positive")}isValid(){if(!(Date.now()-this.startTime<this.timeout)&&this.valid){this.valid=!1;debugger}return this.valid}}n.DateTimeout=g}),ne(ie[38],re([0,1,6,8]),function(O,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shiftSequenceDiffs=n.joinSequenceDiffs=n.removeRandomMatches=n.removeRandomLineMatches=n.smoothenSequenceDiffs=n.optimizeSequenceDiffs=void 0;function i(e,m,c){let h=c;return h=a(e,m,h),h=s(e,m,h),h}n.optimizeSequenceDiffs=i;function u(e,m,c){const h=[];for(const p of c){const f=h[h.length-1];if(!f){h.push(p);continue}p.seq1Range.start-f.seq1Range.endExclusive<=2||p.seq2Range.start-f.seq2Range.endExclusive<=2?h[h.length-1]=new M.SequenceDiff(f.seq1Range.join(p.seq1Range),f.seq2Range.join(p.seq2Range)):h.push(p)}return h}n.smoothenSequenceDiffs=u;function d(e,m,c){let h=c;if(h.length===0)return h;let p=0,f;do{f=!1;const y=[h[0]];for(let w=1;w<h.length;w++){let L=function(o,l){const _=new E.OffsetRange(S.seq1Range.endExclusive,R.seq1Range.start);return e.getText(_).replace(/\s/g,"").length<=4&&(o.seq1Range.length+o.seq2Range.length>5||l.seq1Range.length+l.seq2Range.length>5)};const R=h[w],S=y[y.length-1];L(S,R)?(f=!0,y[y.length-1]=y[y.length-1].join(R)):y.push(R)}h=y}while(p++<10&&f);return h}n.removeRandomLineMatches=d;function g(e,m,c){let h=c;if(h.length===0)return h;let p=0,f;do{f=!1;const y=[h[0]];for(let w=1;w<h.length;w++){let L=function(o,l){const _=new E.OffsetRange(S.seq1Range.endExclusive,R.seq1Range.start);if(e.countLinesIn(_)>5||_.length>500)return!1;const C=e.getText(_).trim();if(C.length>20||C.split(/\r\n|\r|\n/).length>1)return!1;const A=e.countLinesIn(o.seq1Range),N=o.seq1Range.length,D=m.countLinesIn(o.seq2Range),x=o.seq2Range.length,W=e.countLinesIn(l.seq1Range),I=l.seq1Range.length,k=m.countLinesIn(l.seq2Range),P=l.seq2Range.length,T=2*40+50;function z(U){return Math.min(U,T)}return Math.pow(Math.pow(z(A*40+N),1.5)+Math.pow(z(D*40+x),1.5),1.5)+Math.pow(Math.pow(z(W*40+I),1.5)+Math.pow(z(k*40+P),1.5),1.5)>Math.pow(Math.pow(T,1.5),1.5)*1.3};const R=h[w],S=y[y.length-1];L(S,R)?(f=!0,y[y.length-1]=y[y.length-1].join(R)):y.push(R)}h=y}while(p++<10&&f);return h}n.removeRandomMatches=g;function a(e,m,c){if(c.length===0)return c;const h=[];h.push(c[0]);for(let f=1;f<c.length;f++){const y=h[h.length-1];let w=c[f];if(w.seq1Range.isEmpty||w.seq2Range.isEmpty){const R=w.seq1Range.start-y.seq1Range.endExclusive;let S;for(S=1;S<=R&&!(e.getElement(w.seq1Range.start-S)!==e.getElement(w.seq1Range.endExclusive-S)||m.getElement(w.seq2Range.start-S)!==m.getElement(w.seq2Range.endExclusive-S));S++);if(S--,S===R){h[h.length-1]=new M.SequenceDiff(new E.OffsetRange(y.seq1Range.start,w.seq1Range.endExclusive-R),new E.OffsetRange(y.seq2Range.start,w.seq2Range.endExclusive-R));continue}w=w.delta(-S)}h.push(w)}const p=[];for(let f=0;f<h.length-1;f++){const y=h[f+1];let w=h[f];if(w.seq1Range.isEmpty||w.seq2Range.isEmpty){const R=y.seq1Range.start-w.seq1Range.endExclusive;let S;for(S=0;S<R&&!(e.getElement(w.seq1Range.start+S)!==e.getElement(w.seq1Range.endExclusive+S)||m.getElement(w.seq2Range.start+S)!==m.getElement(w.seq2Range.endExclusive+S));S++);if(S===R){h[f+1]=new M.SequenceDiff(new E.OffsetRange(w.seq1Range.start+R,y.seq1Range.endExclusive),new E.OffsetRange(w.seq2Range.start+R,y.seq2Range.endExclusive));continue}S>0&&(w=w.delta(S))}p.push(w)}return h.length>0&&p.push(h[h.length-1]),p}n.joinSequenceDiffs=a;function s(e,m,c){if(!e.getBoundaryScore||!m.getBoundaryScore)return c;for(let h=0;h<c.length;h++){const p=h>0?c[h-1]:void 0,f=c[h],y=h+1<c.length?c[h+1]:void 0,w=new E.OffsetRange(p?p.seq1Range.start+1:0,y?y.seq1Range.endExclusive-1:e.length),R=new E.OffsetRange(p?p.seq2Range.start+1:0,y?y.seq2Range.endExclusive-1:m.length);f.seq1Range.isEmpty?c[h]=v(f,e,m,w,R):f.seq2Range.isEmpty&&(c[h]=v(f.reverse(),m,e,R,w).reverse())}return c}n.shiftSequenceDiffs=s;function v(e,m,c,h,p){let y=1;for(;e.seq1Range.start-y>=h.start&&e.seq2Range.start-y>=p.start&&c.isStronglyEqual(e.seq2Range.start-y,e.seq2Range.endExclusive-y)&&y<100;)y++;y--;let w=0;for(;e.seq1Range.start+w<h.endExclusive&&e.seq2Range.endExclusive+w<p.endExclusive&&c.isStronglyEqual(e.seq2Range.start+w,e.seq2Range.endExclusive+w)&&w<100;)w++;if(y===0&&w===0)return e;let R=0,S=-1;for(let L=-y;L<=w;L++){const r=e.seq2Range.start+L,o=e.seq2Range.endExclusive+L,l=e.seq1Range.start+L,_=m.getBoundaryScore(l)+c.getBoundaryScore(r)+c.getBoundaryScore(o);_>S&&(S=_,R=L)}return e.delta(R)}}),ne(ie[39],re([0,1,6,8]),function(O,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MyersDiffAlgorithm=void 0;class i{compute(s,v,e=M.InfiniteTimeout.instance){if(s.length===0||v.length===0)return M.DiffAlgorithmResult.trivial(s,v);function m(L,r){for(;L<s.length&&r<v.length&&s.getElement(L)===v.getElement(r);)L++,r++;return L}let c=0;const h=new d;h.set(0,m(0,0));const p=new g;p.set(0,h.get(0)===0?null:new u(null,0,0,h.get(0)));let f=0;e:for(;;){if(c++,!e.isValid())return M.DiffAlgorithmResult.trivialTimedOut(s,v);const L=-Math.min(c,v.length+c%2),r=Math.min(c,s.length+c%2);for(f=L;f<=r;f+=2){const o=f===r?-1:h.get(f+1),l=f===L?-1:h.get(f-1)+1,_=Math.min(Math.max(o,l),s.length),b=_-f;if(_>s.length||b>v.length)continue;const C=m(_,b);h.set(f,C);const A=_===o?p.get(f+1):p.get(f-1);if(p.set(f,C!==_?new u(A,_,b,C-_):A),h.get(f)===s.length&&h.get(f)-f===v.length)break e}}let y=p.get(f);const w=[];let R=s.length,S=v.length;for(;;){const L=y?y.x+y.length:0,r=y?y.y+y.length:0;if((L!==R||r!==S)&&w.push(new M.SequenceDiff(new E.OffsetRange(L,R),new E.OffsetRange(r,S))),!y)break;R=y.x,S=y.y,y=y.prev}return w.reverse(),new M.DiffAlgorithmResult(w,!1)}}n.MyersDiffAlgorithm=i;class u{constructor(s,v,e,m){this.prev=s,this.x=v,this.y=e,this.length=m}}class d{constructor(){this.positiveArr=new Int32Array(10),this.negativeArr=new Int32Array(10)}get(s){return s<0?(s=-s-1,this.negativeArr[s]):this.positiveArr[s]}set(s,v){if(s<0){if(s=-s-1,s>=this.negativeArr.length){const e=this.negativeArr;this.negativeArr=new Int32Array(e.length*2),this.negativeArr.set(e)}this.negativeArr[s]=v}else{if(s>=this.positiveArr.length){const e=this.positiveArr;this.positiveArr=new Int32Array(e.length*2),this.positiveArr.set(e)}this.positiveArr[s]=v}}}class g{constructor(){this.positiveArr=[],this.negativeArr=[]}get(s){return s<0?(s=-s-1,this.negativeArr[s]):this.positiveArr[s]}set(s,v){s<0?(s=-s-1,this.negativeArr[s]=v):this.positiveArr[s]=v}}}),ne(ie[40],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Array2D=void 0;class E{constructor(i,u){this.width=i,this.height=u,this.array=[],this.array=new Array(i*u)}get(i,u){return this.array[i+u*this.width]}set(i,u,d){this.array[i+u*this.width]=d}}n.Array2D=E}),ne(ie[41],re([0,1,6,8,40]),function(O,n,E,M,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DynamicProgrammingDiffing=void 0;class u{compute(g,a,s=M.InfiniteTimeout.instance,v){if(g.length===0||a.length===0)return M.DiffAlgorithmResult.trivial(g,a);const e=new i.Array2D(g.length,a.length),m=new i.Array2D(g.length,a.length),c=new i.Array2D(g.length,a.length);for(let S=0;S<g.length;S++)for(let L=0;L<a.length;L++){if(!s.isValid())return M.DiffAlgorithmResult.trivialTimedOut(g,a);const r=S===0?0:e.get(S-1,L),o=L===0?0:e.get(S,L-1);let l;g.getElement(S)===a.getElement(L)?(S===0||L===0?l=0:l=e.get(S-1,L-1),S>0&&L>0&&m.get(S-1,L-1)===3&&(l+=c.get(S-1,L-1)),l+=v?v(S,L):1):l=-1;const _=Math.max(r,o,l);if(_===l){const b=S>0&&L>0?c.get(S-1,L-1):0;c.set(S,L,b+1),m.set(S,L,3)}else _===r?(c.set(S,L,0),m.set(S,L,1)):_===o&&(c.set(S,L,0),m.set(S,L,2));e.set(S,L,_)}const h=[];let p=g.length,f=a.length;function y(S,L){(S+1!==p||L+1!==f)&&h.push(new M.SequenceDiff(new E.OffsetRange(S+1,p),new E.OffsetRange(L+1,f))),p=S,f=L}let w=g.length-1,R=a.length-1;for(;w>=0&&R>=0;)m.get(w,R)===3?(y(w,R),w--,R--):m.get(w,R)===1?w--:R--;return y(-1,-1),h.reverse(),new M.DiffAlgorithmResult(h,!1)}}n.DynamicProgrammingDiffing=u}),ne(ie[26],re([0,1,12]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MovedText=n.SimpleLineRangeMapping=n.RangeMapping=n.LineRangeMapping=n.LinesDiff=void 0;class M{constructor(s,v,e){this.changes=s,this.moves=v,this.hitTimeout=e}}n.LinesDiff=M;class i{static inverse(s,v,e){const m=[];let c=1,h=1;for(const f of s){const y=new i(new E.LineRange(c,f.originalRange.startLineNumber),new E.LineRange(h,f.modifiedRange.startLineNumber),void 0);y.modifiedRange.isEmpty||m.push(y),c=f.originalRange.endLineNumberExclusive,h=f.modifiedRange.endLineNumberExclusive}const p=new i(new E.LineRange(c,v+1),new E.LineRange(h,e+1),void 0);return p.modifiedRange.isEmpty||m.push(p),m}constructor(s,v,e){this.originalRange=s,this.modifiedRange=v,this.innerChanges=e}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}get changedLineCount(){return Math.max(this.originalRange.length,this.modifiedRange.length)}flip(){var s;return new i(this.modifiedRange,this.originalRange,(s=this.innerChanges)===null||s===void 0?void 0:s.map(v=>v.flip()))}}n.LineRangeMapping=i;class u{constructor(s,v){this.originalRange=s,this.modifiedRange=v}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new u(this.modifiedRange,this.originalRange)}}n.RangeMapping=u;class d{constructor(s,v){this.original=s,this.modified=v}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new d(this.modified,this.original)}join(s){return new d(this.original.join(s.original),this.modified.join(s.modified))}}n.SimpleLineRangeMapping=d;class g{constructor(s,v){this.lineRangeMapping=s,this.changes=v}flip(){return new g(this.lineRangeMapping.flip(),this.changes.map(s=>s.flip()))}}n.MovedText=g}),ne(ie[42],re([0,1,21,26,5,2,9,12]),function(O,n,E,M,i,u,d,g){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.DiffComputer=n.SmartLinesDiffComputer=void 0;const a=3;class s{computeDiff(L,r,o){var l;const b=new f(L,r,{maxComputationTime:o.maxComputationTimeMs,shouldIgnoreTrimWhitespace:o.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),C=[];let A=null;for(const N of b.changes){let D;N.originalEndLineNumber===0?D=new g.LineRange(N.originalStartLineNumber+1,N.originalStartLineNumber+1):D=new g.LineRange(N.originalStartLineNumber,N.originalEndLineNumber+1);let x;N.modifiedEndLineNumber===0?x=new g.LineRange(N.modifiedStartLineNumber+1,N.modifiedStartLineNumber+1):x=new g.LineRange(N.modifiedStartLineNumber,N.modifiedEndLineNumber+1);let W=new M.LineRangeMapping(D,x,(l=N.charChanges)===null||l===void 0?void 0:l.map(I=>new M.RangeMapping(new u.Range(I.originalStartLineNumber,I.originalStartColumn,I.originalEndLineNumber,I.originalEndColumn),new u.Range(I.modifiedStartLineNumber,I.modifiedStartColumn,I.modifiedEndLineNumber,I.modifiedEndColumn))));A&&(A.modifiedRange.endLineNumberExclusive===W.modifiedRange.startLineNumber||A.originalRange.endLineNumberExclusive===W.originalRange.startLineNumber)&&(W=new M.LineRangeMapping(A.originalRange.join(W.originalRange),A.modifiedRange.join(W.modifiedRange),A.innerChanges&&W.innerChanges?A.innerChanges.concat(W.innerChanges):void 0),C.pop()),C.push(W),A=W}return(0,d.assertFn)(()=>(0,d.checkAdjacentItems)(C,(N,D)=>D.originalRange.startLineNumber-N.originalRange.endLineNumberExclusive===D.modifiedRange.startLineNumber-N.modifiedRange.endLineNumberExclusive&&N.originalRange.endLineNumberExclusive<D.originalRange.startLineNumber&&N.modifiedRange.endLineNumberExclusive<D.modifiedRange.startLineNumber)),new M.LinesDiff(C,[],b.quitEarly)}}n.SmartLinesDiffComputer=s;function v(S,L,r,o){return new E.LcsDiff(S,L,r).ComputeDiff(o)}class e{constructor(L){const r=[],o=[];for(let l=0,_=L.length;l<_;l++)r[l]=y(L[l],1),o[l]=w(L[l],1);this.lines=L,this._startColumns=r,this._endColumns=o}getElements(){const L=[];for(let r=0,o=this.lines.length;r<o;r++)L[r]=this.lines[r].substring(this._startColumns[r]-1,this._endColumns[r]-1);return L}getStrictElement(L){return this.lines[L]}getStartLineNumber(L){return L+1}getEndLineNumber(L){return L+1}createCharSequence(L,r,o){const l=[],_=[],b=[];let C=0;for(let A=r;A<=o;A++){const N=this.lines[A],D=L?this._startColumns[A]:1,x=L?this._endColumns[A]:N.length+1;for(let W=D;W<x;W++)l[C]=N.charCodeAt(W-1),_[C]=A+1,b[C]=W,C++;!L&&A<o&&(l[C]=10,_[C]=A+1,b[C]=N.length+1,C++)}return new m(l,_,b)}}class m{constructor(L,r,o){this._charCodes=L,this._lineNumbers=r,this._columns=o}toString(){return"["+this._charCodes.map((L,r)=>(L===10?"\\n":String.fromCharCode(L))+`-(${this._lineNumbers[r]},${this._columns[r]})`).join(", ")+"]"}_assertIndex(L,r){if(L<0||L>=r.length)throw new Error("Illegal index")}getElements(){return this._charCodes}getStartLineNumber(L){return L>0&&L===this._lineNumbers.length?this.getEndLineNumber(L-1):(this._assertIndex(L,this._lineNumbers),this._lineNumbers[L])}getEndLineNumber(L){return L===-1?this.getStartLineNumber(L+1):(this._assertIndex(L,this._lineNumbers),this._charCodes[L]===10?this._lineNumbers[L]+1:this._lineNumbers[L])}getStartColumn(L){return L>0&&L===this._columns.length?this.getEndColumn(L-1):(this._assertIndex(L,this._columns),this._columns[L])}getEndColumn(L){return L===-1?this.getStartColumn(L+1):(this._assertIndex(L,this._columns),this._charCodes[L]===10?1:this._columns[L]+1)}}class c{constructor(L,r,o,l,_,b,C,A){this.originalStartLineNumber=L,this.originalStartColumn=r,this.originalEndLineNumber=o,this.originalEndColumn=l,this.modifiedStartLineNumber=_,this.modifiedStartColumn=b,this.modifiedEndLineNumber=C,this.modifiedEndColumn=A}static createFromDiffChange(L,r,o){const l=r.getStartLineNumber(L.originalStart),_=r.getStartColumn(L.originalStart),b=r.getEndLineNumber(L.originalStart+L.originalLength-1),C=r.getEndColumn(L.originalStart+L.originalLength-1),A=o.getStartLineNumber(L.modifiedStart),N=o.getStartColumn(L.modifiedStart),D=o.getEndLineNumber(L.modifiedStart+L.modifiedLength-1),x=o.getEndColumn(L.modifiedStart+L.modifiedLength-1);return new c(l,_,b,C,A,N,D,x)}}function h(S){if(S.length<=1)return S;const L=[S[0]];let r=L[0];for(let o=1,l=S.length;o<l;o++){const _=S[o],b=_.originalStart-(r.originalStart+r.originalLength),C=_.modifiedStart-(r.modifiedStart+r.modifiedLength);Math.min(b,C)<a?(r.originalLength=_.originalStart+_.originalLength-r.originalStart,r.modifiedLength=_.modifiedStart+_.modifiedLength-r.modifiedStart):(L.push(_),r=_)}return L}class p{constructor(L,r,o,l,_){this.originalStartLineNumber=L,this.originalEndLineNumber=r,this.modifiedStartLineNumber=o,this.modifiedEndLineNumber=l,this.charChanges=_}static createFromDiffResult(L,r,o,l,_,b,C){let A,N,D,x,W;if(r.originalLength===0?(A=o.getStartLineNumber(r.originalStart)-1,N=0):(A=o.getStartLineNumber(r.originalStart),N=o.getEndLineNumber(r.originalStart+r.originalLength-1)),r.modifiedLength===0?(D=l.getStartLineNumber(r.modifiedStart)-1,x=0):(D=l.getStartLineNumber(r.modifiedStart),x=l.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),b&&r.originalLength>0&&r.originalLength<20&&r.modifiedLength>0&&r.modifiedLength<20&&_()){const I=o.createCharSequence(L,r.originalStart,r.originalStart+r.originalLength-1),k=l.createCharSequence(L,r.modifiedStart,r.modifiedStart+r.modifiedLength-1);if(I.getElements().length>0&&k.getElements().length>0){let P=v(I,k,_,!0).changes;C&&(P=h(P)),W=[];for(let T=0,z=P.length;T<z;T++)W.push(c.createFromDiffChange(P[T],I,k))}}return new p(A,N,D,x,W)}}class f{constructor(L,r,o){this.shouldComputeCharChanges=o.shouldComputeCharChanges,this.shouldPostProcessCharChanges=o.shouldPostProcessCharChanges,this.shouldIgnoreTrimWhitespace=o.shouldIgnoreTrimWhitespace,this.shouldMakePrettyDiff=o.shouldMakePrettyDiff,this.originalLines=L,this.modifiedLines=r,this.original=new e(L),this.modified=new e(r),this.continueLineDiff=R(o.maxComputationTime),this.continueCharDiff=R(o.maxComputationTime===0?0:Math.min(o.maxComputationTime,5e3))}computeDiff(){if(this.original.lines.length===1&&this.original.lines[0].length===0)return this.modified.lines.length===1&&this.modified.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.modified.lines.length,charChanges:void 0}]};if(this.modified.lines.length===1&&this.modified.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.original.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const L=v(this.original,this.modified,this.continueLineDiff,this.shouldMakePrettyDiff),r=L.changes,o=L.quitEarly;if(this.shouldIgnoreTrimWhitespace){const C=[];for(let A=0,N=r.length;A<N;A++)C.push(p.createFromDiffResult(this.shouldIgnoreTrimWhitespace,r[A],this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges));return{quitEarly:o,changes:C}}const l=[];let _=0,b=0;for(let C=-1,A=r.length;C<A;C++){const N=C+1<A?r[C+1]:null,D=N?N.originalStart:this.originalLines.length,x=N?N.modifiedStart:this.modifiedLines.length;for(;_<D&&b<x;){const W=this.originalLines[_],I=this.modifiedLines[b];if(W!==I){{let k=y(W,1),P=y(I,1);for(;k>1&&P>1;){const T=W.charCodeAt(k-2),z=I.charCodeAt(P-2);if(T!==z)break;k--,P--}(k>1||P>1)&&this._pushTrimWhitespaceCharChange(l,_+1,1,k,b+1,1,P)}{let k=w(W,1),P=w(I,1);const T=W.length+1,z=I.length+1;for(;k<T&&P<z;){const U=W.charCodeAt(k-1),Z=W.charCodeAt(P-1);if(U!==Z)break;k++,P++}(k<T||P<z)&&this._pushTrimWhitespaceCharChange(l,_+1,k,T,b+1,P,z)}}_++,b++}N&&(l.push(p.createFromDiffResult(this.shouldIgnoreTrimWhitespace,N,this.original,this.modified,this.continueCharDiff,this.shouldComputeCharChanges,this.shouldPostProcessCharChanges)),_+=N.originalLength,b+=N.modifiedLength)}return{quitEarly:o,changes:l}}_pushTrimWhitespaceCharChange(L,r,o,l,_,b,C){if(this._mergeTrimWhitespaceCharChange(L,r,o,l,_,b,C))return;let A;this.shouldComputeCharChanges&&(A=[new c(r,o,r,l,_,b,_,C)]),L.push(new p(r,r,_,_,A))}_mergeTrimWhitespaceCharChange(L,r,o,l,_,b,C){const A=L.length;if(A===0)return!1;const N=L[A-1];return N.originalEndLineNumber===0||N.modifiedEndLineNumber===0?!1:N.originalEndLineNumber===r&&N.modifiedEndLineNumber===_?(this.shouldComputeCharChanges&&N.charChanges&&N.charChanges.push(new c(r,o,r,l,_,b,_,C)),!0):N.originalEndLineNumber+1===r&&N.modifiedEndLineNumber+1===_?(N.originalEndLineNumber=r,N.modifiedEndLineNumber=_,this.shouldComputeCharChanges&&N.charChanges&&N.charChanges.push(new c(r,o,r,l,_,b,_,C)),!0):!1}}n.DiffComputer=f;function y(S,L){const r=i.firstNonWhitespaceIndex(S);return r===-1?L:r+1}function w(S,L){const r=i.lastNonWhitespaceIndex(S);return r===-1?L:r+2}function R(S){if(S===0)return()=>!0;const L=Date.now();return()=>Date.now()-L<S}}),ne(ie[43],re([0,1,16,9,28,12,6,3,2,8,41,38,39,26]),function(O,n,E,M,i,u,d,g,a,s,v,e,m,c){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.LinesSliceCharSequence=n.LineSequence=n.getLineRangeMapping=n.lineRangeMappingFromRangeMappings=n.StandardLinesDiffComputer=void 0;class h{constructor(){this.dynamicProgrammingDiffing=new v.DynamicProgrammingDiffing,this.myersDiffingAlgorithm=new m.MyersDiffAlgorithm}computeDiff(P,T,z){if(P.length<=1&&(0,E.equals)(P,T,(G,X)=>G===X))return new c.LinesDiff([],[],!1);if(P.length===1&&P[0].length===0||T.length===1&&T[0].length===0)return new c.LinesDiff([new c.LineRangeMapping(new u.LineRange(1,P.length+1),new u.LineRange(1,T.length+1),[new c.RangeMapping(new a.Range(1,1,P.length,P[0].length+1),new a.Range(1,1,T.length,T[0].length+1))])],[],!1);const U=z.maxComputationTimeMs===0?s.InfiniteTimeout.instance:new s.DateTimeout(z.maxComputationTimeMs),Z=!z.ignoreTrimWhitespace,ee=new Map;function t(G){let X=ee.get(G);return X===void 0&&(X=ee.size,ee.set(G,X)),X}const q=P.map(G=>t(G.trim())),V=T.map(G=>t(G.trim())),Y=new o(q,P),J=new o(V,T),ue=(()=>Y.length+J.length<1700?this.dynamicProgrammingDiffing.compute(Y,J,U,(G,X)=>P[G]===T[X]?T[X].length===0?.1:1+Math.log(1+T[X].length):.99):this.myersDiffingAlgorithm.compute(Y,J))();let le=ue.diffs,fe=ue.hitTimeout;le=(0,e.optimizeSequenceDiffs)(Y,J,le),le=(0,e.removeRandomLineMatches)(Y,J,le);const me=[],be=G=>{if(Z)for(let X=0;X<G;X++){const te=ve+X,ae=$+X;if(P[te]!==T[ae]){const oe=this.refineDiff(P,T,new s.SequenceDiff(new d.OffsetRange(te,te+1),new d.OffsetRange(ae,ae+1)),U,Z);for(const he of oe.mappings)me.push(he);oe.hitTimeout&&(fe=!0)}}};let ve=0,$=0;for(const G of le){(0,M.assertFn)(()=>G.seq1Range.start-ve===G.seq2Range.start-$);const X=G.seq1Range.start-ve;be(X),ve=G.seq1Range.endExclusive,$=G.seq2Range.endExclusive;const te=this.refineDiff(P,T,G,U,Z);te.hitTimeout&&(fe=!0);for(const ae of te.mappings)me.push(ae)}be(P.length-ve);const H=S(me,P,T);let j=[];return z.computeMoves&&(j=this.computeMoves(H,P,T,q,V,U,Z)),(0,M.assertFn)(()=>{function G(te,ae){if(te.lineNumber<1||te.lineNumber>ae.length)return!1;const oe=ae[te.lineNumber-1];return!(te.column<1||te.column>oe.length+1)}function X(te,ae){return!(te.startLineNumber<1||te.startLineNumber>ae.length+1||te.endLineNumberExclusive<1||te.endLineNumberExclusive>ae.length+1)}for(const te of H){if(!te.innerChanges)return!1;for(const ae of te.innerChanges)if(!(G(ae.modifiedRange.getStartPosition(),T)&&G(ae.modifiedRange.getEndPosition(),T)&&G(ae.originalRange.getStartPosition(),P)&&G(ae.originalRange.getEndPosition(),P)))return!1;if(!X(te.modifiedRange,T)||!X(te.originalRange,P))return!1}return!0}),new c.LinesDiff(H,j,fe)}computeMoves(P,T,z,U,Z,ee,t){const q=[],V=P.filter($=>$.modifiedRange.isEmpty&&$.originalRange.length>=3).map($=>new I($.originalRange,T,$)),Y=new Set(P.filter($=>$.originalRange.isEmpty&&$.modifiedRange.length>=3).map($=>new I($.modifiedRange,z,$))),J=new Set;for(const $ of V){let H=-1,j;for(const G of Y){const X=$.computeSimilarity(G);X>H&&(H=X,j=G)}if(H>.9&&j&&(Y.delete(j),q.push(new c.SimpleLineRangeMapping($.range,j.range)),J.add($.source),J.add(j.source)),!ee.isValid())return[]}const ue=new i.SetMap;for(const $ of P)if(!J.has($))for(let H=$.originalRange.startLineNumber;H<$.originalRange.endLineNumberExclusive-2;H++){const j=`${U[H-1]}:${U[H+1-1]}:${U[H+2-1]}`;ue.add(j,{range:new u.LineRange(H,H+3)})}const le=[];P.sort((0,E.compareBy)($=>$.modifiedRange.startLineNumber,E.numberComparator));for(const $ of P){if(J.has($))continue;let H=[];for(let j=$.modifiedRange.startLineNumber;j<$.modifiedRange.endLineNumberExclusive-2;j++){const G=`${Z[j-1]}:${Z[j+1-1]}:${Z[j+2-1]}`,X=new u.LineRange(j,j+3),te=[];ue.forEach(G,({range:ae})=>{for(const he of H)if(he.originalLineRange.endLineNumberExclusive+1===ae.endLineNumberExclusive&&he.modifiedLineRange.endLineNumberExclusive+1===X.endLineNumberExclusive){he.originalLineRange=new u.LineRange(he.originalLineRange.startLineNumber,ae.endLineNumberExclusive),he.modifiedLineRange=new u.LineRange(he.modifiedLineRange.startLineNumber,X.endLineNumberExclusive),te.push(he);return}const oe={modifiedLineRange:X,originalLineRange:ae};le.push(oe),te.push(oe)}),H=te}if(!ee.isValid())return[]}le.sort((0,E.reverseOrder)((0,E.compareBy)($=>$.modifiedLineRange.length,E.numberComparator)));const fe=new f,me=new f;for(const $ of le){const H=$.modifiedLineRange.startLineNumber-$.originalLineRange.startLineNumber,j=fe.subtractFrom($.modifiedLineRange),G=me.subtractFrom($.originalLineRange).map(te=>te.delta(H)),X=p(j,G);for(const te of X){if(te.length<3)continue;const ae=te,oe=te.delta(-H);q.push(new c.SimpleLineRangeMapping(oe,ae)),fe.addRange(ae),me.addRange(oe)}}if(q.sort((0,E.compareBy)($=>$.original.startLineNumber,E.numberComparator)),q.length===0)return[];const be=[q[0]];for(let $=1;$<q.length;$++){const H=be[be.length-1],j=q[$],G=j.original.startLineNumber-H.original.endLineNumberExclusive,X=j.modified.startLineNumber-H.modified.endLineNumberExclusive;if(G>=0&&X>=0&&G<=1&&X<=1){be[be.length-1]=H.join(j);continue}j.original.toOffsetRange().slice(T).map(oe=>oe.trim()).join(`
`).length<=10||be.push(j)}return be.map($=>{const H=this.refineDiff(T,z,new s.SequenceDiff($.original.toOffsetRange(),$.modified.toOffsetRange()),ee,t),j=S(H.mappings,T,z,!0);return new c.MovedText($,j)})}refineDiff(P,T,z,U,Z){const ee=new _(P,z.seq1Range,Z),t=new _(T,z.seq2Range,Z),q=ee.length+t.length<500?this.dynamicProgrammingDiffing.compute(ee,t,U):this.myersDiffingAlgorithm.compute(ee,t,U);let V=q.diffs;return V=(0,e.optimizeSequenceDiffs)(ee,t,V),V=w(ee,t,V),V=(0,e.smoothenSequenceDiffs)(ee,t,V),V=(0,e.removeRandomMatches)(ee,t,V),{mappings:V.map(J=>new c.RangeMapping(ee.translateRange(J.seq1Range),t.translateRange(J.seq2Range))),hitTimeout:q.hitTimeout}}}n.StandardLinesDiffComputer=h;function p(k,P){const T=[];let z=0,U=0;for(;z<k.length&&U<P.length;){const Z=k[z],ee=P[U],t=Z.intersect(ee);t&&!t.isEmpty&&T.push(t),Z.endLineNumberExclusive<ee.endLineNumberExclusive?z++:U++}return T}class f{constructor(){this._normalizedRanges=[]}addRange(P){const T=y(this._normalizedRanges.findIndex(U=>U.endLineNumberExclusive>=P.startLineNumber),this._normalizedRanges.length),z=(0,E.findLastIndex)(this._normalizedRanges,U=>U.startLineNumber<=P.endLineNumberExclusive)+1;if(T===z)this._normalizedRanges.splice(T,0,P);else if(T===z-1){const U=this._normalizedRanges[T];this._normalizedRanges[T]=U.join(P)}else{const U=this._normalizedRanges[T].join(this._normalizedRanges[z-1]).join(P);this._normalizedRanges.splice(T,z-T,U)}}subtractFrom(P){const T=y(this._normalizedRanges.findIndex(ee=>ee.endLineNumberExclusive>=P.startLineNumber),this._normalizedRanges.length),z=(0,E.findLastIndex)(this._normalizedRanges,ee=>ee.startLineNumber<=P.endLineNumberExclusive)+1;if(T===z)return[P];const U=[];let Z=P.startLineNumber;for(let ee=T;ee<z;ee++){const t=this._normalizedRanges[ee];t.startLineNumber>Z&&U.push(new u.LineRange(Z,t.startLineNumber)),Z=t.endLineNumberExclusive}return Z<P.endLineNumberExclusive&&U.push(new u.LineRange(Z,P.endLineNumberExclusive)),U}}function y(k,P){return k===-1?P:k}function w(k,P,T){const z=[];let U;function Z(){if(!U)return;const t=U.s1Range.length-U.deleted,q=U.s2Range.length-U.added;Math.max(U.deleted,U.added)+(U.count-1)>t&&z.push(new s.SequenceDiff(U.s1Range,U.s2Range)),U=void 0}for(const t of T){let q=function(le,fe){var me,be,ve,$;if(!U||!U.s1Range.containsRange(le)||!U.s2Range.containsRange(fe))if(U&&!(U.s1Range.endExclusive<le.start&&U.s2Range.endExclusive<fe.start)){const G=d.OffsetRange.tryCreate(U.s1Range.endExclusive,le.start),X=d.OffsetRange.tryCreate(U.s2Range.endExclusive,fe.start);U.deleted+=(me=G?.length)!==null&&me!==void 0?me:0,U.added+=(be=X?.length)!==null&&be!==void 0?be:0,U.s1Range=U.s1Range.join(le),U.s2Range=U.s2Range.join(fe)}else Z(),U={added:0,deleted:0,count:0,s1Range:le,s2Range:fe};const H=le.intersect(t.seq1Range),j=fe.intersect(t.seq2Range);U.count++,U.deleted+=(ve=H?.length)!==null&&ve!==void 0?ve:0,U.added+=($=j?.length)!==null&&$!==void 0?$:0};const V=k.findWordContaining(t.seq1Range.start-1),Y=P.findWordContaining(t.seq2Range.start-1),J=k.findWordContaining(t.seq1Range.endExclusive),ue=P.findWordContaining(t.seq2Range.endExclusive);V&&J&&Y&&ue&&V.equals(J)&&Y.equals(ue)?q(V,Y):(V&&Y&&q(V,Y),J&&ue&&q(J,ue))}return Z(),R(T,z)}function R(k,P){const T=[];for(;k.length>0||P.length>0;){const z=k[0],U=P[0];let Z;z&&(!U||z.seq1Range.start<U.seq1Range.start)?Z=k.shift():Z=P.shift(),T.length>0&&T[T.length-1].seq1Range.endExclusive>=Z.seq1Range.start?T[T.length-1]=T[T.length-1].join(Z):T.push(Z)}return T}function S(k,P,T,z=!1){const U=[];for(const Z of r(k.map(ee=>L(ee,P,T)),(ee,t)=>ee.originalRange.overlapOrTouch(t.originalRange)||ee.modifiedRange.overlapOrTouch(t.modifiedRange))){const ee=Z[0],t=Z[Z.length-1];U.push(new c.LineRangeMapping(ee.originalRange.join(t.originalRange),ee.modifiedRange.join(t.modifiedRange),Z.map(q=>q.innerChanges[0])))}return(0,M.assertFn)(()=>!z&&U.length>0&&U[0].originalRange.startLineNumber!==U[0].modifiedRange.startLineNumber?!1:(0,M.checkAdjacentItems)(U,(Z,ee)=>ee.originalRange.startLineNumber-Z.originalRange.endLineNumberExclusive===ee.modifiedRange.startLineNumber-Z.modifiedRange.endLineNumberExclusive&&Z.originalRange.endLineNumberExclusive<ee.originalRange.startLineNumber&&Z.modifiedRange.endLineNumberExclusive<ee.modifiedRange.startLineNumber)),U}n.lineRangeMappingFromRangeMappings=S;function L(k,P,T){let z=0,U=0;k.modifiedRange.endColumn===1&&k.originalRange.endColumn===1&&k.originalRange.startLineNumber+z<=k.originalRange.endLineNumber&&k.modifiedRange.startLineNumber+z<=k.modifiedRange.endLineNumber&&(U=-1),k.modifiedRange.startColumn-1>=T[k.modifiedRange.startLineNumber-1].length&&k.originalRange.startColumn-1>=P[k.originalRange.startLineNumber-1].length&&k.originalRange.startLineNumber<=k.originalRange.endLineNumber+U&&k.modifiedRange.startLineNumber<=k.modifiedRange.endLineNumber+U&&(z=1);const Z=new u.LineRange(k.originalRange.startLineNumber+z,k.originalRange.endLineNumber+1+U),ee=new u.LineRange(k.modifiedRange.startLineNumber+z,k.modifiedRange.endLineNumber+1+U);return new c.LineRangeMapping(Z,ee,[k])}n.getLineRangeMapping=L;function*r(k,P){let T,z;for(const U of k)z!==void 0&&P(z,U)?T.push(U):(T&&(yield T),T=[U]),z=U;T&&(yield T)}class o{constructor(P,T){this.trimmedHash=P,this.lines=T}getElement(P){return this.trimmedHash[P]}get length(){return this.trimmedHash.length}getBoundaryScore(P){const T=P===0?0:l(this.lines[P-1]),z=P===this.lines.length?0:l(this.lines[P]);return 1e3-(T+z)}getText(P){return this.lines.slice(P.start,P.endExclusive).join(`
`)}isStronglyEqual(P,T){return this.lines[P]===this.lines[T]}}n.LineSequence=o;function l(k){let P=0;for(;P<k.length&&(k.charCodeAt(P)===32||k.charCodeAt(P)===9);)P++;return P}class _{constructor(P,T,z){this.lines=P,this.considerWhitespaceChanges=z,this.elements=[],this.firstCharOffsetByLineMinusOne=[],this.additionalOffsetByLine=[];let U=!1;T.start>0&&T.endExclusive>=P.length&&(T=new d.OffsetRange(T.start-1,T.endExclusive),U=!0),this.lineRange=T;for(let Z=this.lineRange.start;Z<this.lineRange.endExclusive;Z++){let ee=P[Z],t=0;if(U)t=ee.length,ee="",U=!1;else if(!z){const q=ee.trimStart();t=ee.length-q.length,ee=q.trimEnd()}this.additionalOffsetByLine.push(t);for(let q=0;q<ee.length;q++)this.elements.push(ee.charCodeAt(q));Z<P.length-1&&(this.elements.push(`
`.charCodeAt(0)),this.firstCharOffsetByLineMinusOne[Z-this.lineRange.start]=this.elements.length)}this.additionalOffsetByLine.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new d.OffsetRange(0,this.length))}getText(P){return this.elements.slice(P.start,P.endExclusive).map(T=>String.fromCharCode(T)).join("")}getElement(P){return this.elements[P]}get length(){return this.elements.length}getBoundaryScore(P){const T=N(P>0?this.elements[P-1]:-1),z=N(P<this.elements.length?this.elements[P]:-1);if(T===6&&z===7)return 0;let U=0;return T!==z&&(U+=10,z===1&&(U+=1)),U+=A(T),U+=A(z),U}translateOffset(P){if(this.lineRange.isEmpty)return new g.Position(this.lineRange.start+1,1);let T=0,z=this.firstCharOffsetByLineMinusOne.length;for(;T<z;){const Z=Math.floor((T+z)/2);this.firstCharOffsetByLineMinusOne[Z]>P?z=Z:T=Z+1}const U=T===0?0:this.firstCharOffsetByLineMinusOne[T-1];return new g.Position(this.lineRange.start+T+1,P-U+1+this.additionalOffsetByLine[T])}translateRange(P){return a.Range.fromPositions(this.translateOffset(P.start),this.translateOffset(P.endExclusive))}findWordContaining(P){if(P<0||P>=this.elements.length||!b(this.elements[P]))return;let T=P;for(;T>0&&b(this.elements[T-1]);)T--;let z=P;for(;z<this.elements.length&&b(this.elements[z]);)z++;return new d.OffsetRange(T,z)}countLinesIn(P){return this.translateOffset(P.endExclusive).lineNumber-this.translateOffset(P.start).lineNumber}isStronglyEqual(P,T){return this.elements[P]===this.elements[T]}}n.LinesSliceCharSequence=_;function b(k){return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57}const C={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function A(k){return C[k]}function N(k){return k===10?7:k===13?6:D(k)?5:k>=97&&k<=122?0:k>=65&&k<=90?1:k>=48&&k<=57?2:k===-1?3:4}function D(k){return k===32||k===9}const x=new Map;function W(k){let P=x.get(k);return P===void 0&&(P=x.size,x.set(k,P)),P}class I{constructor(P,T,z){this.range=P,this.lines=T,this.source=z,this.histogram=[];let U=0;for(let Z=P.startLineNumber-1;Z<P.endLineNumberExclusive-1;Z++){const ee=T[Z];for(let q=0;q<ee.length;q++){U++;const V=ee[q],Y=W(V);this.histogram[Y]=(this.histogram[Y]||0)+1}U++;const t=W(`
`);this.histogram[t]=(this.histogram[t]||0)+1}this.totalCount=U}computeSimilarity(P){var T,z;let U=0;const Z=Math.max(this.histogram.length,P.histogram.length);for(let ee=0;ee<Z;ee++)U+=Math.abs(((T=this.histogram[ee])!==null&&T!==void 0?T:0)-((z=P.histogram[ee])!==null&&z!==void 0?z:0));return 1-U/(this.totalCount+P.totalCount)}}}),ne(ie[44],re([0,1,42,43]),function(O,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.linesDiffComputers=void 0,n.linesDiffComputers={getLegacy:()=>new E.SmartLinesDiffComputer,getAdvanced:()=>new M.StandardLinesDiffComputer}}),ne(ie[45],re([0,1,29]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeDefaultDocumentColors=void 0;function M(m){const c=[];for(const h of m){const p=Number(h);(p||p===0&&h.replace(/\s/g,"")!=="")&&c.push(p)}return c}function i(m,c,h,p){return{red:m/255,blue:h/255,green:c/255,alpha:p}}function u(m,c){const h=c.index,p=c[0].length;if(!h)return;const f=m.positionAt(h);return{startLineNumber:f.lineNumber,startColumn:f.column,endLineNumber:f.lineNumber,endColumn:f.column+p}}function d(m,c){if(!m)return;const h=E.Color.Format.CSS.parseHex(c);if(h)return{range:m,color:i(h.rgba.r,h.rgba.g,h.rgba.b,h.rgba.a)}}function g(m,c,h){if(!m||c.length!==1)return;const f=c[0].values(),y=M(f);return{range:m,color:i(y[0],y[1],y[2],h?y[3]:1)}}function a(m,c,h){if(!m||c.length!==1)return;const f=c[0].values(),y=M(f),w=new E.Color(new E.HSLA(y[0],y[1]/100,y[2]/100,h?y[3]:1));return{range:m,color:i(w.rgba.r,w.rgba.g,w.rgba.b,w.rgba.a)}}function s(m,c){return typeof m=="string"?[...m.matchAll(c)]:m.findMatches(c)}function v(m){const c=[],p=s(m,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(p.length>0)for(const f of p){const y=f.filter(L=>L!==void 0),w=y[1],R=y[2];if(!R)continue;let S;if(w==="rgb"){const L=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;S=g(u(m,f),s(R,L),!1)}else if(w==="rgba"){const L=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;S=g(u(m,f),s(R,L),!0)}else if(w==="hsl"){const L=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;S=a(u(m,f),s(R,L),!1)}else if(w==="hsla"){const L=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;S=a(u(m,f),s(R,L),!0)}else w==="#"&&(S=d(u(m,f),w+R));S&&c.push(S)}return c}function e(m){return!m||typeof m.getValue!="function"||typeof m.positionAt!="function"?[]:v(m)}n.computeDefaultDocumentColors=e}),ne(ie[46],re([0,1,24]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.computeLinks=n.LinkComputer=n.StateMachine=void 0;class M{constructor(m,c,h){const p=new Uint8Array(m*c);for(let f=0,y=m*c;f<y;f++)p[f]=h;this._data=p,this.rows=m,this.cols=c}get(m,c){return this._data[m*this.cols+c]}set(m,c,h){this._data[m*this.cols+c]=h}}class i{constructor(m){let c=0,h=0;for(let f=0,y=m.length;f<y;f++){const[w,R,S]=m[f];R>c&&(c=R),w>h&&(h=w),S>h&&(h=S)}c++,h++;const p=new M(h,c,0);for(let f=0,y=m.length;f<y;f++){const[w,R,S]=m[f];p.set(w,R,S)}this._states=p,this._maxCharCode=c}nextState(m,c){return c<0||c>=this._maxCharCode?0:this._states.get(m,c)}}n.StateMachine=i;let u=null;function d(){return u===null&&(u=new i([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),u}let g=null;function a(){if(g===null){g=new E.CharacterClassifier(0);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let c=0;c<e.length;c++)g.set(e.charCodeAt(c),1);const m=".,;:";for(let c=0;c<m.length;c++)g.set(m.charCodeAt(c),2)}return g}class s{static _createLink(m,c,h,p,f){let y=f-1;do{const w=c.charCodeAt(y);if(m.get(w)!==2)break;y--}while(y>p);if(p>0){const w=c.charCodeAt(p-1),R=c.charCodeAt(y);(w===40&&R===41||w===91&&R===93||w===123&&R===125)&&y--}return{range:{startLineNumber:h,startColumn:p+1,endLineNumber:h,endColumn:y+2},url:c.substring(p,y+1)}}static computeLinks(m,c=d()){const h=a(),p=[];for(let f=1,y=m.getLineCount();f<=y;f++){const w=m.getLineContent(f),R=w.length;let S=0,L=0,r=0,o=1,l=!1,_=!1,b=!1,C=!1;for(;S<R;){let A=!1;const N=w.charCodeAt(S);if(o===13){let D;switch(N){case 40:l=!0,D=0;break;case 41:D=l?0:1;break;case 91:b=!0,_=!0,D=0;break;case 93:b=!1,D=_?0:1;break;case 123:C=!0,D=0;break;case 125:D=C?0:1;break;case 39:case 34:case 96:r===N?D=1:r===39||r===34||r===96?D=0:D=1;break;case 42:D=r===42?1:0;break;case 124:D=r===124?1:0;break;case 32:D=b?0:1;break;default:D=h.get(N)}D===1&&(p.push(s._createLink(h,w,f,L,S)),A=!0)}else if(o===12){let D;N===91?(_=!0,D=0):D=h.get(N),D===1?A=!0:o=13}else o=c.nextState(o,N),o===0&&(A=!0);A&&(o=1,l=!1,_=!1,C=!1,L=S+1,r=N),S++}o===13&&p.push(s._createLink(h,w,f,L,R))}return p}}n.LinkComputer=s;function v(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:s.computeLinks(e)}n.computeLinks=v}),ne(ie[47],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.BasicInplaceReplace=void 0;class E{constructor(){this._defaultValueSet=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(i,u,d,g,a){if(i&&u){const s=this.doNavigateValueSet(u,a);if(s)return{range:i,value:s}}if(d&&g){const s=this.doNavigateValueSet(g,a);if(s)return{range:d,value:s}}return null}doNavigateValueSet(i,u){const d=this.numberReplace(i,u);return d!==null?d:this.textReplace(i,u)}numberReplace(i,u){const d=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let g=Number(i);const a=parseFloat(i);return!isNaN(g)&&!isNaN(a)&&g===a?g===0&&!u?null:(g=Math.floor(g*d),g+=u?d:-d,String(g/d)):null}textReplace(i,u){return this.valueSetsReplace(this._defaultValueSet,i,u)}valueSetsReplace(i,u,d){let g=null;for(let a=0,s=i.length;g===null&&a<s;a++)g=this.valueSetReplace(i[a],u,d);return g}valueSetReplace(i,u,d){let g=i.indexOf(u);return g>=0?(g+=d?1:-1,g<0?g=i.length-1:g%=i.length,i[g]):null}}n.BasicInplaceReplace=E,E.INSTANCE=new E}),ne(ie[48],re([0,1,11]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.shouldSynchronizeModel=n.ApplyEditsResult=n.SearchData=n.ValidAnnotatedEditOperation=n.isITextSnapshot=n.FindMatch=n.TextModelResolvedOptions=n.InjectedTextCursorStops=n.MinimapPosition=n.GlyphMarginLane=n.OverviewRulerLane=void 0;var M;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(M||(n.OverviewRulerLane=M={}));var i;(function(h){h[h.Left=1]="Left",h[h.Right=2]="Right"})(i||(n.GlyphMarginLane=i={}));var u;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(u||(n.MinimapPosition=u={}));var d;(function(h){h[h.Both=0]="Both",h[h.Right=1]="Right",h[h.Left=2]="Left",h[h.None=3]="None"})(d||(n.InjectedTextCursorStops=d={}));class g{get originalIndentSize(){return this._indentSizeIsTabSize?"tabSize":this.indentSize}constructor(p){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,p.tabSize|0),p.indentSize==="tabSize"?(this.indentSize=this.tabSize,this._indentSizeIsTabSize=!0):(this.indentSize=Math.max(1,p.indentSize|0),this._indentSizeIsTabSize=!1),this.insertSpaces=!!p.insertSpaces,this.defaultEOL=p.defaultEOL|0,this.trimAutoWhitespace=!!p.trimAutoWhitespace,this.bracketPairColorizationOptions=p.bracketPairColorizationOptions}equals(p){return this.tabSize===p.tabSize&&this._indentSizeIsTabSize===p._indentSizeIsTabSize&&this.indentSize===p.indentSize&&this.insertSpaces===p.insertSpaces&&this.defaultEOL===p.defaultEOL&&this.trimAutoWhitespace===p.trimAutoWhitespace&&(0,E.equals)(this.bracketPairColorizationOptions,p.bracketPairColorizationOptions)}createChangeEvent(p){return{tabSize:this.tabSize!==p.tabSize,indentSize:this.indentSize!==p.indentSize,insertSpaces:this.insertSpaces!==p.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==p.trimAutoWhitespace}}}n.TextModelResolvedOptions=g;class a{constructor(p,f){this._findMatchBrand=void 0,this.range=p,this.matches=f}}n.FindMatch=a;function s(h){return h&&typeof h.read=="function"}n.isITextSnapshot=s;class v{constructor(p,f,y,w,R,S){this.identifier=p,this.range=f,this.text=y,this.forceMoveMarkers=w,this.isAutoWhitespaceEdit=R,this._isTracked=S}}n.ValidAnnotatedEditOperation=v;class e{constructor(p,f,y){this.regex=p,this.wordSeparators=f,this.simpleSearch=y}}n.SearchData=e;class m{constructor(p,f,y){this.reverseEdits=p,this.changes=f,this.trimAutoWhitespaceLineNumbers=y}}n.ApplyEditsResult=m;function c(h){return!h.isTooLargeForSyncing()&&!h.isForSimpleWidget}n.shouldSynchronizeModel=c}),ne(ie[49],re([0,1,16,23]),function(O,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.PrefixSumIndexOfResult=n.ConstantTimePrefixSumComputer=n.PrefixSumComputer=void 0;class i{constructor(a){this.values=a,this.prefixSum=new Uint32Array(a.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}insertValues(a,s){a=(0,M.toUint32)(a);const v=this.values,e=this.prefixSum,m=s.length;return m===0?!1:(this.values=new Uint32Array(v.length+m),this.values.set(v.subarray(0,a),0),this.values.set(v.subarray(a),a+m),this.values.set(s,a),a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}setValue(a,s){return a=(0,M.toUint32)(a),s=(0,M.toUint32)(s),this.values[a]===s?!1:(this.values[a]=s,a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),!0)}removeValues(a,s){a=(0,M.toUint32)(a),s=(0,M.toUint32)(s);const v=this.values,e=this.prefixSum;if(a>=v.length)return!1;const m=v.length-a;return s>=m&&(s=m),s===0?!1:(this.values=new Uint32Array(v.length-s),this.values.set(v.subarray(0,a),0),this.values.set(v.subarray(a+s),a),this.prefixSum=new Uint32Array(this.values.length),a-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=a-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(e.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(a){return a<0?0:(a=(0,M.toUint32)(a),this._getPrefixSum(a))}_getPrefixSum(a){if(a<=this.prefixSumValidIndex[0])return this.prefixSum[a];let s=this.prefixSumValidIndex[0]+1;s===0&&(this.prefixSum[0]=this.values[0],s++),a>=this.values.length&&(a=this.values.length-1);for(let v=s;v<=a;v++)this.prefixSum[v]=this.prefixSum[v-1]+this.values[v];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],a),this.prefixSum[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let s=0,v=this.values.length-1,e=0,m=0,c=0;for(;s<=v;)if(e=s+(v-s)/2|0,m=this.prefixSum[e],c=m-this.values[e],a<c)v=e-1;else if(a>=m)s=e+1;else break;return new d(e,a-c)}}n.PrefixSumComputer=i;class u{constructor(a){this._values=a,this._isValid=!1,this._validEndIndex=-1,this._prefixSum=[],this._indexBySum=[]}getTotalSum(){return this._ensureValid(),this._indexBySum.length}getPrefixSum(a){return this._ensureValid(),a===0?0:this._prefixSum[a-1]}getIndexOf(a){this._ensureValid();const s=this._indexBySum[a],v=s>0?this._prefixSum[s-1]:0;return new d(s,a-v)}removeValues(a,s){this._values.splice(a,s),this._invalidate(a)}insertValues(a,s){this._values=(0,E.arrayInsert)(this._values,a,s),this._invalidate(a)}_invalidate(a){this._isValid=!1,this._validEndIndex=Math.min(this._validEndIndex,a-1)}_ensureValid(){if(!this._isValid){for(let a=this._validEndIndex+1,s=this._values.length;a<s;a++){const v=this._values[a],e=a>0?this._prefixSum[a-1]:0;this._prefixSum[a]=e+v;for(let m=0;m<v;m++)this._indexBySum[e+m]=a}this._prefixSum.length=this._values.length,this._indexBySum.length=this._prefixSum[this._prefixSum.length-1],this._isValid=!0,this._validEndIndex=this._values.length-1}}setValue(a,s){this._values[a]!==s&&(this._values[a]=s,this._invalidate(a))}}n.ConstantTimePrefixSumComputer=u;class d{constructor(a,s){this.index=a,this.remainder=s,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=s}}n.PrefixSumIndexOfResult=d}),ne(ie[50],re([0,1,5,3,49]),function(O,n,E,M,i){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.MirrorTextModel=void 0;class u{constructor(g,a,s,v){this._uri=g,this._lines=a,this._eol=s,this._versionId=v,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(g){g.eol&&g.eol!==this._eol&&(this._eol=g.eol,this._lineStarts=null);const a=g.changes;for(const s of a)this._acceptDeleteRange(s.range),this._acceptInsertText(new M.Position(s.range.startLineNumber,s.range.startColumn),s.text);this._versionId=g.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const g=this._eol.length,a=this._lines.length,s=new Uint32Array(a);for(let v=0;v<a;v++)s[v]=this._lines[v].length+g;this._lineStarts=new i.PrefixSumComputer(s)}}_setLineText(g,a){this._lines[g]=a,this._lineStarts&&this._lineStarts.setValue(g,this._lines[g].length+this._eol.length)}_acceptDeleteRange(g){if(g.startLineNumber===g.endLineNumber){if(g.startColumn===g.endColumn)return;this._setLineText(g.startLineNumber-1,this._lines[g.startLineNumber-1].substring(0,g.startColumn-1)+this._lines[g.startLineNumber-1].substring(g.endColumn-1));return}this._setLineText(g.startLineNumber-1,this._lines[g.startLineNumber-1].substring(0,g.startColumn-1)+this._lines[g.endLineNumber-1].substring(g.endColumn-1)),this._lines.splice(g.startLineNumber,g.endLineNumber-g.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(g.startLineNumber,g.endLineNumber-g.startLineNumber)}_acceptInsertText(g,a){if(a.length===0)return;const s=(0,E.splitLines)(a);if(s.length===1){this._setLineText(g.lineNumber-1,this._lines[g.lineNumber-1].substring(0,g.column-1)+s[0]+this._lines[g.lineNumber-1].substring(g.column-1));return}s[s.length-1]+=this._lines[g.lineNumber-1].substring(g.column-1),this._setLineText(g.lineNumber-1,this._lines[g.lineNumber-1].substring(0,g.column-1)+s[0]);const v=new Uint32Array(s.length-1);for(let e=1;e<s.length;e++)this._lines.splice(g.lineNumber+e-1,0,s[e]),v[e-1]=s[e].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(g.lineNumber,v)}}n.MirrorTextModel=u}),ne(ie[51],re([0,1,5,37,3,2,48]),function(O,n,E,M,i,u,d){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.Searcher=n.isValidMatch=n.TextModelSearch=n.createFindMatch=n.isMultilineRegexSource=n.SearchParams=void 0;const g=999;class a{constructor(w,R,S,L){this.searchString=w,this.isRegex=R,this.matchCase=S,this.wordSeparators=L}parseSearchRequest(){if(this.searchString==="")return null;let w;this.isRegex?w=s(this.searchString):w=this.searchString.indexOf(`
`)>=0;let R=null;try{R=E.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:w,global:!0,unicode:!0})}catch{return null}if(!R)return null;let S=!this.isRegex&&!w;return S&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(S=this.matchCase),new d.SearchData(R,this.wordSeparators?(0,M.getMapForWordSeparators)(this.wordSeparators):null,S?this.searchString:null)}}n.SearchParams=a;function s(y){if(!y||y.length===0)return!1;for(let w=0,R=y.length;w<R;w++){const S=y.charCodeAt(w);if(S===10)return!0;if(S===92){if(w++,w>=R)break;const L=y.charCodeAt(w);if(L===110||L===114||L===87)return!0}}return!1}n.isMultilineRegexSource=s;function v(y,w,R){if(!R)return new d.FindMatch(y,null);const S=[];for(let L=0,r=w.length;L<r;L++)S[L]=w[L];return new d.FindMatch(y,S)}n.createFindMatch=v;class e{constructor(w){const R=[];let S=0;for(let L=0,r=w.length;L<r;L++)w.charCodeAt(L)===10&&(R[S++]=L);this._lineFeedsOffsets=R}findLineFeedCountBeforeOffset(w){const R=this._lineFeedsOffsets;let S=0,L=R.length-1;if(L===-1||w<=R[0])return 0;for(;S<L;){const r=S+((L-S)/2>>0);R[r]>=w?L=r-1:R[r+1]>=w?(S=r,L=r):S=r+1}return S+1}}class m{static findMatches(w,R,S,L,r){const o=R.parseSearchRequest();return o?o.regex.multiline?this._doFindMatchesMultiline(w,S,new f(o.wordSeparators,o.regex),L,r):this._doFindMatchesLineByLine(w,S,o,L,r):[]}static _getMultilineMatchRange(w,R,S,L,r,o){let l,_=0;L?(_=L.findLineFeedCountBeforeOffset(r),l=R+r+_):l=R+r;let b;if(L){const D=L.findLineFeedCountBeforeOffset(r+o.length)-_;b=l+o.length+D}else b=l+o.length;const C=w.getPositionAt(l),A=w.getPositionAt(b);return new u.Range(C.lineNumber,C.column,A.lineNumber,A.column)}static _doFindMatchesMultiline(w,R,S,L,r){const o=w.getOffsetAt(R.getStartPosition()),l=w.getValueInRange(R,1),_=w.getEOL()===`\r
`?new e(l):null,b=[];let C=0,A;for(S.reset(0);A=S.next(l);)if(b[C++]=v(this._getMultilineMatchRange(w,o,l,_,A.index,A[0]),A,L),C>=r)return b;return b}static _doFindMatchesLineByLine(w,R,S,L,r){const o=[];let l=0;if(R.startLineNumber===R.endLineNumber){const b=w.getLineContent(R.startLineNumber).substring(R.startColumn-1,R.endColumn-1);return l=this._findMatchesInLine(S,b,R.startLineNumber,R.startColumn-1,l,o,L,r),o}const _=w.getLineContent(R.startLineNumber).substring(R.startColumn-1);l=this._findMatchesInLine(S,_,R.startLineNumber,R.startColumn-1,l,o,L,r);for(let b=R.startLineNumber+1;b<R.endLineNumber&&l<r;b++)l=this._findMatchesInLine(S,w.getLineContent(b),b,0,l,o,L,r);if(l<r){const b=w.getLineContent(R.endLineNumber).substring(0,R.endColumn-1);l=this._findMatchesInLine(S,b,R.endLineNumber,0,l,o,L,r)}return o}static _findMatchesInLine(w,R,S,L,r,o,l,_){const b=w.wordSeparators;if(!l&&w.simpleSearch){const N=w.simpleSearch,D=N.length,x=R.length;let W=-D;for(;(W=R.indexOf(N,W+D))!==-1;)if((!b||p(b,R,x,W,D))&&(o[r++]=new d.FindMatch(new u.Range(S,W+1+L,S,W+1+D+L),null),r>=_))return r;return r}const C=new f(w.wordSeparators,w.regex);let A;C.reset(0);do if(A=C.next(R),A&&(o[r++]=v(new u.Range(S,A.index+1+L,S,A.index+1+A[0].length+L),A,l),r>=_))return r;while(A);return r}static findNextMatch(w,R,S,L){const r=R.parseSearchRequest();if(!r)return null;const o=new f(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(w,S,o,L):this._doFindNextMatchLineByLine(w,S,o,L)}static _doFindNextMatchMultiline(w,R,S,L){const r=new i.Position(R.lineNumber,1),o=w.getOffsetAt(r),l=w.getLineCount(),_=w.getValueInRange(new u.Range(r.lineNumber,r.column,l,w.getLineMaxColumn(l)),1),b=w.getEOL()===`\r
`?new e(_):null;S.reset(R.column-1);const C=S.next(_);return C?v(this._getMultilineMatchRange(w,o,_,b,C.index,C[0]),C,L):R.lineNumber!==1||R.column!==1?this._doFindNextMatchMultiline(w,new i.Position(1,1),S,L):null}static _doFindNextMatchLineByLine(w,R,S,L){const r=w.getLineCount(),o=R.lineNumber,l=w.getLineContent(o),_=this._findFirstMatchInLine(S,l,o,R.column,L);if(_)return _;for(let b=1;b<=r;b++){const C=(o+b-1)%r,A=w.getLineContent(C+1),N=this._findFirstMatchInLine(S,A,C+1,1,L);if(N)return N}return null}static _findFirstMatchInLine(w,R,S,L,r){w.reset(L-1);const o=w.next(R);return o?v(new u.Range(S,o.index+1,S,o.index+1+o[0].length),o,r):null}static findPreviousMatch(w,R,S,L){const r=R.parseSearchRequest();if(!r)return null;const o=new f(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(w,S,o,L):this._doFindPreviousMatchLineByLine(w,S,o,L)}static _doFindPreviousMatchMultiline(w,R,S,L){const r=this._doFindMatchesMultiline(w,new u.Range(1,1,R.lineNumber,R.column),S,L,10*g);if(r.length>0)return r[r.length-1];const o=w.getLineCount();return R.lineNumber!==o||R.column!==w.getLineMaxColumn(o)?this._doFindPreviousMatchMultiline(w,new i.Position(o,w.getLineMaxColumn(o)),S,L):null}static _doFindPreviousMatchLineByLine(w,R,S,L){const r=w.getLineCount(),o=R.lineNumber,l=w.getLineContent(o).substring(0,R.column-1),_=this._findLastMatchInLine(S,l,o,L);if(_)return _;for(let b=1;b<=r;b++){const C=(r+o-b-1)%r,A=w.getLineContent(C+1),N=this._findLastMatchInLine(S,A,C+1,L);if(N)return N}return null}static _findLastMatchInLine(w,R,S,L){let r=null,o;for(w.reset(0);o=w.next(R);)r=v(new u.Range(S,o.index+1,S,o.index+1+o[0].length),o,L);return r}}n.TextModelSearch=m;function c(y,w,R,S,L){if(S===0)return!0;const r=w.charCodeAt(S-1);if(y.get(r)!==0||r===13||r===10)return!0;if(L>0){const o=w.charCodeAt(S);if(y.get(o)!==0)return!0}return!1}function h(y,w,R,S,L){if(S+L===R)return!0;const r=w.charCodeAt(S+L);if(y.get(r)!==0||r===13||r===10)return!0;if(L>0){const o=w.charCodeAt(S+L-1);if(y.get(o)!==0)return!0}return!1}function p(y,w,R,S,L){return c(y,w,R,S,L)&&h(y,w,R,S,L)}n.isValidMatch=p;class f{constructor(w,R){this._wordSeparators=w,this._searchRegex=R,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(w){this._searchRegex.lastIndex=w,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(w){const R=w.length;let S;do{if(this._prevMatchStartIndex+this._prevMatchLength===R||(S=this._searchRegex.exec(w),!S))return null;const L=S.index,r=S[0].length;if(L===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){E.getNextCodePoint(w,R,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=L,this._prevMatchLength=r,!this._wordSeparators||p(this._wordSeparators,w,R,L,r))return S}while(S);return null}}n.Searcher=f}),ne(ie[52],re([0,1,2,51,5,9,25]),function(O,n,E,M,i,u,d){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.UnicodeTextModelHighlighter=void 0;class g{static computeUnicodeHighlights(m,c,h){const p=h?h.startLineNumber:1,f=h?h.endLineNumber:m.getLineCount(),y=new s(c),w=y.getCandidateCodePoints();let R;w==="allNonBasicAscii"?R=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):R=new RegExp(`${a(Array.from(w))}`,"g");const S=new M.Searcher(null,R),L=[];let r=!1,o,l=0,_=0,b=0;e:for(let C=p,A=f;C<=A;C++){const N=m.getLineContent(C),D=N.length;S.reset(0);do if(o=S.next(N),o){let x=o.index,W=o.index+o[0].length;if(x>0){const T=N.charCodeAt(x-1);i.isHighSurrogate(T)&&x--}if(W+1<D){const T=N.charCodeAt(W-1);i.isHighSurrogate(T)&&W++}const I=N.substring(x,W);let k=(0,d.getWordAtText)(x+1,d.DEFAULT_WORD_REGEXP,N,0);k&&k.endColumn<=x+1&&(k=null);const P=y.shouldHighlightNonBasicASCII(I,k?k.word:null);if(P!==0){P===3?l++:P===2?_++:P===1?b++:(0,u.assertNever)(P);const T=1e3;if(L.length>=T){r=!0;break e}L.push(new E.Range(C,x+1,C,W+1))}}while(o)}return{ranges:L,hasMore:r,ambiguousCharacterCount:l,invisibleCharacterCount:_,nonBasicAsciiCharacterCount:b}}static computeUnicodeHighlightReason(m,c){const h=new s(c);switch(h.shouldHighlightNonBasicASCII(m,null)){case 0:return null;case 2:return{kind:1};case 3:{const f=m.codePointAt(0),y=h.ambiguousCharacters.getPrimaryConfusable(f),w=i.AmbiguousCharacters.getLocales().filter(R=>!i.AmbiguousCharacters.getInstance(new Set([...c.allowedLocales,R])).isAmbiguous(f));return{kind:0,confusableWith:String.fromCodePoint(y),notAmbiguousInLocales:w}}case 1:return{kind:2}}}}n.UnicodeTextModelHighlighter=g;function a(e,m){return`[${i.escapeRegExpCharacters(e.map(h=>String.fromCodePoint(h)).join(""))}]`}class s{constructor(m){this.options=m,this.allowedCodePoints=new Set(m.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(m.allowedLocales))}getCandidateCodePoints(){if(this.options.nonBasicASCII)return"allNonBasicAscii";const m=new Set;if(this.options.invisibleCharacters)for(const c of i.InvisibleCharacters.codePoints)v(String.fromCodePoint(c))||m.add(c);if(this.options.ambiguousCharacters)for(const c of this.ambiguousCharacters.getConfusableCodePoints())m.add(c);for(const c of this.allowedCodePoints)m.delete(c);return m}shouldHighlightNonBasicASCII(m,c){const h=m.codePointAt(0);if(this.allowedCodePoints.has(h))return 0;if(this.options.nonBasicASCII)return 1;let p=!1,f=!1;if(c)for(const y of c){const w=y.codePointAt(0),R=i.isBasicASCII(y);p=p||R,!R&&!this.ambiguousCharacters.isAmbiguous(w)&&!i.InvisibleCharacters.isInvisibleCharacter(w)&&(f=!0)}return!p&&f?0:this.options.invisibleCharacters&&!v(m)&&i.InvisibleCharacters.isInvisibleCharacter(h)?2:this.options.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(h)?3:0}}function v(e){return e===" "||e===`
`||e==="	"}}),ne(ie[53],re([0,1]),function(O,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.WrappingIndent=n.TrackedRangeStickiness=n.TextEditorCursorStyle=n.TextEditorCursorBlinkingStyle=n.SymbolTag=n.SymbolKind=n.SignatureHelpTriggerKind=n.SelectionDirection=n.ScrollbarVisibility=n.ScrollType=n.RenderMinimap=n.RenderLineNumbersType=n.PositionAffinity=n.OverviewRulerLane=n.OverlayWidgetPositionPreference=n.MouseTargetType=n.MinimapPosition=n.MarkerTag=n.MarkerSeverity=n.KeyCode=n.InlineCompletionTriggerKind=n.InlayHintKind=n.InjectedTextCursorStops=n.IndentAction=n.GlyphMarginLane=n.EndOfLineSequence=n.EndOfLinePreference=n.EditorOption=n.EditorAutoIndentStrategy=n.DocumentHighlightKind=n.DefaultEndOfLine=n.CursorChangeReason=n.ContentWidgetPositionPreference=n.CompletionTriggerKind=n.CompletionItemTag=n.CompletionItemKind=n.CompletionItemInsertTextRule=n.CodeActionTriggerType=n.AccessibilitySupport=void 0;var E;(function(t){t[t.Unknown=0]="Unknown",t[t.Disabled=1]="Disabled",t[t.Enabled=2]="Enabled"})(E||(n.AccessibilitySupport=E={}));var M;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(M||(n.CodeActionTriggerType=M={}));var i;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(i||(n.CompletionItemInsertTextRule=i={}));var u;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(u||(n.CompletionItemKind=u={}));var d;(function(t){t[t.Deprecated=1]="Deprecated"})(d||(n.CompletionItemTag=d={}));var g;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g||(n.CompletionTriggerKind=g={}));var a;(function(t){t[t.EXACT=0]="EXACT",t[t.ABOVE=1]="ABOVE",t[t.BELOW=2]="BELOW"})(a||(n.ContentWidgetPositionPreference=a={}));var s;(function(t){t[t.NotSet=0]="NotSet",t[t.ContentFlush=1]="ContentFlush",t[t.RecoverFromMarkers=2]="RecoverFromMarkers",t[t.Explicit=3]="Explicit",t[t.Paste=4]="Paste",t[t.Undo=5]="Undo",t[t.Redo=6]="Redo"})(s||(n.CursorChangeReason=s={}));var v;(function(t){t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(v||(n.DefaultEndOfLine=v={}));var e;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(e||(n.DocumentHighlightKind=e={}));var m;(function(t){t[t.None=0]="None",t[t.Keep=1]="Keep",t[t.Brackets=2]="Brackets",t[t.Advanced=3]="Advanced",t[t.Full=4]="Full"})(m||(n.EditorAutoIndentStrategy=m={}));var c;(function(t){t[t.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",t[t.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",t[t.accessibilitySupport=2]="accessibilitySupport",t[t.accessibilityPageSize=3]="accessibilityPageSize",t[t.ariaLabel=4]="ariaLabel",t[t.ariaRequired=5]="ariaRequired",t[t.autoClosingBrackets=6]="autoClosingBrackets",t[t.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",t[t.autoClosingDelete=8]="autoClosingDelete",t[t.autoClosingOvertype=9]="autoClosingOvertype",t[t.autoClosingQuotes=10]="autoClosingQuotes",t[t.autoIndent=11]="autoIndent",t[t.automaticLayout=12]="automaticLayout",t[t.autoSurround=13]="autoSurround",t[t.bracketPairColorization=14]="bracketPairColorization",t[t.guides=15]="guides",t[t.codeLens=16]="codeLens",t[t.codeLensFontFamily=17]="codeLensFontFamily",t[t.codeLensFontSize=18]="codeLensFontSize",t[t.colorDecorators=19]="colorDecorators",t[t.colorDecoratorsLimit=20]="colorDecoratorsLimit",t[t.columnSelection=21]="columnSelection",t[t.comments=22]="comments",t[t.contextmenu=23]="contextmenu",t[t.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",t[t.cursorBlinking=25]="cursorBlinking",t[t.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",t[t.cursorStyle=27]="cursorStyle",t[t.cursorSurroundingLines=28]="cursorSurroundingLines",t[t.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",t[t.cursorWidth=30]="cursorWidth",t[t.disableLayerHinting=31]="disableLayerHinting",t[t.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",t[t.domReadOnly=33]="domReadOnly",t[t.dragAndDrop=34]="dragAndDrop",t[t.dropIntoEditor=35]="dropIntoEditor",t[t.emptySelectionClipboard=36]="emptySelectionClipboard",t[t.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",t[t.extraEditorClassName=38]="extraEditorClassName",t[t.fastScrollSensitivity=39]="fastScrollSensitivity",t[t.find=40]="find",t[t.fixedOverflowWidgets=41]="fixedOverflowWidgets",t[t.folding=42]="folding",t[t.foldingStrategy=43]="foldingStrategy",t[t.foldingHighlight=44]="foldingHighlight",t[t.foldingImportsByDefault=45]="foldingImportsByDefault",t[t.foldingMaximumRegions=46]="foldingMaximumRegions",t[t.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",t[t.fontFamily=48]="fontFamily",t[t.fontInfo=49]="fontInfo",t[t.fontLigatures=50]="fontLigatures",t[t.fontSize=51]="fontSize",t[t.fontWeight=52]="fontWeight",t[t.fontVariations=53]="fontVariations",t[t.formatOnPaste=54]="formatOnPaste",t[t.formatOnType=55]="formatOnType",t[t.glyphMargin=56]="glyphMargin",t[t.gotoLocation=57]="gotoLocation",t[t.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",t[t.hover=59]="hover",t[t.inDiffEditor=60]="inDiffEditor",t[t.inlineSuggest=61]="inlineSuggest",t[t.letterSpacing=62]="letterSpacing",t[t.lightbulb=63]="lightbulb",t[t.lineDecorationsWidth=64]="lineDecorationsWidth",t[t.lineHeight=65]="lineHeight",t[t.lineNumbers=66]="lineNumbers",t[t.lineNumbersMinChars=67]="lineNumbersMinChars",t[t.linkedEditing=68]="linkedEditing",t[t.links=69]="links",t[t.matchBrackets=70]="matchBrackets",t[t.minimap=71]="minimap",t[t.mouseStyle=72]="mouseStyle",t[t.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",t[t.mouseWheelZoom=74]="mouseWheelZoom",t[t.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",t[t.multiCursorModifier=76]="multiCursorModifier",t[t.multiCursorPaste=77]="multiCursorPaste",t[t.multiCursorLimit=78]="multiCursorLimit",t[t.occurrencesHighlight=79]="occurrencesHighlight",t[t.overviewRulerBorder=80]="overviewRulerBorder",t[t.overviewRulerLanes=81]="overviewRulerLanes",t[t.padding=82]="padding",t[t.pasteAs=83]="pasteAs",t[t.parameterHints=84]="parameterHints",t[t.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",t[t.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",t[t.quickSuggestions=87]="quickSuggestions",t[t.quickSuggestionsDelay=88]="quickSuggestionsDelay",t[t.readOnly=89]="readOnly",t[t.readOnlyMessage=90]="readOnlyMessage",t[t.renameOnType=91]="renameOnType",t[t.renderControlCharacters=92]="renderControlCharacters",t[t.renderFinalNewline=93]="renderFinalNewline",t[t.renderLineHighlight=94]="renderLineHighlight",t[t.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",t[t.renderValidationDecorations=96]="renderValidationDecorations",t[t.renderWhitespace=97]="renderWhitespace",t[t.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",t[t.roundedSelection=99]="roundedSelection",t[t.rulers=100]="rulers",t[t.scrollbar=101]="scrollbar",t[t.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",t[t.scrollBeyondLastLine=103]="scrollBeyondLastLine",t[t.scrollPredominantAxis=104]="scrollPredominantAxis",t[t.selectionClipboard=105]="selectionClipboard",t[t.selectionHighlight=106]="selectionHighlight",t[t.selectOnLineNumbers=107]="selectOnLineNumbers",t[t.showFoldingControls=108]="showFoldingControls",t[t.showUnused=109]="showUnused",t[t.snippetSuggestions=110]="snippetSuggestions",t[t.smartSelect=111]="smartSelect",t[t.smoothScrolling=112]="smoothScrolling",t[t.stickyScroll=113]="stickyScroll",t[t.stickyTabStops=114]="stickyTabStops",t[t.stopRenderingLineAfter=115]="stopRenderingLineAfter",t[t.suggest=116]="suggest",t[t.suggestFontSize=117]="suggestFontSize",t[t.suggestLineHeight=118]="suggestLineHeight",t[t.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",t[t.suggestSelection=120]="suggestSelection",t[t.tabCompletion=121]="tabCompletion",t[t.tabIndex=122]="tabIndex",t[t.unicodeHighlighting=123]="unicodeHighlighting",t[t.unusualLineTerminators=124]="unusualLineTerminators",t[t.useShadowDOM=125]="useShadowDOM",t[t.useTabStops=126]="useTabStops",t[t.wordBreak=127]="wordBreak",t[t.wordSeparators=128]="wordSeparators",t[t.wordWrap=129]="wordWrap",t[t.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",t[t.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",t[t.wordWrapColumn=132]="wordWrapColumn",t[t.wordWrapOverride1=133]="wordWrapOverride1",t[t.wordWrapOverride2=134]="wordWrapOverride2",t[t.wrappingIndent=135]="wrappingIndent",t[t.wrappingStrategy=136]="wrappingStrategy",t[t.showDeprecated=137]="showDeprecated",t[t.inlayHints=138]="inlayHints",t[t.editorClassName=139]="editorClassName",t[t.pixelRatio=140]="pixelRatio",t[t.tabFocusMode=141]="tabFocusMode",t[t.layoutInfo=142]="layoutInfo",t[t.wrappingInfo=143]="wrappingInfo",t[t.defaultColorDecorators=144]="defaultColorDecorators",t[t.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn",t[t.inlineCompletionsAccessibilityVerbose=146]="inlineCompletionsAccessibilityVerbose"})(c||(n.EditorOption=c={}));var h;(function(t){t[t.TextDefined=0]="TextDefined",t[t.LF=1]="LF",t[t.CRLF=2]="CRLF"})(h||(n.EndOfLinePreference=h={}));var p;(function(t){t[t.LF=0]="LF",t[t.CRLF=1]="CRLF"})(p||(n.EndOfLineSequence=p={}));var f;(function(t){t[t.Left=1]="Left",t[t.Right=2]="Right"})(f||(n.GlyphMarginLane=f={}));var y;(function(t){t[t.None=0]="None",t[t.Indent=1]="Indent",t[t.IndentOutdent=2]="IndentOutdent",t[t.Outdent=3]="Outdent"})(y||(n.IndentAction=y={}));var w;(function(t){t[t.Both=0]="Both",t[t.Right=1]="Right",t[t.Left=2]="Left",t[t.None=3]="None"})(w||(n.InjectedTextCursorStops=w={}));var R;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(R||(n.InlayHintKind=R={}));var S;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(S||(n.InlineCompletionTriggerKind=S={}));var L;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.F20=78]="F20",t[t.F21=79]="F21",t[t.F22=80]="F22",t[t.F23=81]="F23",t[t.F24=82]="F24",t[t.NumLock=83]="NumLock",t[t.ScrollLock=84]="ScrollLock",t[t.Semicolon=85]="Semicolon",t[t.Equal=86]="Equal",t[t.Comma=87]="Comma",t[t.Minus=88]="Minus",t[t.Period=89]="Period",t[t.Slash=90]="Slash",t[t.Backquote=91]="Backquote",t[t.BracketLeft=92]="BracketLeft",t[t.Backslash=93]="Backslash",t[t.BracketRight=94]="BracketRight",t[t.Quote=95]="Quote",t[t.OEM_8=96]="OEM_8",t[t.IntlBackslash=97]="IntlBackslash",t[t.Numpad0=98]="Numpad0",t[t.Numpad1=99]="Numpad1",t[t.Numpad2=100]="Numpad2",t[t.Numpad3=101]="Numpad3",t[t.Numpad4=102]="Numpad4",t[t.Numpad5=103]="Numpad5",t[t.Numpad6=104]="Numpad6",t[t.Numpad7=105]="Numpad7",t[t.Numpad8=106]="Numpad8",t[t.Numpad9=107]="Numpad9",t[t.NumpadMultiply=108]="NumpadMultiply",t[t.NumpadAdd=109]="NumpadAdd",t[t.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=111]="NumpadSubtract",t[t.NumpadDecimal=112]="NumpadDecimal",t[t.NumpadDivide=113]="NumpadDivide",t[t.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",t[t.ABNT_C1=115]="ABNT_C1",t[t.ABNT_C2=116]="ABNT_C2",t[t.AudioVolumeMute=117]="AudioVolumeMute",t[t.AudioVolumeUp=118]="AudioVolumeUp",t[t.AudioVolumeDown=119]="AudioVolumeDown",t[t.BrowserSearch=120]="BrowserSearch",t[t.BrowserHome=121]="BrowserHome",t[t.BrowserBack=122]="BrowserBack",t[t.BrowserForward=123]="BrowserForward",t[t.MediaTrackNext=124]="MediaTrackNext",t[t.MediaTrackPrevious=125]="MediaTrackPrevious",t[t.MediaStop=126]="MediaStop",t[t.MediaPlayPause=127]="MediaPlayPause",t[t.LaunchMediaPlayer=128]="LaunchMediaPlayer",t[t.LaunchMail=129]="LaunchMail",t[t.LaunchApp2=130]="LaunchApp2",t[t.Clear=131]="Clear",t[t.MAX_VALUE=132]="MAX_VALUE"})(L||(n.KeyCode=L={}));var r;(function(t){t[t.Hint=1]="Hint",t[t.Info=2]="Info",t[t.Warning=4]="Warning",t[t.Error=8]="Error"})(r||(n.MarkerSeverity=r={}));var o;(function(t){t[t.Unnecessary=1]="Unnecessary",t[t.Deprecated=2]="Deprecated"})(o||(n.MarkerTag=o={}));var l;(function(t){t[t.Inline=1]="Inline",t[t.Gutter=2]="Gutter"})(l||(n.MinimapPosition=l={}));var _;(function(t){t[t.UNKNOWN=0]="UNKNOWN",t[t.TEXTAREA=1]="TEXTAREA",t[t.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",t[t.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",t[t.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",t[t.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",t[t.CONTENT_TEXT=6]="CONTENT_TEXT",t[t.CONTENT_EMPTY=7]="CONTENT_EMPTY",t[t.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",t[t.CONTENT_WIDGET=9]="CONTENT_WIDGET",t[t.OVERVIEW_RULER=10]="OVERVIEW_RULER",t[t.SCROLLBAR=11]="SCROLLBAR",t[t.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",t[t.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(_||(n.MouseTargetType=_={}));var b;(function(t){t[t.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",t[t.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",t[t.TOP_CENTER=2]="TOP_CENTER"})(b||(n.OverlayWidgetPositionPreference=b={}));var C;(function(t){t[t.Left=1]="Left",t[t.Center=2]="Center",t[t.Right=4]="Right",t[t.Full=7]="Full"})(C||(n.OverviewRulerLane=C={}));var A;(function(t){t[t.Left=0]="Left",t[t.Right=1]="Right",t[t.None=2]="None",t[t.LeftOfInjectedText=3]="LeftOfInjectedText",t[t.RightOfInjectedText=4]="RightOfInjectedText"})(A||(n.PositionAffinity=A={}));var N;(function(t){t[t.Off=0]="Off",t[t.On=1]="On",t[t.Relative=2]="Relative",t[t.Interval=3]="Interval",t[t.Custom=4]="Custom"})(N||(n.RenderLineNumbersType=N={}));var D;(function(t){t[t.None=0]="None",t[t.Text=1]="Text",t[t.Blocks=2]="Blocks"})(D||(n.RenderMinimap=D={}));var x;(function(t){t[t.Smooth=0]="Smooth",t[t.Immediate=1]="Immediate"})(x||(n.ScrollType=x={}));var W;(function(t){t[t.Auto=1]="Auto",t[t.Hidden=2]="Hidden",t[t.Visible=3]="Visible"})(W||(n.ScrollbarVisibility=W={}));var I;(function(t){t[t.LTR=0]="LTR",t[t.RTL=1]="RTL"})(I||(n.SelectionDirection=I={}));var k;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(k||(n.SignatureHelpTriggerKind=k={}));var P;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(P||(n.SymbolKind=P={}));var T;(function(t){t[t.Deprecated=1]="Deprecated"})(T||(n.SymbolTag=T={}));var z;(function(t){t[t.Hidden=0]="Hidden",t[t.Blink=1]="Blink",t[t.Smooth=2]="Smooth",t[t.Phase=3]="Phase",t[t.Expand=4]="Expand",t[t.Solid=5]="Solid"})(z||(n.TextEditorCursorBlinkingStyle=z={}));var U;(function(t){t[t.Line=1]="Line",t[t.Block=2]="Block",t[t.Underline=3]="Underline",t[t.LineThin=4]="LineThin",t[t.BlockOutline=5]="BlockOutline",t[t.UnderlineThin=6]="UnderlineThin"})(U||(n.TextEditorCursorStyle=U={}));var Z;(function(t){t[t.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",t[t.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",t[t.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",t[t.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(Z||(n.TrackedRangeStickiness=Z={}));var ee;(function(t){t[t.None=0]="None",t[t.Same=1]="Same",t[t.Indent=2]="Indent",t[t.DeepIndent=3]="DeepIndent"})(ee||(n.WrappingIndent=ee={}))}),ne(ie[54],re([0,1,7,10]),function(O,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=void 0;class i{constructor(){this._tokenizationSupports=new Map,this._factories=new Map,this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}handleChange(g){this._onDidChange.fire({changedLanguages:g,changedColorMap:!1})}register(g,a){return this._tokenizationSupports.set(g,a),this.handleChange([g]),(0,M.toDisposable)(()=>{this._tokenizationSupports.get(g)===a&&(this._tokenizationSupports.delete(g),this.handleChange([g]))})}get(g){return this._tokenizationSupports.get(g)||null}registerFactory(g,a){var s;(s=this._factories.get(g))===null||s===void 0||s.dispose();const v=new u(this,g,a);return this._factories.set(g,v),(0,M.toDisposable)(()=>{const e=this._factories.get(g);!e||e!==v||(this._factories.delete(g),e.dispose())})}getOrCreate(g){return pe(this,void 0,void 0,function*(){const a=this.get(g);if(a)return a;const s=this._factories.get(g);return!s||s.isResolved?null:(yield s.resolve(),this.get(g))})}isResolved(g){if(this.get(g))return!0;const s=this._factories.get(g);return!!(!s||s.isResolved)}setColorMap(g){this._colorMap=g,this._onDidChange.fire({changedLanguages:Array.from(this._tokenizationSupports.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}n.TokenizationRegistry=i;class u extends M.Disposable{get isResolved(){return this._isResolved}constructor(g,a,s){super(),this._registry=g,this._languageId=a,this._factory=s,this._isDisposed=!1,this._resolvePromise=null,this._isResolved=!1}dispose(){this._isDisposed=!0,super.dispose()}resolve(){return pe(this,void 0,void 0,function*(){return this._resolvePromise||(this._resolvePromise=this._create()),this._resolvePromise})}_create(){return pe(this,void 0,void 0,function*(){const g=yield this._factory.tokenizationSupport;this._isResolved=!0,g&&!this._isDisposed&&this._register(this._registry.register(this._languageId,g))})}}}),ne(ie[55],re([15,56]),function(O,n){return O.create("vs/base/common/platform",n)}),ne(ie[13],re([0,1,55]),function(O,n,E){"use strict";var M;Object.defineProperty(n,"__esModule",{value:!0}),n.isAndroid=n.isEdge=n.isSafari=n.isFirefox=n.isChrome=n.isLittleEndian=n.OS=n.setTimeout0=n.setTimeout0IsFaster=n.language=n.userAgent=n.isMobile=n.isIOS=n.isWebWorker=n.isWeb=n.isNative=n.isLinux=n.isMacintosh=n.isWindows=n.globals=n.LANGUAGE_DEFAULT=void 0,n.LANGUAGE_DEFAULT="en";let i=!1,u=!1,d=!1,g=!1,a=!1,s=!1,v=!1,e=!1,m=!1,c=!1,h,p=n.LANGUAGE_DEFAULT,f=n.LANGUAGE_DEFAULT,y,w;n.globals=typeof self=="object"?self:typeof global=="object"?global:{};let R;typeof n.globals.vscode<"u"&&typeof n.globals.vscode.process<"u"?R=n.globals.vscode.process:typeof process<"u"&&(R=process);const S=typeof((M=R?.versions)===null||M===void 0?void 0:M.electron)=="string",L=S&&R?.type==="renderer";if(typeof navigator=="object"&&!L)w=navigator.userAgent,i=w.indexOf("Windows")>=0,u=w.indexOf("Macintosh")>=0,e=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,d=w.indexOf("Linux")>=0,c=w?.indexOf("Mobi")>=0,s=!0,h=E.getConfiguredDefaultLocale(E.localize(0,null))||n.LANGUAGE_DEFAULT,p=h,f=navigator.language;else if(typeof R=="object"){i=R.platform==="win32",u=R.platform==="darwin",d=R.platform==="linux",g=d&&!!R.env.SNAP&&!!R.env.SNAP_REVISION,v=S,m=!!R.env.CI||!!R.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=n.LANGUAGE_DEFAULT,p=n.LANGUAGE_DEFAULT;const b=R.env.VSCODE_NLS_CONFIG;if(b)try{const C=JSON.parse(b),A=C.availableLanguages["*"];h=C.locale,f=C.osLocale,p=A||n.LANGUAGE_DEFAULT,y=C._translationsConfigFile}catch{}a=!0}else console.error("Unable to resolve platform.");let r=0;u?r=1:i?r=3:d&&(r=2),n.isWindows=i,n.isMacintosh=u,n.isLinux=d,n.isNative=a,n.isWeb=s,n.isWebWorker=s&&typeof n.globals.importScripts=="function",n.isIOS=e,n.isMobile=c,n.userAgent=w,n.language=p,n.setTimeout0IsFaster=typeof n.globals.postMessage=="function"&&!n.globals.importScripts,n.setTimeout0=(()=>{if(n.setTimeout0IsFaster){const b=[];n.globals.addEventListener("message",A=>{if(A.data&&A.data.vscodeScheduleAsyncWork)for(let N=0,D=b.length;N<D;N++){const x=b[N];if(x.id===A.data.vscodeScheduleAsyncWork){b.splice(N,1),x.callback();return}}});let C=0;return A=>{const N=++C;b.push({id:N,callback:A}),n.globals.postMessage({vscodeScheduleAsyncWork:N},"*")}}return b=>setTimeout(b)})(),n.OS=u||e?2:i?1:3;let o=!0,l=!1;function _(){if(!l){l=!0;const b=new Uint8Array(2);b[0]=1,b[1]=2,o=new Uint16Array(b.buffer)[0]===(2<<8)+1}return o}n.isLittleEndian=_,n.isChrome=!!(n.userAgent&&n.userAgent.indexOf("Chrome")>=0),n.isFirefox=!!(n.userAgent&&n.userAgent.indexOf("Firefox")>=0),n.isSafari=!!(!n.isChrome&&n.userAgent&&n.userAgent.indexOf("Safari")>=0),n.isEdge=!!(n.userAgent&&n.userAgent.indexOf("Edg/")>=0),n.isAndroid=!!(n.userAgent&&n.userAgent.indexOf("Android")>=0)}),ne(ie[57],re([0,1,13]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.platform=n.env=n.cwd=void 0;let M;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const i=E.globals.vscode.process;M={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};n.cwd=M.cwd,n.env=M.env,n.platform=M.platform}),ne(ie[58],re([0,1,57]),function(O,n,E){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.sep=n.extname=n.basename=n.dirname=n.relative=n.resolve=n.normalize=n.posix=n.win32=void 0;const M=65,i=97,u=90,d=122,g=46,a=47,s=92,v=58,e=63;class m extends Error{constructor(o,l,_){let b;typeof l=="string"&&l.indexOf("not ")===0?(b="must not be",l=l.replace(/^not /,"")):b="must be";const C=o.indexOf(".")!==-1?"property":"argument";let A=`The "${o}" ${C} ${b} of type ${l}`;A+=`. Received type ${typeof _}`,super(A),this.code="ERR_INVALID_ARG_TYPE"}}function c(r,o){if(r===null||typeof r!="object")throw new m(o,"Object",r)}function h(r,o){if(typeof r!="string")throw new m(o,"string",r)}const p=E.platform==="win32";function f(r){return r===a||r===s}function y(r){return r===a}function w(r){return r>=M&&r<=u||r>=i&&r<=d}function R(r,o,l,_){let b="",C=0,A=-1,N=0,D=0;for(let x=0;x<=r.length;++x){if(x<r.length)D=r.charCodeAt(x);else{if(_(D))break;D=a}if(_(D)){if(!(A===x-1||N===1))if(N===2){if(b.length<2||C!==2||b.charCodeAt(b.length-1)!==g||b.charCodeAt(b.length-2)!==g){if(b.length>2){const W=b.lastIndexOf(l);W===-1?(b="",C=0):(b=b.slice(0,W),C=b.length-1-b.lastIndexOf(l)),A=x,N=0;continue}else if(b.length!==0){b="",C=0,A=x,N=0;continue}}o&&(b+=b.length>0?`${l}..`:"..",C=2)}else b.length>0?b+=`${l}${r.slice(A+1,x)}`:b=r.slice(A+1,x),C=x-A-1;A=x,N=0}else D===g&&N!==-1?++N:N=-1}return b}function S(r,o){c(o,"pathObject");const l=o.dir||o.root,_=o.base||`${o.name||""}${o.ext||""}`;return l?l===o.root?`${l}${_}`:`${l}${r}${_}`:_}n.win32={resolve(...r){let o="",l="",_=!1;for(let b=r.length-1;b>=-1;b--){let C;if(b>=0){if(C=r[b],h(C,"path"),C.length===0)continue}else o.length===0?C=E.cwd():(C=E.env[`=${o}`]||E.cwd(),(C===void 0||C.slice(0,2).toLowerCase()!==o.toLowerCase()&&C.charCodeAt(2)===s)&&(C=`${o}\\`));const A=C.length;let N=0,D="",x=!1;const W=C.charCodeAt(0);if(A===1)f(W)&&(N=1,x=!0);else if(f(W))if(x=!0,f(C.charCodeAt(1))){let I=2,k=I;for(;I<A&&!f(C.charCodeAt(I));)I++;if(I<A&&I!==k){const P=C.slice(k,I);for(k=I;I<A&&f(C.charCodeAt(I));)I++;if(I<A&&I!==k){for(k=I;I<A&&!f(C.charCodeAt(I));)I++;(I===A||I!==k)&&(D=`\\\\${P}\\${C.slice(k,I)}`,N=I)}}}else N=1;else w(W)&&C.charCodeAt(1)===v&&(D=C.slice(0,2),N=2,A>2&&f(C.charCodeAt(2))&&(x=!0,N=3));if(D.length>0)if(o.length>0){if(D.toLowerCase()!==o.toLowerCase())continue}else o=D;if(_){if(o.length>0)break}else if(l=`${C.slice(N)}\\${l}`,_=x,x&&o.length>0)break}return l=R(l,!_,"\\",f),_?`${o}\\${l}`:`${o}${l}`||"."},normalize(r){h(r,"path");const o=r.length;if(o===0)return".";let l=0,_,b=!1;const C=r.charCodeAt(0);if(o===1)return y(C)?"\\":r;if(f(C))if(b=!0,f(r.charCodeAt(1))){let N=2,D=N;for(;N<o&&!f(r.charCodeAt(N));)N++;if(N<o&&N!==D){const x=r.slice(D,N);for(D=N;N<o&&f(r.charCodeAt(N));)N++;if(N<o&&N!==D){for(D=N;N<o&&!f(r.charCodeAt(N));)N++;if(N===o)return`\\\\${x}\\${r.slice(D)}\\`;N!==D&&(_=`\\\\${x}\\${r.slice(D,N)}`,l=N)}}}else l=1;else w(C)&&r.charCodeAt(1)===v&&(_=r.slice(0,2),l=2,o>2&&f(r.charCodeAt(2))&&(b=!0,l=3));let A=l<o?R(r.slice(l),!b,"\\",f):"";return A.length===0&&!b&&(A="."),A.length>0&&f(r.charCodeAt(o-1))&&(A+="\\"),_===void 0?b?`\\${A}`:A:b?`${_}\\${A}`:`${_}${A}`},isAbsolute(r){h(r,"path");const o=r.length;if(o===0)return!1;const l=r.charCodeAt(0);return f(l)||o>2&&w(l)&&r.charCodeAt(1)===v&&f(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let o,l;for(let C=0;C<r.length;++C){const A=r[C];h(A,"path"),A.length>0&&(o===void 0?o=l=A:o+=`\\${A}`)}if(o===void 0)return".";let _=!0,b=0;if(typeof l=="string"&&f(l.charCodeAt(0))){++b;const C=l.length;C>1&&f(l.charCodeAt(1))&&(++b,C>2&&(f(l.charCodeAt(2))?++b:_=!1))}if(_){for(;b<o.length&&f(o.charCodeAt(b));)b++;b>=2&&(o=`\\${o.slice(b)}`)}return n.win32.normalize(o)},relative(r,o){if(h(r,"from"),h(o,"to"),r===o)return"";const l=n.win32.resolve(r),_=n.win32.resolve(o);if(l===_||(r=l.toLowerCase(),o=_.toLowerCase(),r===o))return"";let b=0;for(;b<r.length&&r.charCodeAt(b)===s;)b++;let C=r.length;for(;C-1>b&&r.charCodeAt(C-1)===s;)C--;const A=C-b;let N=0;for(;N<o.length&&o.charCodeAt(N)===s;)N++;let D=o.length;for(;D-1>N&&o.charCodeAt(D-1)===s;)D--;const x=D-N,W=A<x?A:x;let I=-1,k=0;for(;k<W;k++){const T=r.charCodeAt(b+k);if(T!==o.charCodeAt(N+k))break;T===s&&(I=k)}if(k!==W){if(I===-1)return _}else{if(x>W){if(o.charCodeAt(N+k)===s)return _.slice(N+k+1);if(k===2)return _.slice(N+k)}A>W&&(r.charCodeAt(b+k)===s?I=k:k===2&&(I=3)),I===-1&&(I=0)}let P="";for(k=b+I+1;k<=C;++k)(k===C||r.charCodeAt(k)===s)&&(P+=P.length===0?"..":"\\..");return N+=I,P.length>0?`${P}${_.slice(N,D)}`:(_.charCodeAt(N)===s&&++N,_.slice(N,D))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const o=n.win32.resolve(r);if(o.length<=2)return r;if(o.charCodeAt(0)===s){if(o.charCodeAt(1)===s){const l=o.charCodeAt(2);if(l!==e&&l!==g)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(w(o.charCodeAt(0))&&o.charCodeAt(1)===v&&o.charCodeAt(2)===s)return`\\\\?\\${o}`;return r},dirname(r){h(r,"path");const o=r.length;if(o===0)return".";let l=-1,_=0;const b=r.charCodeAt(0);if(o===1)return f(b)?r:".";if(f(b)){if(l=_=1,f(r.charCodeAt(1))){let N=2,D=N;for(;N<o&&!f(r.charCodeAt(N));)N++;if(N<o&&N!==D){for(D=N;N<o&&f(r.charCodeAt(N));)N++;if(N<o&&N!==D){for(D=N;N<o&&!f(r.charCodeAt(N));)N++;if(N===o)return r;N!==D&&(l=_=N+1)}}}}else w(b)&&r.charCodeAt(1)===v&&(l=o>2&&f(r.charCodeAt(2))?3:2,_=l);let C=-1,A=!0;for(let N=o-1;N>=_;--N)if(f(r.charCodeAt(N))){if(!A){C=N;break}}else A=!1;if(C===-1){if(l===-1)return".";C=l}return r.slice(0,C)},basename(r,o){o!==void 0&&h(o,"ext"),h(r,"path");let l=0,_=-1,b=!0,C;if(r.length>=2&&w(r.charCodeAt(0))&&r.charCodeAt(1)===v&&(l=2),o!==void 0&&o.length>0&&o.length<=r.length){if(o===r)return"";let A=o.length-1,N=-1;for(C=r.length-1;C>=l;--C){const D=r.charCodeAt(C);if(f(D)){if(!b){l=C+1;break}}else N===-1&&(b=!1,N=C+1),A>=0&&(D===o.charCodeAt(A)?--A===-1&&(_=C):(A=-1,_=N))}return l===_?_=N:_===-1&&(_=r.length),r.slice(l,_)}for(C=r.length-1;C>=l;--C)if(f(r.charCodeAt(C))){if(!b){l=C+1;break}}else _===-1&&(b=!1,_=C+1);return _===-1?"":r.slice(l,_)},extname(r){h(r,"path");let o=0,l=-1,_=0,b=-1,C=!0,A=0;r.length>=2&&r.charCodeAt(1)===v&&w(r.charCodeAt(0))&&(o=_=2);for(let N=r.length-1;N>=o;--N){const D=r.charCodeAt(N);if(f(D)){if(!C){_=N+1;break}continue}b===-1&&(C=!1,b=N+1),D===g?l===-1?l=N:A!==1&&(A=1):l!==-1&&(A=-1)}return l===-1||b===-1||A===0||A===1&&l===b-1&&l===_+1?"":r.slice(l,b)},format:S.bind(null,"\\"),parse(r){h(r,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return o;const l=r.length;let _=0,b=r.charCodeAt(0);if(l===1)return f(b)?(o.root=o.dir=r,o):(o.base=o.name=r,o);if(f(b)){if(_=1,f(r.charCodeAt(1))){let I=2,k=I;for(;I<l&&!f(r.charCodeAt(I));)I++;if(I<l&&I!==k){for(k=I;I<l&&f(r.charCodeAt(I));)I++;if(I<l&&I!==k){for(k=I;I<l&&!f(r.charCodeAt(I));)I++;I===l?_=I:I!==k&&(_=I+1)}}}}else if(w(b)&&r.charCodeAt(1)===v){if(l<=2)return o.root=o.dir=r,o;if(_=2,f(r.charCodeAt(2))){if(l===3)return o.root=o.dir=r,o;_=3}}_>0&&(o.root=r.slice(0,_));let C=-1,A=_,N=-1,D=!0,x=r.length-1,W=0;for(;x>=_;--x){if(b=r.charCodeAt(x),f(b)){if(!D){A=x+1;break}continue}N===-1&&(D=!1,N=x+1),b===g?C===-1?C=x:W!==1&&(W=1):C!==-1&&(W=-1)}return N!==-1&&(C===-1||W===0||W===1&&C===N-1&&C===A+1?o.base=o.name=r.slice(A,N):(o.name=r.slice(A,C),o.base=r.slice(A,N),o.ext=r.slice(C,N))),A>0&&A!==_?o.dir=r.slice(0,A-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const L=(()=>{if(p){const r=/\\/g;return()=>{const o=E.cwd().replace(r,"/");return o.slice(o.indexOf("/"))}}return()=>E.cwd()})();n.posix={resolve(...r){let o="",l=!1;for(let _=r.length-1;_>=-1&&!l;_--){const b=_>=0?r[_]:L();h(b,"path"),b.length!==0&&(o=`${b}/${o}`,l=b.charCodeAt(0)===a)}return o=R(o,!l,"/",y),l?`/${o}`:o.length>0?o:"."},normalize(r){if(h(r,"path"),r.length===0)return".";const o=r.charCodeAt(0)===a,l=r.charCodeAt(r.length-1)===a;return r=R(r,!o,"/",y),r.length===0?o?"/":l?"./":".":(l&&(r+="/"),o?`/${r}`:r)},isAbsolute(r){return h(r,"path"),r.length>0&&r.charCodeAt(0)===a},join(...r){if(r.length===0)return".";let o;for(let l=0;l<r.length;++l){const _=r[l];h(_,"path"),_.length>0&&(o===void 0?o=_:o+=`/${_}`)}return o===void 0?".":n.posix.normalize(o)},relative(r,o){if(h(r,"from"),h(o,"to"),r===o||(r=n.posix.resolve(r),o=n.posix.resolve(o),r===o))return"";const l=1,_=r.length,b=_-l,C=1,A=o.length-C,N=b<A?b:A;let D=-1,x=0;for(;x<N;x++){const I=r.charCodeAt(l+x);if(I!==o.charCodeAt(C+x))break;I===a&&(D=x)}if(x===N)if(A>N){if(o.charCodeAt(C+x)===a)return o.slice(C+x+1);if(x===0)return o.slice(C+x)}else b>N&&(r.charCodeAt(l+x)===a?D=x:x===0&&(D=0));let W="";for(x=l+D+1;x<=_;++x)(x===_||r.charCodeAt(x)===a)&&(W+=W.length===0?"..":"/..");return`${W}${o.slice(C+D)}`},toNamespacedPath(r){return r},dirname(r){if(h(r,"path"),r.length===0)return".";const o=r.charCodeAt(0)===a;let l=-1,_=!0;for(let b=r.length-1;b>=1;--b)if(r.charCodeAt(b)===a){if(!_){l=b;break}}else _=!1;return l===-1?o?"/":".":o&&l===1?"//":r.slice(0,l)},basename(r,o){o!==void 0&&h(o,"ext"),h(r,"path");let l=0,_=-1,b=!0,C;if(o!==void 0&&o.length>0&&o.length<=r.length){if(o===r)return"";let A=o.length-1,N=-1;for(C=r.length-1;C>=0;--C){const D=r.charCodeAt(C);if(D===a){if(!b){l=C+1;break}}else N===-1&&(b=!1,N=C+1),A>=0&&(D===o.charCodeAt(A)?--A===-1&&(_=C):(A=-1,_=N))}return l===_?_=N:_===-1&&(_=r.length),r.slice(l,_)}for(C=r.length-1;C>=0;--C)if(r.charCodeAt(C)===a){if(!b){l=C+1;break}}else _===-1&&(b=!1,_=C+1);return _===-1?"":r.slice(l,_)},extname(r){h(r,"path");let o=-1,l=0,_=-1,b=!0,C=0;for(let A=r.length-1;A>=0;--A){const N=r.charCodeAt(A);if(N===a){if(!b){l=A+1;break}continue}_===-1&&(b=!1,_=A+1),N===g?o===-1?o=A:C!==1&&(C=1):o!==-1&&(C=-1)}return o===-1||_===-1||C===0||C===1&&o===_-1&&o===l+1?"":r.slice(o,_)},format:S.bind(null,"/"),parse(r){h(r,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return o;const l=r.charCodeAt(0)===a;let _;l?(o.root="/",_=1):_=0;let b=-1,C=0,A=-1,N=!0,D=r.length-1,x=0;for(;D>=_;--D){const W=r.charCodeAt(D);if(W===a){if(!N){C=D+1;break}continue}A===-1&&(N=!1,A=D+1),W===g?b===-1?b=D:x!==1&&(x=1):b!==-1&&(x=-1)}if(A!==-1){const W=C===0&&l?1:C;b===-1||x===0||x===1&&b===A-1&&b===C+1?o.base=o.name=r.slice(W,A):(o.name=r.slice(W,b),o.base=r.slice(W,A),o.ext=r.slice(b,A))}return C>0?o.dir=r.slice(0,C-1):l&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},n.posix.win32=n.win32.win32=n.win32,n.posix.posix=n.win32.posix=n.posix,n.normalize=p?n.win32.normalize:n.posix.normalize,n.resolve=p?n.win32.resolve:n.posix.resolve,n.relative=p?n.win32.relative:n.posix.relative,n.dirname=p?n.win32.dirname:n.posix.dirname,n.basename=p?n.win32.basename:n.posix.basename,n.extname=p?n.win32.extname:n.posix.extname,n.sep=p?n.win32.sep:n.posix.sep}),ne(ie[14],re([0,1,58,13]),function(O,n,E,M){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.uriToFsPath=n.URI=void 0;const i=/^\w[\w\d+.-]*$/,u=/^\//,d=/^\/\//;function g(l,_){if(!l.scheme&&_)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!i.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!u.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(d.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function a(l,_){return!l&&!_?"file":l}function s(l,_){switch(l){case"https":case"http":case"file":_?_[0]!==e&&(_=e+_):_=e;break}return _}const v="",e="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(_){return _ instanceof c?!0:_?typeof _.authority=="string"&&typeof _.fragment=="string"&&typeof _.path=="string"&&typeof _.query=="string"&&typeof _.scheme=="string"&&typeof _.fsPath=="string"&&typeof _.with=="function"&&typeof _.toString=="function":!1}constructor(_,b,C,A,N,D=!1){typeof _=="object"?(this.scheme=_.scheme||v,this.authority=_.authority||v,this.path=_.path||v,this.query=_.query||v,this.fragment=_.fragment||v):(this.scheme=a(_,D),this.authority=b||v,this.path=s(this.scheme,C||v),this.query=A||v,this.fragment=N||v,g(this,D))}get fsPath(){return R(this,!1)}with(_){if(!_)return this;let{scheme:b,authority:C,path:A,query:N,fragment:D}=_;return b===void 0?b=this.scheme:b===null&&(b=v),C===void 0?C=this.authority:C===null&&(C=v),A===void 0?A=this.path:A===null&&(A=v),N===void 0?N=this.query:N===null&&(N=v),D===void 0?D=this.fragment:D===null&&(D=v),b===this.scheme&&C===this.authority&&A===this.path&&N===this.query&&D===this.fragment?this:new p(b,C,A,N,D)}static parse(_,b=!1){const C=m.exec(_);return C?new p(C[2]||v,o(C[4]||v),o(C[5]||v),o(C[7]||v),o(C[9]||v),b):new p(v,v,v,v,v)}static file(_){let b=v;if(M.isWindows&&(_=_.replace(/\\/g,e)),_[0]===e&&_[1]===e){const C=_.indexOf(e,2);C===-1?(b=_.substring(2),_=e):(b=_.substring(2,C),_=_.substring(C)||e)}return new p("file",b,_,v,v)}static from(_,b){return new p(_.scheme,_.authority,_.path,_.query,_.fragment,b)}static joinPath(_,...b){if(!_.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let C;return M.isWindows&&_.scheme==="file"?C=c.file(E.win32.join(R(_,!0),...b)).path:C=E.posix.join(_.path,...b),_.with({path:C})}toString(_=!1){return S(this,_)}toJSON(){return this}static revive(_){var b,C;if(_){if(_ instanceof c)return _;{const A=new p(_);return A._formatted=(b=_.external)!==null&&b!==void 0?b:null,A._fsPath=_._sep===h&&(C=_.fsPath)!==null&&C!==void 0?C:null,A}}else return _}}n.URI=c;const h=M.isWindows?1:void 0;class p extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=R(this,!1)),this._fsPath}toString(_=!1){return _?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const _={$mid:1};return this._fsPath&&(_.fsPath=this._fsPath,_._sep=h),this._formatted&&(_.external=this._formatted),this.path&&(_.path=this.path),this.scheme&&(_.scheme=this.scheme),this.authority&&(_.authority=this.authority),this.query&&(_.query=this.query),this.fragment&&(_.fragment=this.fragment),_}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function y(l,_,b){let C,A=-1;for(let N=0;N<l.length;N++){const D=l.charCodeAt(N);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||_&&D===47||b&&D===91||b&&D===93||b&&D===58)A!==-1&&(C+=encodeURIComponent(l.substring(A,N)),A=-1),C!==void 0&&(C+=l.charAt(N));else{C===void 0&&(C=l.substr(0,N));const x=f[D];x!==void 0?(A!==-1&&(C+=encodeURIComponent(l.substring(A,N)),A=-1),C+=x):A===-1&&(A=N)}}return A!==-1&&(C+=encodeURIComponent(l.substring(A))),C!==void 0?C:l}function w(l){let _;for(let b=0;b<l.length;b++){const C=l.charCodeAt(b);C===35||C===63?(_===void 0&&(_=l.substr(0,b)),_+=f[C]):_!==void 0&&(_+=l[b])}return _!==void 0?_:l}function R(l,_){let b;return l.authority&&l.path.length>1&&l.scheme==="file"?b=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?_?b=l.path.substr(1):b=l.path[1].toLowerCase()+l.path.substr(2):b=l.path,M.isWindows&&(b=b.replace(/\//g,"\\")),b}n.uriToFsPath=R;function S(l,_){const b=_?w:y;let C="",{scheme:A,authority:N,path:D,query:x,fragment:W}=l;if(A&&(C+=A,C+=":"),(N||A==="file")&&(C+=e,C+=e),N){let I=N.indexOf("@");if(I!==-1){const k=N.substr(0,I);N=N.substr(I+1),I=k.lastIndexOf(":"),I===-1?C+=b(k,!1,!1):(C+=b(k.substr(0,I),!1,!1),C+=":",C+=b(k.substr(I+1),!1,!0)),C+="@"}N=N.toLowerCase(),I=N.lastIndexOf(":"),I===-1?C+=b(N,!1,!0):(C+=b(N.substr(0,I),!1,!0),C+=N.substr(I))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const I=D.charCodeAt(1);I>=65&&I<=90&&(D=`/${String.fromCharCode(I+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const I=D.charCodeAt(0);I>=65&&I<=90&&(D=`${String.fromCharCode(I+32)}:${D.substr(2)}`)}C+=b(D,!0,!1)}return x&&(C+="?",C+=b(x,!1,!1)),W&&(C+="#",C+=_?W:y(W,!1,!1)),C}function L(l){try{return decodeURIComponent(l)}catch{return l.length>3?l.substr(0,3)+L(l.substr(3)):l}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(l){return l.match(r)?l.replace(r,_=>L(_)):l}}),ne(ie[62],re([0,1,4,7,10,11,13,5]),function(O,n,E,M,i,u,d,g){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.SimpleWorkerServer=n.SimpleWorkerClient=n.logOnceWebWorkerWarning=void 0;const a="$initialize";let s=!1;function v(o){d.isWeb&&(s||(s=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(o.message))}n.logOnceWebWorkerWarning=v;class e{constructor(l,_,b,C){this.vsWorker=l,this.req=_,this.method=b,this.args=C,this.type=0}}class m{constructor(l,_,b,C){this.vsWorker=l,this.seq=_,this.res=b,this.err=C,this.type=1}}class c{constructor(l,_,b,C){this.vsWorker=l,this.req=_,this.eventName=b,this.arg=C,this.type=2}}class h{constructor(l,_,b){this.vsWorker=l,this.req=_,this.event=b,this.type=3}}class p{constructor(l,_){this.vsWorker=l,this.req=_,this.type=4}}class f{constructor(l){this._workerId=-1,this._handler=l,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(l){this._workerId=l}sendMessage(l,_){const b=String(++this._lastSentReq);return new Promise((C,A)=>{this._pendingReplies[b]={resolve:C,reject:A},this._send(new e(this._workerId,b,l,_))})}listen(l,_){let b=null;const C=new M.Emitter({onWillAddFirstListener:()=>{b=String(++this._lastSentReq),this._pendingEmitters.set(b,C),this._send(new c(this._workerId,b,l,_))},onDidRemoveLastListener:()=>{this._pendingEmitters.delete(b),this._send(new p(this._workerId,b)),b=null}});return C.event}handleMessage(l){!l||!l.vsWorker||this._workerId!==-1&&l.vsWorker!==this._workerId||this._handleMessage(l)}_handleMessage(l){switch(l.type){case 1:return this._handleReplyMessage(l);case 0:return this._handleRequestMessage(l);case 2:return this._handleSubscribeEventMessage(l);case 3:return this._handleEventMessage(l);case 4:return this._handleUnsubscribeEventMessage(l)}}_handleReplyMessage(l){if(!this._pendingReplies[l.seq]){console.warn("Got reply to unknown seq");return}const _=this._pendingReplies[l.seq];if(delete this._pendingReplies[l.seq],l.err){let b=l.err;l.err.$isError&&(b=new Error,b.name=l.err.name,b.message=l.err.message,b.stack=l.err.stack),_.reject(b);return}_.resolve(l.res)}_handleRequestMessage(l){const _=l.req;this._handler.handleMessage(l.method,l.args).then(C=>{this._send(new m(this._workerId,_,C,void 0))},C=>{C.detail instanceof Error&&(C.detail=(0,E.transformErrorForSerialization)(C.detail)),this._send(new m(this._workerId,_,void 0,(0,E.transformErrorForSerialization)(C)))})}_handleSubscribeEventMessage(l){const _=l.req,b=this._handler.handleEvent(l.eventName,l.arg)(C=>{this._send(new h(this._workerId,_,C))});this._pendingEvents.set(_,b)}_handleEventMessage(l){if(!this._pendingEmitters.has(l.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(l.req).fire(l.event)}_handleUnsubscribeEventMessage(l){if(!this._pendingEvents.has(l.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(l.req).dispose(),this._pendingEvents.delete(l.req)}_send(l){const _=[];if(l.type===0)for(let b=0;b<l.args.length;b++)l.args[b]instanceof ArrayBuffer&&_.push(l.args[b]);else l.type===1&&l.res instanceof ArrayBuffer&&_.push(l.res);this._handler.sendMessage(l,_)}}class y extends i.Disposable{constructor(l,_,b){super();let C=null;this._worker=this._register(l.create("vs/base/common/worker/simpleWorker",I=>{this._protocol.handleMessage(I)},I=>{C?.(I)})),this._protocol=new f({sendMessage:(I,k)=>{this._worker.postMessage(I,k)},handleMessage:(I,k)=>{if(typeof b[I]!="function")return Promise.reject(new Error("Missing method "+I+" on main thread host."));try{return Promise.resolve(b[I].apply(b,k))}catch(P){return Promise.reject(P)}},handleEvent:(I,k)=>{if(R(I)){const P=b[I].call(b,k);if(typeof P!="function")throw new Error(`Missing dynamic event ${I} on main thread host.`);return P}if(w(I)){const P=b[I];if(typeof P!="function")throw new Error(`Missing event ${I} on main thread host.`);return P}throw new Error(`Malformed event name ${I}`)}}),this._protocol.setWorkerId(this._worker.getId());let A=null;const N=globalThis.require;typeof N<"u"&&typeof N.getConfig=="function"?A=N.getConfig():typeof globalThis.requirejs<"u"&&(A=globalThis.requirejs.s.contexts._.config);const D=(0,u.getAllMethodNames)(b);this._onModuleLoaded=this._protocol.sendMessage(a,[this._worker.getId(),JSON.parse(JSON.stringify(A)),_,D]);const x=(I,k)=>this._request(I,k),W=(I,k)=>this._protocol.listen(I,k);this._lazyProxy=new Promise((I,k)=>{C=k,this._onModuleLoaded.then(P=>{I(S(P,x,W))},P=>{k(P),this._onError("Worker failed to load "+_,P)})})}getProxyObject(){return this._lazyProxy}_request(l,_){return new Promise((b,C)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(l,_).then(b,C)},C)})}_onError(l,_){console.error(l),console.info(_)}}n.SimpleWorkerClient=y;function w(o){return o[0]==="o"&&o[1]==="n"&&g.isUpperAsciiLetter(o.charCodeAt(2))}function R(o){return/^onDynamic/.test(o)&&g.isUpperAsciiLetter(o.charCodeAt(9))}function S(o,l,_){const b=N=>function(){const D=Array.prototype.slice.call(arguments,0);return l(N,D)},C=N=>function(D){return _(N,D)},A={};for(const N of o){if(R(N)){A[N]=C(N);continue}if(w(N)){A[N]=_(N,void 0);continue}A[N]=b(N)}return A}class L{constructor(l,_){this._requestHandlerFactory=_,this._requestHandler=null,this._protocol=new f({sendMessage:(b,C)=>{l(b,C)},handleMessage:(b,C)=>this._handleMessage(b,C),handleEvent:(b,C)=>this._handleEvent(b,C)})}onmessage(l){this._protocol.handleMessage(l)}_handleMessage(l,_){if(l===a)return this.initialize(_[0],_[1],_[2],_[3]);if(!this._requestHandler||typeof this._requestHandler[l]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+l));try{return Promise.resolve(this._requestHandler[l].apply(this._requestHandler,_))}catch(b){return Promise.reject(b)}}_handleEvent(l,_){if(!this._requestHandler)throw new Error("Missing requestHandler");if(R(l)){const b=this._requestHandler[l].call(this._requestHandler,_);if(typeof b!="function")throw new Error(`Missing dynamic event ${l} on request handler.`);return b}if(w(l)){const b=this._requestHandler[l];if(typeof b!="function")throw new Error(`Missing event ${l} on request handler.`);return b}throw new Error(`Malformed event name ${l}`)}initialize(l,_,b,C){this._protocol.setWorkerId(l);const D=S(C,(x,W)=>this._protocol.sendMessage(x,W),(x,W)=>this._protocol.listen(x,W));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(D),Promise.resolve((0,u.getAllMethodNames)(this._requestHandler))):(_&&(typeof _.baseUrl<"u"&&delete _.baseUrl,typeof _.paths<"u"&&typeof _.paths.vs<"u"&&delete _.paths.vs,typeof _.trustedTypesPolicy!==void 0&&delete _.trustedTypesPolicy,_.catchError=!0,globalThis.require.config(_)),new Promise((x,W)=>{(globalThis.require||O)([b],k=>{if(this._requestHandler=k.create(D),!this._requestHandler){W(new Error("No RequestHandler!"));return}x((0,u.getAllMethodNames)(this._requestHandler))},W)}))}}n.SimpleWorkerServer=L;function r(o){return new L(o,null)}n.create=r}),ne(ie[59],re([15,56]),function(O,n){return O.create("vs/editor/common/languages",n)}),ne(ie[60],re([0,1,35,14,2,54,59]),function(O,n,E,M,i,u,d){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.TokenizationRegistry=n.LazyTokenizationSupport=n.InlayHintKind=n.Command=n.FoldingRangeKind=n.TextEdit=n.SymbolKinds=n.getAriaLabelForSymbol=n.symbolKindNames=n.isLocationLink=n.DocumentHighlightKind=n.SignatureHelpTriggerKind=n.SelectedSuggestionInfo=n.InlineCompletionTriggerKind=n.CompletionItemKinds=n.EncodedTokenizationResult=n.TokenizationResult=n.Token=void 0;class g{constructor(l,_,b){this.offset=l,this.type=_,this.language=b,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}n.Token=g;class a{constructor(l,_){this.tokens=l,this.endState=_,this._tokenizationResultBrand=void 0}}n.TokenizationResult=a;class s{constructor(l,_){this.tokens=l,this.endState=_,this._encodedTokenizationResultBrand=void 0}}n.EncodedTokenizationResult=s;var v;(function(o){const l=new Map;l.set(0,E.Codicon.symbolMethod),l.set(1,E.Codicon.symbolFunction),l.set(2,E.Codicon.symbolConstructor),l.set(3,E.Codicon.symbolField),l.set(4,E.Codicon.symbolVariable),l.set(5,E.Codicon.symbolClass),l.set(6,E.Codicon.symbolStruct),l.set(7,E.Codicon.symbolInterface),l.set(8,E.Codicon.symbolModule),l.set(9,E.Codicon.symbolProperty),l.set(10,E.Codicon.symbolEvent),l.set(11,E.Codicon.symbolOperator),l.set(12,E.Codicon.symbolUnit),l.set(13,E.Codicon.symbolValue),l.set(15,E.Codicon.symbolEnum),l.set(14,E.Codicon.symbolConstant),l.set(15,E.Codicon.symbolEnum),l.set(16,E.Codicon.symbolEnumMember),l.set(17,E.Codicon.symbolKeyword),l.set(27,E.Codicon.symbolSnippet),l.set(18,E.Codicon.symbolText),l.set(19,E.Codicon.symbolColor),l.set(20,E.Codicon.symbolFile),l.set(21,E.Codicon.symbolReference),l.set(22,E.Codicon.symbolCustomColor),l.set(23,E.Codicon.symbolFolder),l.set(24,E.Codicon.symbolTypeParameter),l.set(25,E.Codicon.account),l.set(26,E.Codicon.issues);function _(A){let N=l.get(A);return N||(console.info("No codicon found for CompletionItemKind "+A),N=E.Codicon.symbolProperty),N}o.toIcon=_;const b=new Map;b.set("method",0),b.set("function",1),b.set("constructor",2),b.set("field",3),b.set("variable",4),b.set("class",5),b.set("struct",6),b.set("interface",7),b.set("module",8),b.set("property",9),b.set("event",10),b.set("operator",11),b.set("unit",12),b.set("value",13),b.set("constant",14),b.set("enum",15),b.set("enum-member",16),b.set("enumMember",16),b.set("keyword",17),b.set("snippet",27),b.set("text",18),b.set("color",19),b.set("file",20),b.set("reference",21),b.set("customcolor",22),b.set("folder",23),b.set("type-parameter",24),b.set("typeParameter",24),b.set("account",25),b.set("issue",26);function C(A,N){let D=b.get(A);return typeof D>"u"&&!N&&(D=9),D}o.fromString=C})(v||(n.CompletionItemKinds=v={}));var e;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(e||(n.InlineCompletionTriggerKind=e={}));class m{constructor(l,_,b,C){this.range=l,this.text=_,this.completionKind=b,this.isSnippetText=C}equals(l){return i.Range.lift(this.range).equalsRange(l.range)&&this.text===l.text&&this.completionKind===l.completionKind&&this.isSnippetText===l.isSnippetText}}n.SelectedSuggestionInfo=m;var c;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(c||(n.SignatureHelpTriggerKind=c={}));var h;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(h||(n.DocumentHighlightKind=h={}));function p(o){return o&&M.URI.isUri(o.uri)&&i.Range.isIRange(o.range)&&(i.Range.isIRange(o.originSelectionRange)||i.Range.isIRange(o.targetSelectionRange))}n.isLocationLink=p,n.symbolKindNames={[17]:(0,d.localize)(0,null),[16]:(0,d.localize)(1,null),[4]:(0,d.localize)(2,null),[13]:(0,d.localize)(3,null),[8]:(0,d.localize)(4,null),[9]:(0,d.localize)(5,null),[21]:(0,d.localize)(6,null),[23]:(0,d.localize)(7,null),[7]:(0,d.localize)(8,null),[0]:(0,d.localize)(9,null),[11]:(0,d.localize)(10,null),[10]:(0,d.localize)(11,null),[19]:(0,d.localize)(12,null),[5]:(0,d.localize)(13,null),[1]:(0,d.localize)(14,null),[2]:(0,d.localize)(15,null),[20]:(0,d.localize)(16,null),[15]:(0,d.localize)(17,null),[18]:(0,d.localize)(18,null),[24]:(0,d.localize)(19,null),[3]:(0,d.localize)(20,null),[6]:(0,d.localize)(21,null),[14]:(0,d.localize)(22,null),[22]:(0,d.localize)(23,null),[25]:(0,d.localize)(24,null),[12]:(0,d.localize)(25,null)};function f(o,l){return(0,d.localize)(26,null,o,n.symbolKindNames[l])}n.getAriaLabelForSymbol=f;var y;(function(o){const l=new Map;l.set(0,E.Codicon.symbolFile),l.set(1,E.Codicon.symbolModule),l.set(2,E.Codicon.symbolNamespace),l.set(3,E.Codicon.symbolPackage),l.set(4,E.Codicon.symbolClass),l.set(5,E.Codicon.symbolMethod),l.set(6,E.Codicon.symbolProperty),l.set(7,E.Codicon.symbolField),l.set(8,E.Codicon.symbolConstructor),l.set(9,E.Codicon.symbolEnum),l.set(10,E.Codicon.symbolInterface),l.set(11,E.Codicon.symbolFunction),l.set(12,E.Codicon.symbolVariable),l.set(13,E.Codicon.symbolConstant),l.set(14,E.Codicon.symbolString),l.set(15,E.Codicon.symbolNumber),l.set(16,E.Codicon.symbolBoolean),l.set(17,E.Codicon.symbolArray),l.set(18,E.Codicon.symbolObject),l.set(19,E.Codicon.symbolKey),l.set(20,E.Codicon.symbolNull),l.set(21,E.Codicon.symbolEnumMember),l.set(22,E.Codicon.symbolStruct),l.set(23,E.Codicon.symbolEvent),l.set(24,E.Codicon.symbolOperator),l.set(25,E.Codicon.symbolTypeParameter);function _(b){let C=l.get(b);return C||(console.info("No codicon found for SymbolKind "+b),C=E.Codicon.symbolProperty),C}o.toIcon=_})(y||(n.SymbolKinds=y={}));class w{}n.TextEdit=w;class R{static fromValue(l){switch(l){case"comment":return R.Comment;case"imports":return R.Imports;case"region":return R.Region}return new R(l)}constructor(l){this.value=l}}n.FoldingRangeKind=R,R.Comment=new R("comment"),R.Imports=new R("imports"),R.Region=new R("region");var S;(function(o){function l(_){return!_||typeof _!="object"?!1:typeof _.id=="string"&&typeof _.title=="string"}o.is=l})(S||(n.Command=S={}));var L;(function(o){o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(L||(n.InlayHintKind=L={}));class r{constructor(l){this.createSupport=l,this._tokenizationSupport=null}dispose(){this._tokenizationSupport&&this._tokenizationSupport.then(l=>{l&&l.dispose()})}get tokenizationSupport(){return this._tokenizationSupport||(this._tokenizationSupport=this.createSupport()),this._tokenizationSupport}}n.LazyTokenizationSupport=r,n.TokenizationRegistry=new u.TokenizationRegistry}),ne(ie[61],re([0,1,33,7,31,14,3,2,36,60,53]),function(O,n,E,M,i,u,d,g,a,s,v){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.createMonacoBaseAPI=n.KeyMod=void 0;class e{static chord(h,p){return(0,i.KeyChord)(h,p)}}n.KeyMod=e,e.CtrlCmd=2048,e.Shift=1024,e.Alt=512,e.WinCtrl=256;function m(){return{editor:void 0,languages:void 0,CancellationTokenSource:E.CancellationTokenSource,Emitter:M.Emitter,KeyCode:v.KeyCode,KeyMod:e,Position:d.Position,Range:g.Range,Selection:a.Selection,SelectionDirection:v.SelectionDirection,MarkerSeverity:v.MarkerSeverity,MarkerTag:v.MarkerTag,Uri:u.URI,Token:s.Token}}n.createMonacoBaseAPI=m}),ne(ie[63],re([0,1,21,14,3,2,50,25,46,47,61,20,52,44,11,45]),function(O,n,E,M,i,u,d,g,a,s,v,e,m,c,h,p){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.create=n.EditorSimpleWorker=void 0;class f extends d.MirrorTextModel{get uri(){return this._uri}get eol(){return this._eol}getValue(){return this.getText()}findMatches(S){const L=[];for(let r=0;r<this._lines.length;r++){const o=this._lines[r],l=this.offsetAt(new i.Position(r+1,1)),_=o.matchAll(S);for(const b of _)(b.index||b.index===0)&&(b.index=b.index+l),L.push(b)}return L}getLinesContent(){return this._lines.slice(0)}getLineCount(){return this._lines.length}getLineContent(S){return this._lines[S-1]}getWordAtPosition(S,L){const r=(0,g.getWordAtText)(S.column,(0,g.ensureValidWordDefinition)(L),this._lines[S.lineNumber-1],0);return r?new u.Range(S.lineNumber,r.startColumn,S.lineNumber,r.endColumn):null}words(S){const L=this._lines,r=this._wordenize.bind(this);let o=0,l="",_=0,b=[];return{*[Symbol.iterator](){for(;;)if(_<b.length){const C=l.substring(b[_].start,b[_].end);_+=1,yield C}else if(o<L.length)l=L[o],b=r(l,S),_=0,o+=1;else break}}}getLineWords(S,L){const r=this._lines[S-1],o=this._wordenize(r,L),l=[];for(const _ of o)l.push({word:r.substring(_.start,_.end),startColumn:_.start+1,endColumn:_.end+1});return l}_wordenize(S,L){const r=[];let o;for(L.lastIndex=0;(o=L.exec(S))&&o[0].length!==0;)r.push({start:o.index,end:o.index+o[0].length});return r}getValueInRange(S){if(S=this._validateRange(S),S.startLineNumber===S.endLineNumber)return this._lines[S.startLineNumber-1].substring(S.startColumn-1,S.endColumn-1);const L=this._eol,r=S.startLineNumber-1,o=S.endLineNumber-1,l=[];l.push(this._lines[r].substring(S.startColumn-1));for(let _=r+1;_<o;_++)l.push(this._lines[_]);return l.push(this._lines[o].substring(0,S.endColumn-1)),l.join(L)}offsetAt(S){return S=this._validatePosition(S),this._ensureLineStarts(),this._lineStarts.getPrefixSum(S.lineNumber-2)+(S.column-1)}positionAt(S){S=Math.floor(S),S=Math.max(0,S),this._ensureLineStarts();const L=this._lineStarts.getIndexOf(S),r=this._lines[L.index].length;return{lineNumber:1+L.index,column:1+Math.min(L.remainder,r)}}_validateRange(S){const L=this._validatePosition({lineNumber:S.startLineNumber,column:S.startColumn}),r=this._validatePosition({lineNumber:S.endLineNumber,column:S.endColumn});return L.lineNumber!==S.startLineNumber||L.column!==S.startColumn||r.lineNumber!==S.endLineNumber||r.column!==S.endColumn?{startLineNumber:L.lineNumber,startColumn:L.column,endLineNumber:r.lineNumber,endColumn:r.column}:S}_validatePosition(S){if(!i.Position.isIPosition(S))throw new Error("bad position");let{lineNumber:L,column:r}=S,o=!1;if(L<1)L=1,r=1,o=!0;else if(L>this._lines.length)L=this._lines.length,r=this._lines[L-1].length+1,o=!0;else{const l=this._lines[L-1].length+1;r<1?(r=1,o=!0):r>l&&(r=l,o=!0)}return o?{lineNumber:L,column:r}:S}}class y{constructor(S,L){this._host=S,this._models=Object.create(null),this._foreignModuleFactory=L,this._foreignModule=null}dispose(){this._models=Object.create(null)}_getModel(S){return this._models[S]}_getModels(){const S=[];return Object.keys(this._models).forEach(L=>S.push(this._models[L])),S}acceptNewModel(S){this._models[S.url]=new f(M.URI.parse(S.url),S.lines,S.EOL,S.versionId)}acceptModelChanged(S,L){if(!this._models[S])return;this._models[S].onEvents(L)}acceptRemovedModel(S){this._models[S]&&delete this._models[S]}computeUnicodeHighlights(S,L,r){return pe(this,void 0,void 0,function*(){const o=this._getModel(S);return o?m.UnicodeTextModelHighlighter.computeUnicodeHighlights(o,L,r):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}})}computeDiff(S,L,r,o){return pe(this,void 0,void 0,function*(){const l=this._getModel(S),_=this._getModel(L);return!l||!_?null:y.computeDiff(l,_,r,o)})}static computeDiff(S,L,r,o){const l=o==="advanced"?c.linesDiffComputers.getAdvanced():c.linesDiffComputers.getLegacy(),_=S.getLinesContent(),b=L.getLinesContent(),C=l.computeDiff(_,b,r),A=C.changes.length>0?!1:this._modelsAreIdentical(S,L);function N(D){return D.map(x=>{var W;return[x.originalRange.startLineNumber,x.originalRange.endLineNumberExclusive,x.modifiedRange.startLineNumber,x.modifiedRange.endLineNumberExclusive,(W=x.innerChanges)===null||W===void 0?void 0:W.map(I=>[I.originalRange.startLineNumber,I.originalRange.startColumn,I.originalRange.endLineNumber,I.originalRange.endColumn,I.modifiedRange.startLineNumber,I.modifiedRange.startColumn,I.modifiedRange.endLineNumber,I.modifiedRange.endColumn])]})}return{identical:A,quitEarly:C.hitTimeout,changes:N(C.changes),moves:C.moves.map(D=>[D.lineRangeMapping.original.startLineNumber,D.lineRangeMapping.original.endLineNumberExclusive,D.lineRangeMapping.modified.startLineNumber,D.lineRangeMapping.modified.endLineNumberExclusive,N(D.changes)])}}static _modelsAreIdentical(S,L){const r=S.getLineCount(),o=L.getLineCount();if(r!==o)return!1;for(let l=1;l<=r;l++){const _=S.getLineContent(l),b=L.getLineContent(l);if(_!==b)return!1}return!0}computeMoreMinimalEdits(S,L,r){return pe(this,void 0,void 0,function*(){const o=this._getModel(S);if(!o)return L;const l=[];let _;L=L.slice(0).sort((b,C)=>{if(b.range&&C.range)return u.Range.compareRangesUsingStarts(b.range,C.range);const A=b.range?0:1,N=C.range?0:1;return A-N});for(let{range:b,text:C,eol:A}of L){if(typeof A=="number"&&(_=A),u.Range.isEmpty(b)&&!C)continue;const N=o.getValueInRange(b);if(C=C.replace(/\r\n|\n|\r/g,o.eol),N===C)continue;if(Math.max(C.length,N.length)>y._diffLimit){l.push({range:b,text:C});continue}const D=(0,E.stringDiff)(N,C,r),x=o.offsetAt(u.Range.lift(b).getStartPosition());for(const W of D){const I=o.positionAt(x+W.originalStart),k=o.positionAt(x+W.originalStart+W.originalLength),P={text:C.substr(W.modifiedStart,W.modifiedLength),range:{startLineNumber:I.lineNumber,startColumn:I.column,endLineNumber:k.lineNumber,endColumn:k.column}};o.getValueInRange(P.range)!==P.text&&l.push(P)}}return typeof _=="number"&&l.push({eol:_,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),l})}computeLinks(S){return pe(this,void 0,void 0,function*(){const L=this._getModel(S);return L?(0,a.computeLinks)(L):null})}computeDefaultDocumentColors(S){return pe(this,void 0,void 0,function*(){const L=this._getModel(S);return L?(0,p.computeDefaultDocumentColors)(L):null})}textualSuggest(S,L,r,o){return pe(this,void 0,void 0,function*(){const l=new e.StopWatch,_=new RegExp(r,o),b=new Set;e:for(const C of S){const A=this._getModel(C);if(A){for(const N of A.words(_))if(!(N===L||!isNaN(Number(N)))&&(b.add(N),b.size>y._suggestionsLimit))break e}}return{words:Array.from(b),duration:l.elapsed()}})}computeWordRanges(S,L,r,o){return pe(this,void 0,void 0,function*(){const l=this._getModel(S);if(!l)return Object.create(null);const _=new RegExp(r,o),b=Object.create(null);for(let C=L.startLineNumber;C<L.endLineNumber;C++){const A=l.getLineWords(C,_);for(const N of A){if(!isNaN(Number(N.word)))continue;let D=b[N.word];D||(D=[],b[N.word]=D),D.push({startLineNumber:C,startColumn:N.startColumn,endLineNumber:C,endColumn:N.endColumn})}}return b})}navigateValueSet(S,L,r,o,l){return pe(this,void 0,void 0,function*(){const _=this._getModel(S);if(!_)return null;const b=new RegExp(o,l);L.startColumn===L.endColumn&&(L={startLineNumber:L.startLineNumber,startColumn:L.startColumn,endLineNumber:L.endLineNumber,endColumn:L.endColumn+1});const C=_.getValueInRange(L),A=_.getWordAtPosition({lineNumber:L.startLineNumber,column:L.startColumn},b);if(!A)return null;const N=_.getValueInRange(A);return s.BasicInplaceReplace.INSTANCE.navigateValueSet(L,C,A,N,r)})}loadForeignModule(S,L,r){const o=(b,C)=>this._host.fhr(b,C),_={host:(0,h.createProxyObject)(r,o),getMirrorModels:()=>this._getModels()};return this._foreignModuleFactory?(this._foreignModule=this._foreignModuleFactory(_,L),Promise.resolve((0,h.getAllMethodNames)(this._foreignModule))):new Promise((b,C)=>{O([S],A=>{this._foreignModule=A.create(_,L),b((0,h.getAllMethodNames)(this._foreignModule))},C)})}fmr(S,L){if(!this._foreignModule||typeof this._foreignModule[S]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+S));try{return Promise.resolve(this._foreignModule[S].apply(this._foreignModule,L))}catch(r){return Promise.reject(r)}}}n.EditorSimpleWorker=y,y._diffLimit=1e5,y._suggestionsLimit=1e4;function w(R){return new y(R,null)}n.create=w,typeof importScripts=="function"&&(globalThis.monaco=(0,v.createMonacoBaseAPI)())})}).call(this);

//# sourceMappingURL=../../../../min-maps/vs/base/worker/workerMain.js.map